use strict;

our (%FXcfg, %FXflags, %FXbot, %FXserv, %FXirc, %FXim, %FXsock, %FXstats, $ts);

sub add_channel {
  my ($channel, $time, $mode) = (shift, shift, shift);

  $FXirc{'channel'}{lc($channel)}{'channel'} = $channel;
  $FXirc{'channel'}{lc($channel)}{'time'} = $time;
  $FXirc{'channel'}{lc($channel)}{'current'} = 0;
  $FXirc{'channel'}{lc($channel)}{'max'} = 0;
  $FXirc{'channel'}{lc($channel)}{'max_ts'} = 0;
  $FXirc{'channel'}{lc($channel)}{'topic'}{'string'} = "";
  $FXirc{'channel'}{lc($channel)}{'topic'}{'author'} = "";
  $FXirc{'channel'}{lc($channel)}{'topic'}{'set'} = 0;
  $FXirc{'channel'}{lc($channel)}{'mode'} = $mode;
  $FXirc{'channel'}{lc($channel)}{'names'} = ();
  $FXirc{'channel'}{lc($channel)}{'banlist'} = ();
  $FXirc{'channel'}{lc($channel)}{'geclist'} = ();
  $FXirc{'channel'}{lc($channel)}{'exclist'} = ();
  $FXirc{'channel'}{lc($channel)}{'invlist'} = ();

  if (++$FXstats{'channels'}{'current'} > $FXstats{'channels'}{'max'}) {
    $FXstats{'channels'}{'max'} = $FXstats{'channels'}{'current'};
    $FXstats{'channels'}{'max_ts'} = $ts;
    if ($FXserv{'connected'} && !$FXserv{'netmerge'}) { &putinfo("x", "New max channel count: %d", $FXstats{'channels'}{'current'}); }
  }

  return(0);
}

sub del_channel {
  my ($channel, $nick) = (shift, shift);

  if ($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}) {
    delete($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)});
    --$FXirc{'channel'}{lc($channel)}{'current'};
  }

  if (!scalar(keys(%{$FXirc{'channel'}{lc($channel)}{'names'}}))) {
    delete($FXirc{'channel'}{lc($channel)});
    --$FXstats{'channels'}{'current'};
  }

  return(0);
}

sub check_channel {
  my $service = shift;
  my $nick = $FXbot{$service}{'nick'};
  my $list = "";

  if ($FXbot{$service}{'enabled'}) {
    foreach (keys(%{$FXbot{$service}{'channel'}})) {
      my $channel = $FXbot{$service}{'channel'}{$_}{'channel'};

      if ($FXirc{'channel'}{lc($channel)} && $FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}) {
        if ((($FXbot{$service}{'channel'}{lc($channel)}{'mode'} eq "o") && ($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'o'})) ||
            (($FXbot{$service}{'channel'}{lc($channel)}{'mode'} eq "h") && ($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'h'})) ||
            (($FXbot{$service}{'channel'}{lc($channel)}{'mode'} eq "v") && ($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'v'})) ||
            (($FXbot{$service}{'channel'}{lc($channel)}{'mode'} eq "") && ($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} eq ""))) {
          next;
        } else {
          &service_part($service, $channel);
        }
      }

      &service_join($service, $channel);
      $list .= $channel . " ";
    }

    if ($list) {
      $list =~ s/\s+$//;
      &putinfo("y", "%s: now monitoring %s", $nick, $list);
      $list = "";
    }

    foreach (keys(%{$FXirc{'channel'}})) {
      my $channel = $FXirc{'channel'}{$_}{'channel'};

      if ($FXirc{'channel'}{$_}{'names'}{lc($nick)} && !$FXbot{$service}{'channel'}{lc($channel)}) {
        &service_part($service, $channel);
        $list .= $channel . " ";
      }
    }

    if ($list) {
      $list =~ s/\s+$//;
      &putinfo("y", "%s: no longer monitoring %s", $nick, $list);
      $list = "";
    }
  } else {
    foreach (keys(%{$FXirc{'channel'}})) {
      if ($FXirc{'channel'}{$_}{'names'}{lc($nick)}) {
        &service_part($service, $FXirc{'channel'}{$_}{'channel'});
        $list .= $FXirc{'channel'}{$_}{'channel'} . " ";
      }
    }

    if ($list) {
      $list =~ s/\s+$//;
      &putinfo("y", "%s: no longer monitoring %s", $nick, $list);
      $list = "";
    }
  }

  return(0);
}

sub channel_mode {
  my ($nick, $channel, $modes, $args) = (shift, shift, shift, shift);
  my $what = 1;
  my $idx = 0;
  my $check = 0;
  my $author = "";
  my @arg = ();

  foreach (split(/ /, $args)) { push(@arg, $_); }

  if ($FXirc{'client'}{lc($nick)}) {
    $author = $FXirc{'client'}{lc($nick)}{'nick'} . "!" . $FXirc{'client'}{lc($nick)}{'user'} . "\@" . $FXirc{'client'}{lc($nick)}{'host'};
  } elsif ($FXirc{'server'}{lc($nick)}) {
    $author = $FXirc{'server'}{lc($nick)}{'name'};
  }

  foreach my $mode (split(//, $modes)) {
    if ($mode eq "+") {
      $what = 1;
    } elsif ($mode eq "-") {
      $what = 0;
    } else {
      if (($mode eq "o") || ($mode eq "h") || ($mode eq "v")) {
        foreach my $service (keys(%FXbot)) {
          if (lc($FXbot{$service}{'nick'}) eq lc($arg[$idx])) { $check = 1; }
        }

        if ($what) {
          $FXirc{'channel'}{lc($channel)}{'names'}{lc($arg[$idx])}{'mode'} |= $FXflags{'channel'}{$mode};
        } else {
          $FXirc{'channel'}{lc($channel)}{'names'}{lc($arg[$idx])}{'mode'} &= ~$FXflags{'channel'}{$mode};
        }
        ++$idx;
      } elsif ($mode eq "b") {
        if ($what) {
          $FXirc{'channel'}{lc($channel)}{'banlist'}{lc($arg[$idx])}{'mask'} = $arg[$idx];
          $FXirc{'channel'}{lc($channel)}{'banlist'}{lc($arg[$idx])}{'author'} = $author;
          $FXirc{'channel'}{lc($channel)}{'banlist'}{lc($arg[$idx])}{'ts'} = $ts;
        } else {
          if ($FXirc{'channel'}{lc($channel)}{'banlist'} && $FXirc{'channel'}{lc($channel)}{'banlist'}{lc($arg[$idx])}) { delete($FXirc{'channel'}{lc($channel)}{'banlist'}{lc($arg[$idx])}); }
        }
        ++$idx;
      } elsif ($mode eq "d") {
        if ($what) {
          $FXirc{'channel'}{lc($channel)}{'geclist'}{lc($arg[$idx])}{'mask'} = $arg[$idx];
          $FXirc{'channel'}{lc($channel)}{'geclist'}{lc($arg[$idx])}{'author'} = $author;
          $FXirc{'channel'}{lc($channel)}{'geclist'}{lc($arg[$idx])}{'ts'} = $ts;
        } else {
          if ($FXirc{'channel'}{lc($channel)}{'geclist'} && $FXirc{'channel'}{lc($channel)}{'geclist'}{lc($arg[$idx])}) { delete($FXirc{'channel'}{lc($channel)}{'geclist'}{lc($arg[$idx])}); }
        }
        ++$idx;
      } elsif ($mode eq "e") {
        if ($what) {
          $FXirc{'channel'}{lc($channel)}{'exclist'}{lc($arg[$idx])}{'mask'} = $arg[$idx];
          $FXirc{'channel'}{lc($channel)}{'exclist'}{lc($arg[$idx])}{'author'} = $author;
          $FXirc{'channel'}{lc($channel)}{'exclist'}{lc($arg[$idx])}{'ts'} = $ts;
        } else {
          if ($FXirc{'channel'}{lc($channel)}{'exclist'} && $FXirc{'channel'}{lc($channel)}{'exclist'}{lc($arg[$idx])}) { delete($FXirc{'channel'}{lc($channel)}{'exclist'}{lc($arg[$idx])}); }
        }
      } elsif ($mode eq "I") {
        if ($what) {
          $FXirc{'channel'}{lc($channel)}{'invlist'}{lc($arg[$idx])}{'mask'} = $arg[$idx];
          $FXirc{'channel'}{lc($channel)}{'invlist'}{lc($arg[$idx])}{'author'} = $author;
          $FXirc{'channel'}{lc($channel)}{'invlist'}{lc($arg[$idx])}{'ts'} = $ts;
        } else {
          if ($FXirc{'channel'}{lc($channel)}{'invlist'} && $FXirc{'channel'}{lc($channel)}{'invlist'}{lc($arg[$idx])}) { delete($FXirc{'channel'}{lc($channel)}{'invlist'}{lc($arg[$idx])}); }
        }
        ++$idx;
      } elsif (($mode =~ /[aqfklL]/) && !(($mode eq "l") && !$what)) {
        if ($mode =~ /[kl]/) {
          if ($what) {
            $FXirc{'channel'}{lc($channel)}{'mode'} |= $FXflags{'channel'}{$mode};
          } else {
            $FXirc{'channel'}{lc($channel)}{'mode'} &= ~$FXflags{'channel'}{$mode};
          }
        }
        ++$idx;
      } else {
        if ($mode =~ /[cilmnprst]/) {
          if ($what) {
            $FXirc{'channel'}{lc($channel)}{'mode'} |= $FXflags{'channel'}{$mode};
          } else {
            $FXirc{'channel'}{lc($channel)}{'mode'} &= ~$FXflags{'channel'}{$mode};
          }
        }
      }
    }
  }

  if ($check) {
    foreach (keys(%FXbot)) {
      if (!$FXbot{$_}{'enabled'}) { next; }
      my $service = $FXbot{$_}{'service'};
      my $nick = $FXbot{$_}{'nick'};

      if ($FXbot{$_}{'channel'}{lc($channel)}) {
        if ((($FXbot{$_}{'channel'}{lc($channel)}{'mode'} eq "o") && !($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'o'})) ||
            (($FXbot{$_}{'channel'}{lc($channel)}{'mode'} eq "h") && !($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'h'})) ||
            (($FXbot{$_}{'channel'}{lc($channel)}{'mode'} eq "v") && !($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'v'}))) {
          &service_part($service, $FXirc{'channel'}{lc($channel)}{'channel'});
          &service_join($service, $FXirc{'channel'}{lc($channel)}{'channel'});
          &putinfo("y", "%s: %s attempted to change %s's mode", $FXirc{'channel'}{lc($channel)}{'channel'}, $author, $nick);
        }
      }
    }
  }

  return(0);
}

sub service_part {
  my ($service, $channel) = (shift, shift);
  my $nick = $FXbot{$service}{'nick'};

  &putsock($FXsock{'irc'}, ":%s PART %s", $nick, $FXirc{'channel'}{lc($channel)}{'channel'});

  &add_seen($nick, "PART", $channel);
  &chanlog("p", $channel, $nick, undef, undef);

  delete($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)});
  &del_channel($channel);

  return(0);
}

sub service_join {
  my ($service, $channel) = (shift, shift);
  my $nick = $FXbot{$service}{'nick'};
  my $channel_ts = $ts;
  my $channel_mode = "";
  my $mode = '';
  my $power = "";
  my $prefix = "";

  if ($FXirc{'channel'}{lc($channel)}) {
    $channel_ts = $FXirc{'channel'}{lc($channel)}{'time'};
  } else {
    $mode |= $FXflags{'channel'}{'n'};
    $mode |= $FXflags{'channel'}{'t'};
    $channel_mode = "nt";
    $channel_ts = $ts;
    &add_channel($channel, $ts, $mode);
  }

  $FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'nick'} = $nick;
  $FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} = '';

  if (++$FXirc{'channel'}{lc($channel)}{'current'} > $FXirc{'channel'}{lc($channel)}{'max'}) {
    $FXirc{'channel'}{lc($channel)}{'max'} = $FXirc{'channel'}{lc($channel)}{'current'};
    $FXirc{'channel'}{lc($channel)}{'max_ts'} = $ts;
  }

  if ($FXbot{$service}{'channel'}{lc($channel)}{'mode'} eq "o") {
    $FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} |= $FXflags{'channel'}{'o'};
    $prefix = "\@";
    $power = "+o";
  } elsif ($FXbot{$service}{'channel'}{lc($channel)}{'mode'} eq "h") {
    $FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} |= $FXflags{'channel'}{'h'};
    $prefix = "\%";
    $power = "+h";
  } elsif ($FXbot{$service}{'channel'}{lc($channel)}{'mode'} eq "v") {
    $FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} |= $FXflags{'channel'}{'v'};
    $prefix = "+";
    $power = "+v";
  }

  if ($FXcfg{'general'}{'fightfix'}) {
    &putsock($FXsock{'irc'}, ":%s SJOIN %d %s +%s :%s", $FXserv{'name'}, $channel_ts, $channel, $channel_mode, $nick);
  } else {
    &putsock($FXsock{'irc'}, ":%s SJOIN %d %s +%s :%s%s", $FXserv{'name'}, $channel_ts, $channel, $channel_mode, $prefix, $nick);
  }

  &add_seen($nick, "JOIN", $channel);
  &chanlog("j", $channel, $nick, undef, undef);

  if ($power) {
    if ($FXcfg{'general'}{'fightfix'}) {
      &putsock($FXsock{'irc'}, ":%s MODE %s %s %s", $nick, $channel, $power, $nick);
      &chanlog("m", $channel, $nick, $power, $nick);
    } else {
      &chanlog("m", $channel, $FXserv{'name'}, $power, $nick);
    }
  }

  return(0);
}

sub process_channel {
  my ($nick, $channel, $query) = (shift, shift, shift);
  my $arg = (split(/ /, $query, 2))[1];

  foreach (keys(%FXbot)) {
    if (!$FXbot{$_}{'enabled'}) { next; }

    if ($FXbot{$_}{'channel'} && $FXbot{$_}{'channel'}{lc($channel)} && $FXbot{$_}{'channel'}{lc($channel)}{'public'}) {
      my ($cmd) = $query =~ /^$FXbot{$_}{'channel'}{lc($channel)}{'prefix'}(\S+)/;

      if ($FXbot{$_}{'service'} eq "DataServ") {
        if ($FXbot{$_}{'channel_sub'}->{uc($cmd)}) {
          if (&check_flood($nick)) { return(0); }
          &{$FXbot{$_}{'channel_sub'}->{uc($cmd)}}($nick, $channel, $cmd, $query);
          last;
        }
      }

      if ($FXbot{$_}{'public_sub'}->{uc($cmd)}) {
        if (&check_flood($nick)) { return(0); }
        &{$FXbot{$_}{'public_sub'}->{uc($cmd)}}($nick, $arg);
        last;
      }
    }
  }

  if ($FXbot{'PageServ'}{'enabled'}) {
    my $im_text = {
      'msn'    => \&msn_text,
      'yahoo'  => \&yahoo_text,
      'icq'    => \&icq_text,
      'aim'    => \&aim_text,
      'jabber' => \&jabber_text
    };

    foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
      if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }

      foreach my $session (keys(%{$FXim{$im}{'board'}})) {
        if (lc($FXim{$im}{'board'}{$session}{'channel'}) eq lc($channel)) {
          $FXim{$im}{'board'}{$session}{'last'} = $ts;

          my $text = "";
          if ($query =~ /\cAACTION (.*)\cA/i) {
            $text = "* " . $nick . " " . $1;
          } else {
            $text = "<" . $nick . "> " . $query;
          }

          &{$im_text->{$im}}($FXim{$im}{'board'}{$session}{'id'}, $text);
          last;
        }
      }
    }

    return(0);

  }

  return(0);
}

1;