use strict;

our (%FXserv, %FXflags, %FXirc, %FXim, %FXsock, %FXbot, %FXboard, %FXcfg, %FXmsg, %FXstats, %FXscan, %FXfserv, %FXrcon, $ts);

sub add_client {
  my ($nick, $user, $host, $info, $numeric, $server, $time, $mode) = (shift, shift, shift, shift, shift, shift, shift, shift);
  my @split = split(/\./, $host);
  my $suffix = $split[$#split];
  my $domain = $split[$#split - 1] . "." . $suffix;

  $FXirc{'client'}{lc($nick)}{'nick'} = $nick;
  $FXirc{'client'}{lc($nick)}{'user'} = $user;
  $FXirc{'client'}{lc($nick)}{'host'} = $host;
  $FXirc{'client'}{lc($nick)}{'info'} = $info;
  $FXirc{'client'}{lc($nick)}{'numeric'} = $numeric;
  $FXirc{'client'}{lc($nick)}{'server'} = $server;
  $FXirc{'client'}{lc($nick)}{'time'} = $time;
  $FXirc{'client'}{lc($nick)}{'mode'} = $mode;
  $FXirc{'client'}{lc($nick)}{'oper'} = "";
  $FXirc{'client'}{lc($nick)}{'lastcmd'} = 0;
  $FXirc{'client'}{lc($nick)}{'floodcnt'} = 0;
  $FXirc{'client'}{lc($nick)}{'ignored'} = 0;
  $FXirc{'client'}{lc($nick)}{'reply'} = "";

  if ($FXserv{'connected'} && !$FXserv{'netmerge'} && ($server ne $FXserv{'name'})) { &putinfo("C", "Client connection: %s!%s\@%s [%s]", $nick, $user, $host, $server); }

  if (++$FXstats{'clients'}{'current'} > $FXstats{'clients'}{'max'}) {
    $FXstats{'clients'}{'max'} = $FXstats{'clients'}{'current'};
    $FXstats{'clients'}{'max_ts'} = $ts;
    if ($FXserv{'connected'} && !$FXserv{'netmerge'} && ($server ne $FXserv{'name'})) { &putinfo("x", "New max client count: %d", $FXstats{'clients'}{'current'}); }
  }

  if (++$FXirc{'server'}{lc($server)}{'users'}{'current'} > $FXirc{'server'}{lc($server)}{'users'}{'max'}) {
    $FXirc{'server'}{lc($server)}{'users'}{'max'} = $FXirc{'server'}{lc($server)}{'users'}{'current'};
    $FXirc{'server'}{lc($server)}{'users'}{'max_ts'} = $ts;
  }

  if ($mode & $FXflags{'client'}{'o'}) {
    if ($FXserv{'connected'} && !$FXserv{'netmerge'} && ($server ne $FXserv{'name'})) { &putinfo("o", "New Operator: %s (%s\@%s) [%s]", $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'},  $FXirc{'client'}{lc($nick)}{'server'}); }

    if (++$FXstats{'opers'}{'current'} > $FXstats{'opers'}{'max'}) {
    if ($FXserv{'connected'} && !$FXserv{'netmerge'} && ($server ne $FXserv{'name'})) { &putinfo("x", "New max operator count: %d", $FXstats{'opers'}{'current'}); }
      $FXstats{'opers'}{'max'} = $FXstats{'opers'}{'current'};
      $FXstats{'opers'}{'max_ts'} = $ts;
    }

    if (++$FXirc{'server'}{lc($server)}{'opers'}{'current'} > $FXirc{'server'}{lc($server)}{'opers'}{'max'}) {
      $FXirc{'server'}{lc($server)}{'opers'}{'max'} = $FXirc{'server'}{lc($server)}{'opers'}{'current'};
      $FXirc{'server'}{lc($server)}{'opers'}{'max_ts'} = $ts;
    }
  }

  if ($suffix !~ /\d+/) {
    if (++$FXstats{'domain'}{lc($domain)}{'current'} > $FXstats{'domain'}{lc($domain)}{'max'}) {
      $FXstats{'domain'}{lc($domain)}{'max'} = $FXstats{'domain'}{lc($domain)}{'current'};
      $FXstats{'domain'}{lc($domain)}{'max_ts'} = $ts;
    }

    if (++$FXstats{'tld'}{lc($suffix)}{'current'} > $FXstats{'tld'}{lc($suffix)}{'max'}) {
      $FXstats{'tld'}{lc($suffix)}{'max'} = $FXstats{'tld'}{lc($suffix)}{'current'};
      $FXstats{'tld'}{lc($suffix)}{'max_ts'} = $ts;
    }
  } else {
    if (++$FXstats{'domain'}{'[unknown]'}{'current'} > $FXstats{'domain'}{'[unknown]'}{'max'}) {
      $FXstats{'domain'}{'[unknown]'}{'max'} = $FXstats{'domain'}{'[unknown]'}{'current'};
      $FXstats{'domain'}{'[unknown]'}{'max_ts'} = $ts;
    }
  }

  return(0);
}

sub rename_client {
  my ($oldnick, $newnick) = (shift, shift);

  if (lc($newnick) ne lc($oldnick)) {
    $FXirc{'client'}{lc($newnick)} = $FXirc{'client'}{lc($oldnick)};
    $FXirc{'client'}{lc($newnick)}{'nick'} = $newnick;

    foreach (keys(%{$FXirc{'channel'}})) {
      if ($FXirc{'channel'}{$_}{'names'}{lc($oldnick)}) {
        $FXirc{'channel'}{$_}{'names'}{lc($newnick)} = $FXirc{'channel'}{$_}{'names'}{lc($oldnick)};
        delete($FXirc{'channel'}{$_}{'names'}{lc($oldnick)});
        $FXirc{'channel'}{$_}{'names'}{lc($newnick)}{'nick'} = $newnick;
      }
    }

    delete($FXirc{'client'}{lc($oldnick)});
  } else {
    $FXirc{'client'}{lc($oldnick)}{'nick'} = $newnick;

    foreach (keys(%{$FXirc{'channel'}})) {
      if ($FXirc{'channel'}{$_}{'names'}{lc($oldnick)}) { $FXirc{'channel'}{$_}{'names'}{lc($oldnick)}{'nick'} = $newnick; }
    }
  }

  if ($FXbot{'PageServ'}{'enabled'}) {
    my $im_text = {
      'msn'    => \&msn_text,
      'yahoo'  => \&yahoo_text,
      'icq'    => \&icq_text,
      'aim'    => \&aim_text,
      'jabber' => \&jabber_text
    };

    foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
      if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }

      foreach my $session (keys(%{$FXim{$im}{'board'}})) {
        my $cnt = 0;

        foreach my $user (@{$FXim{$im}{'board'}{$session}{'nick'}}) {
          if (lc($user) eq lc($oldnick)) {
            splice(@{$FXim{$im}{'board'}{$session}{'nick'}}, $cnt, 1, $newnick);
            &{$im_text->{$im}}($FXim{$im}{'board'}{$session}{'id'}, $FXmsg{'buddy_nick'}, $user, $newnick);
            last;
          }

          $cnt++;
        }
      }

      foreach my $trid (keys(%{$FXboard{$im}})) {
        my $cnt = 0;
        foreach my $user (@{$FXboard{$im}{$trid}{'nick'}}) {
          if (lc($user) eq lc($oldnick)) {
            splice(@{$FXboard{$im}{$trid}{'nick'}}, $cnt, 1, $newnick);
            last;
          }

          $cnt++;
        }
      }
    }
  }

  if ($FXbot{'ScanServ'}{'enabled'}) {
    foreach my $id (keys(%{$FXscan{'scan'}})) {
      if (lc($oldnick) eq lc($FXscan{'scan'}{$id}{'nick'})) {
        $FXscan{'scan'}{$id}{'nick'} = $newnick;
        last;
      }
    }

    foreach my $id (keys(%{$FXscan{'query'}})) {
      if (lc($oldnick) eq lc($FXscan{'query'}{$id}{'nick'})) {
        $FXscan{'query'}{$id}{'nick'} = $newnick;
        last;
      }
    }
  }

  if ($FXbot{'FileServ'}{'enabled'}) {
    foreach (keys(%{$FXfserv{'list'}})) {
      if (lc($FXfserv{'list'}{$_}{'nick'}) eq lc($oldnick)) {
        $FXfserv{'list'}{$_}{'nick'} = $newnick;
        last;
      }
    }

    foreach (keys(%{$FXfserv{'query'}})) {
      if (lc($FXfserv{'query'}{$_}{'nick'}) eq lc($oldnick)) {
        $FXfserv{'query'}{lc($newnick)}{'nick'} = $newnick;
        $FXfserv{'query'}{lc($newnick)}{'time'} = $FXfserv{'query'}{$_}{'time'};
        delete($FXfserv{'query'}{$_});
        last;
      }
    }

    foreach (keys(%{$FXsock{'list'}})) {
      if (($FXsock{'list'}{$_}{'type'} eq "FSERV-G") && (lc($FXsock{'list'}{$_}{'nick'}) eq lc($oldnick))) {
        $FXsock{'list'}{$_}{'nick'} = $newnick;
        last;
      }
    }
  }

  if ($FXbot{'GameServ'}{'enabled'}) {
    foreach (keys(%{$FXrcon{'list'}})) {
      if (lc($FXrcon{'list'}{$_}{'nick'}) eq lc($oldnick)) {
        $FXrcon{'list'}{$_}{'nick'} = $newnick;
        last;
      }
    }

    foreach (keys(%{$FXrcon{'query'}})) {
      if (lc($FXrcon{'query'}{$_}{'nick'}) eq lc($oldnick)) {
        $FXrcon{'query'}{lc($newnick)}{'nick'} = $newnick;
        $FXrcon{'query'}{lc($newnick)}{'time'} = $FXrcon{'query'}{$_}{'time'};
        delete($FXrcon{'query'}{$_});
        last;
      }
    }
  }

  return(0);
}

sub del_client {
  my $nick = shift;
  my @split = split(/\./, $FXirc{'client'}{lc($nick)}{'host'});
  my $suffix = $split[$#split];
  my $domain = $split[$#split - 1] . "." . $suffix;
  my $server = $FXirc{'client'}{lc($nick)}{'server'};

  foreach my $channel (keys(%{$FXirc{'channel'}})) {
    if ($FXirc{'channel'}{$channel}{'names'}{lc($nick)}) {

      if ($FXbot{'PageServ'}{'enabled'}) {
        my $im_remsession = {
          'msn'    => \&msn_remsession,
          'yahoo'  => \&yahoo_remsession,
          'icq'    => \&icq_remsession,
          'aim'    => \&aim_remsession,
          'jabber' => \&jabber_remsession
        };

        foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
          if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }

          foreach my $session (keys(%{$FXim{$im}{'board'}})) {
            if (lc($channel) eq lc($FXim{$im}{'board'}{$session}{'channel'})) {
              foreach my $user (@{$FXim{$im}{'board'}{$session}{'nick'}}) {
                if (lc($nick) eq lc($user)) {
                  &{$im_remsession->{$im}}($session, $nick);
                  last;
                }
              }
            }
          }
        }
      }

      &del_channel($FXirc{'channel'}{$channel}{'channel'}, $nick);
    }
  }

  --$FXirc{'server'}{lc($server)}{'users'}{'current'};

  if ($FXirc{'client'}{lc($nick)}{'mode'} & $FXflags{'client'}{'o'}) {
    --$FXstats{'opers'}{'current'};
    --$FXirc{'server'}{lc($server)}{'opers'}{'current'};
  }

  if ($suffix !~ /\d+/) {
    --$FXstats{'tld'}{lc($suffix)}{'current'};
    --$FXstats{'domain'}{lc($domain)}{'current'};
  } else {
    --$FXstats{'domain'}{'[unknown]'}{'current'};
  }

  if ($FXirc{'client'}{lc($nick)}{'reply'}) {
    my $reply = $FXirc{'client'}{lc($nick)}{'reply'};
    if ($FXstats{'version'}{$reply}) { --$FXstats{'version'}{$reply}{'current'}; }
  }

  if ($FXbot{'FileServ'}{'enabled'}) {
    foreach (keys(%{$FXsock{'list'}})) {
      if (($FXsock{'list'}{$_}{'type'} eq "FSERV") && (lc($FXsock{'list'}{$_}{'nick'}) eq lc($nick))) {
        &putsock($FXsock{'list'}{$_}{'sock'}, "Sorry, you MUST stay on the IRC server");
        &del_socket($FXsock{'list'}{$_}{'sock'});
        last;
      }
    }

    foreach (keys(%{$FXfserv{'query'}})) {
      if (lc($FXfserv{'query'}{$_}{'nick'}) eq lc($nick)) {
        delete($FXfserv{'query'}{$_});
        last;
      }
    }
  }

  if ($FXbot{'GameServ'}{'enabled'}) {
    foreach (keys(%{$FXrcon{'query'}})) {
      if (lc($FXrcon{'query'}{$_}{'nick'}) eq lc($nick)) {
        delete($FXrcon{'query'}{$_});
        last;
      }
    }
  }

  if ($FXbot{'ScanServ'}{'enabled'}) {
    foreach my $id (keys(%{$FXscan{'scan'}})) {
      if (lc($nick) eq lc($FXscan{'scan'}{$id}{'nick'})) {
        &scan_del($nick, "scan");
        delete($FXscan{'scan'}{$id});
        last;
      }
    }

    foreach my $id (keys(%{$FXscan{'query'}})) {
      if (lc($nick) eq lc($FXscan{'query'}{$id}{'nick'})) {
        &scan_del($nick, "query");
        delete($FXscan{'query'}{$id});
        last;
      }
    }
  }

  delete($FXirc{'client'}{lc($nick)});
  --$FXstats{'clients'}{'current'};

  return(0);
}

sub add_seen {
  my ($nick, $action, $xtra) = (shift, shift, shift);

  my $host = $FXirc{'client'}{lc($nick)}{'host'};

  $FXirc{'seen'}{lc($nick)}{'nick'} = $FXirc{'client'}{lc($nick)}{'nick'};
  $FXirc{'seen'}{lc($nick)}{'time'} = $ts;
  $FXirc{'seen'}{lc($nick)}{'user'} = $FXirc{'client'}{lc($nick)}{'user'};
  $FXirc{'seen'}{lc($nick)}{'host'} = $host;
  $FXirc{'seen'}{lc($nick)}{'action'} = $action;
  $FXirc{'seen'}{lc($nick)}{'xtra'} = $xtra;

  if (scalar(keys(%{$FXirc{'seen'}})) > $FXbot{'DataServ'}{'seen_maxrecs'}) {
    my @seen = sort { $FXirc{'seen'}{$a}{'time'} <=> $FXirc{'seen'}{$b}{'time'} } keys(%{$FXirc{'seen'}});
    my $max = scalar(keys(%{$FXirc{'seen'}})) - $FXbot{'DataServ'}{'seen_maxrecs'};

    foreach (@seen) {
      if (!$max--) { last; }
      delete($FXirc{'seen'}{$_});
    }
  }

  return(0);
}

sub check_client {
  my $nick = shift;
  my $result = 0;

  foreach (keys(%{$FXirc{'exempt'}})) {
    my $usermask = (split(/\@/, $FXirc{'exempt'}{$_}{'mask'}, 0))[0]; my $umaskrx = &plain2regexp($usermask);
    my $hostmask = (split(/\@/, $FXirc{'exempt'}{$_}{'mask'}, 0))[1]; my $hmaskrx = &plain2regexp($hostmask);
    my $servmask = &plain2regexp($FXirc{'exempt'}{$_}{'server'});

    if (($FXirc{'client'}{lc($nick)}{'user'} =~ /^$umaskrx$/i) && ($FXirc{'client'}{lc($nick)}{'host'} =~ /^$hmaskrx$/i) && ($FXirc{'client'}{lc($nick)}{'server'} =~ /^$servmask$/i)) {
      &putlog("y", "Exempted client connection: %s (%s\@%s) [%s]", $nick, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $FXirc{'client'}{lc($nick)}{'server'});
      return(0);
    }
  }

  foreach (keys(%{$FXirc{'kill'}})) {
    my $usermask = (split(/\@/, $FXirc{'kill'}{$_}{'mask'}, 0))[0]; my $umaskrx = &plain2regexp($usermask);
    my $hostmask = (split(/\@/, $FXirc{'kill'}{$_}{'mask'}, 0))[1]; my $hmaskrx = &plain2regexp($hostmask);

    if (($FXirc{'client'}{lc($nick)}{'user'} =~ /^$umaskrx$/i) && ($FXirc{'client'}{lc($nick)}{'host'} =~ /^$hmaskrx$/i)) {
      if (lc($FXirc{'client'}{lc($nick)}{'server'}) eq lc($FXserv{'name'})) { next; }

      &putlog("y", "Auto-kill client connection: %s (%s\@%s) [%s]", $nick, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $FXirc{'client'}{lc($nick)}{'server'});
      &kill_client($nick, $FXirc{'kill'}{$_}{'reason'}, $FXirc{'kill'}{$_}{'author'}, $FXbot{'DataServ'}{'service'});
      &add_seen($nick, "QUIT", $FXirc{'kill'}{$_}{'reason'});
      &chanlog("q", undef, $nick, $FXirc{'kill'}{$_}{'reason'}, undef);
      &del_client($nick);
      ++$FXstats{'kills'}{'oper'};
      return(0);
    }
  }

  my $clones = 0;

  foreach (keys %{$FXirc{'client'}}) {
    if ($FXirc{'client'}{$_}{'host'} eq $FXirc{'client'}{lc($nick)}{'host'}) { ++$clones; }
  }

  if ($clones > $FXcfg{'general'}{'clones_max'}) {
    &putinfo("y", "Clone detected: %s (%s\@%s) [%s]", $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $FXirc{'client'}{lc($nick)}{'server'});
    if ($FXcfg{'general'}{'clones_kill'}) {
      &kill_client($FXirc{'client'}{lc($nick)}{'nick'}, "No more than $FXcfg{'general'}{'clones_max'} users with the same host", undef, $FXbot{'DataServ'}{'nick'});
      ++$FXstats{'kills'}{'oper'};
      &del_client($nick);
      return(0);
    }
  }

  if ($FXbot{'ScanServ'}{'enabled'}) {
    if ($FXbot{'ScanServ'}{'scan_version'}) { &ss_ctcp($nick, 0, "VERSION"); }
    &ss_check($nick, "scan", undef);
  }

  return(0);
}

sub kill_client {
  my ($nick, $reason, $author, $service) = (shift, shift, shift, shift);

  if ($author) { $author = " (" . $author . "\@" . $FXbot{$service}{'nick'}. ")"; }

  if ($FXcfg{'hub'}{'type'} =~ /^(hybrid|hybrid7|unreal)$/) {
    &putsock($FXsock{'irc'}, ":%s KILL %s :%s!%s (%s%s)", $FXbot{$service}{'nick'}, $FXirc{'client'}{lc($nick)}{'nick'}, $FXserv{'name'}, $FXbot{$service}{'nick'}, $reason, $author ? $author : "");
  } elsif ($FXcfg{'hub'}{'type'} eq "bahamut") {
    &putsock($FXsock{'irc'}, ":%s KILL %s :%s%s", $FXbot{$service}{'nick'}, $FXirc{'client'}{lc($nick)}{'nick'}, $reason, $author ? $author : "");
  } elsif ($FXcfg{'hub'}{'type'} eq "ultimate") {
    &putsock($FXsock{'irc'}, ":%s KILL %s :%s%s", $FXbot{$service}{'nick'}, $FXirc{'client'}{lc($nick)}{'nick'}, $reason, $author ? $author : "");
  }

  &putinfo("O", "Service kill: %s!%s\@%s by %s (%s)", $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $FXbot{$service}{'nick'}, $reason);

  return(0);
}

sub add_akill {
  my ($user, $host, $author, $expire, $reason) = (shift, shift, shift, shift, shift);

  my $mask = $user . "\@" . $host;

  $FXirc{'kill'}{lc($mask)}{'mask'} = $mask;
  $FXirc{'kill'}{lc($mask)}{'reason'} = $reason ? $reason : $FXcfg{'general'}{'kill_reason'};
  $FXirc{'kill'}{lc($mask)}{'author'} = $author;
  $FXirc{'kill'}{lc($mask)}{'set'} = $ts;
  $FXirc{'kill'}{lc($mask)}{'expire'} = $expire;

  if (!$FXsock{'irc'}) { return(0); }

  if ($FXcfg{'hub'}{'type'} eq "hybrid") {
    &putsock($FXsock{'irc'}, ":%s KLINE %s * :%s", $FXbot{'DataServ'}{'nick'}, $mask, $reason);
  } elsif ($FXcfg{'hub'}{'type'} eq "hybrid7") {
    &putsock($FXsock{'irc'}, ":%s KLINE * %d %s %s :%s", $FXbot{'DataServ'}{'nick'}, $ts, $user, $host, $reason);
  } elsif ($FXcfg{'hub'}{'type'} eq "bahamut") {
    &putsock($FXsock{'irc'}, ":%s AKILL %s %s %d %s %d :%s", $FXserv{'name'}, $host, $user, $expire, $author, $ts, $reason);
  } elsif ($FXcfg{'hub'}{'type'} eq "unreal") {
    &putsock($FXsock{'irc'}, ":%s TKL + G %s %s %s %d %d :%s", $FXserv{'name'}, $user, $host, $author, $ts + $expire, $ts, $reason);
  }

  return(0);
}

sub rem_akill {
  my ($user, $host) = (shift, shift);

  if (!$FXsock{'irc'}) { return(0); }

  my $mask = $user . "\@" . $host;

  if ($FXcfg{'hub'}{'type'} eq "hybrid") {
    &putsock($FXsock{'irc'}, ":%s UNKLINE %s", $FXserv{'name'}, $mask);
  } elsif ($FXcfg{'hub'}{'type'} eq "hybrid7") {
    &putsock($FXsock{'irc'}, ":%s UNKLINE * %s %s", $FXbot{'DataServ'}{'nick'}, $user, $host);
  } elsif ($FXcfg{'hub'}{'type'} eq "bahamut") {
    &putsock($FXsock{'irc'}, ":%s RAKILL %s %s", $FXserv{'name'}, $host, $user);
  } elsif ($FXcfg{'hub'}{'type'} eq "unreal") {
    &putsock($FXsock{'irc'}, ":%s TKL - G %s %s %s", $FXserv{'name'}, $user, $host, $FXbot{'DataServ'}{'nick'});
  }

  return(0);
}

sub check_flood {
  my $nick = shift;

  if (&valid_oper($nick, undef)) {
    $FXirc{'client'}{lc($nick)}{'lastcmd'} = $ts;
    $FXirc{'client'}{lc($nick)}{'floodcnt'} = 0;
    return(0);
  } elsif ($FXirc{'client'}{lc($nick)}{'ignored'}) {
    return(1);
  } elsif ($ts - $FXirc{'client'}{lc($nick)}{'lastcmd'} < $FXcfg{'general'}{'flood_time'}) {
    if (++$FXirc{'client'}{lc($nick)}{'floodcnt'} < $FXcfg{'general'}{'flood_count'}) {
      $FXirc{'client'}{lc($nick)}{'lastcmd'} = $ts;
      return(0);
    } else {
      &ds_notice($FXirc{'client'}{lc($nick)}{'nick'}, $FXmsg{'flood_irc'}, $FXcfg{'general'}{'flood_count'}, $FXcfg{'general'}{'flood_time'});
      $FXirc{'client'}{lc($nick)}{'ignored'} = $ts;
      &putinfo("y", "Detected flood from %s!%s\@%s (%dsec ignore)", $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $FXcfg{'general'}{'flood_ignore'});
      return(1);
    }
  } else {
    $FXirc{'client'}{lc($nick)}{'lastcmd'} = $ts;
    $FXirc{'client'}{lc($nick)}{'floodcnt'} = 0;
    return(0);
  }
}

sub introduce_service {
  my $service = shift;

  if (!$FXbot{$service}{'enabled'}) { return(1); }

  my $nick = $FXbot{$service}{'nick'};
  my $user = $FXbot{$service}{'user'};
  my $host = $FXbot{$service}{'host'};
  my $info = $FXbot{$service}{'info'};
  my $mode = $FXbot{$service}{'mode'};
  my $numeric = 0;
  my $what = 1;
  my $umode = '';

  if (($service eq "DataServ") && ($FXbot{'DataServ'}{'mode'} !~ /o/)) { $mode .= "o"; }
  if (($service eq "ScanServ") && $FXbot{'ScanServ'}{'enabled'} && ($FXbot{'ScanServ'}{'mode'} !~ /o/)) { $mode .= "o"; }

  if ($FXcfg{'hub'}{'type'} eq "bahamut") {
    if ($mode !~ /a/) { $mode .= "a"; }
  } elsif ($FXcfg{'hub'}{'type'} eq "ultimate") {
    if ($mode !~ /b/) { $mode .= "b"; }
  }

  if ($FXcfg{'hub'}{'type'} =~ /^(unreal|ultimate)$/) {
    if ($mode !~ /S/) { $mode .= "S"; }
  }

  foreach (split(//, $mode)) {
    if ($_ eq "+") {
      $what = 1;
    } elsif ($_ eq "-") {
      $what = 0;
    } elsif ($FXflags{'client'}{$_}) {
      if ($what) {
        $umode |= $FXflags{'client'}{$_};
      } else {
        $umode &= ~$FXflags{'client'}{$_};
      }
    }
  }

  &introduce_nick($nick, $user, $host, $numeric, $umode, $info);
  &add_client($nick, $user, $host, $info, $numeric, $FXserv{'name'}, $ts, $umode);

  return(0);
}

sub introduce_nick {
  my ($nick, $user, $host, $numeric, $umode, $info) = (shift, shift, shift, shift, shift, shift);
  my $mode = "+";

  if ($FXirc{'client'}{lc($nick)}) {
    my $target = $FXirc{'client'}{lc($nick)}{'nick'};
    my $reason = "Nick Collision";

    &kill_client($target, $reason, $FXbot{'DataServ'}{'nick'}, "DataServ");
    &add_seen($target, "QUIT", $reason);
    &chanlog("q", undef, $target, $reason, undef);
    &del_client($target);
    ++$FXstats{'kills'}{'oper'};
  }

  foreach (keys(%{$FXflags{'client'}})) {
    if ($umode & $FXflags{'client'}{$_}) { $mode .= $_; }
  }

  if ($FXcfg{'hub'}{'type'} =~ /^(hybrid|hybrid7)$/) {
    &putsock($FXsock{'irc'}, "NICK %s 1 %d %s %s %s %s :%s", $nick, $ts, $mode, $user, $host, $FXserv{'name'}, $info);
    &putsock($FXsock{'irc'}, ":%s MODE %s :%s", $nick, $nick, $mode);
  } elsif ($FXcfg{'hub'}{'type'} eq "unreal") {
    &putsock($FXsock{'irc'}, "NICK %s 1 %d %s %s %s 0 %s * :%s", $nick, $ts, $user, $host, $FXserv{'name'}, $mode, $info);
  } elsif ($FXcfg{'hub'}{'type'} eq "bahamut") {
    &putsock($FXsock{'irc'}, "NICK %s 1 %d %s %s %s %s 0 0 :%s", $nick, $ts, $mode, $user, $host, $FXserv{'name'}, $info);
  } elsif ($FXcfg{'hub'}{'type'} eq "ultimate") {
    &putsock($FXsock{'irc'}, "NICK %s 1 %d %s %s %s 0 :%s", $nick, $ts, $user, $host, $FXserv{'name'}, $info);
    &putsock($FXsock{'irc'}, "MODE %s %s", $nick, $mode);
  }

  return(0);
}

1;