use strict;

our (%FXcfg, %FXflags, %FXbot, %FXserv, %FXbnet, %FXoper, %FXgames, %FXlisten, %FXim, %FXirc, %FXmsg, %MySQL, $ConfigFile, $LangPack, $LogEvent, $LogFile, $PidFile, $ts);

sub load_conf {
  my $error = 0;
  my $block = 0;
  my %listen = ();
  my @range = ();
  %FXmsg = ();

  $FXbot{'DataServ'}{'enabled'} = 1;
  $FXbot{'FileServ'}{'enabled'} = 0;
  $FXbot{'FindServ'}{'enabled'} = 0;
  $FXbot{'NewsServ'}{'enabled'} = 0;
  $FXbot{'MobiServ'}{'enabled'} = 0;
  $FXbot{'GameServ'}{'enabled'} = 0;
  $FXbot{'PageServ'}{'enabled'} = 0;
  $FXbot{'ScanServ'}{'enabled'} = 0;
  $MySQL{'enabled'} = 0;

  $FXserv{'name'} = "";
  $FXserv{'info'} = "";
  $FXserv{'vhost'} = "";
  $FXserv{'admin'} = "";

  $FXcfg{'files'}{'pid'} = "";
  $FXcfg{'files'}{'log'} = "";
  $FXcfg{'files'}{'log_event'} = "";
  $FXcfg{'files'}{'log_ext'} = "";
  $FXcfg{'files'}{'motd'} = "";
  $FXcfg{'files'}{'oper'} = "";
  $FXcfg{'files'}{'ignore'} = "";
  $FXcfg{'files'}{'kill'} = "";
  $FXcfg{'files'}{'exempt'} = "";
  $FXcfg{'files'}{'monitor'} = "";
  $FXcfg{'files'}{'bot'} = "";
  $FXcfg{'general'}{'language'} = "";
  $FXcfg{'general'}{'reconnect'} = 0;
  $FXcfg{'general'}{'ping'} = 0;
  $FXcfg{'general'}{'modes'} = 0;
  $FXcfg{'general'}{'communicate'} = "NOTICE";
  $FXcfg{'general'}{'flood_count'} = 0;
  $FXcfg{'general'}{'flood_time'} = 0;
  $FXcfg{'general'}{'flood_ignore'} = 0;
  $FXcfg{'general'}{'clones_max'} = 0;
  $FXcfg{'general'}{'clones_kill'} = 0;
  $FXcfg{'general'}{'kill_reason'} = "Killed";
  $FXcfg{'general'}{'fightfix'} = 0;
  $FXcfg{'general'}{'timeout'} = 0;
  $FXcfg{'general'}{'max_connections'} = 0;
  $FXcfg{'general'}{'autolink'} = 0;
  $FXcfg{'general'}{'non_wildcard'} = 0;
  $FXcfg{'general'}{'sync'} = 0;

  if (!open(FILE, "<" . $ConfigFile)) { return(1); }

  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer =~ tr/ //s; $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ s/\r$//;

    if (($buffer =~ /^#/) || ($buffer !~ /\S/)) { next; }

    if (!$block && ($buffer =~ /^(hub|FXserv|files|general|listen|MySQL|(Data|File|Find|News|Mobi|Game|Page|Scan)Serv) \{$/)) {
      $block = $1;
      next;
    }

    if ($block) {
      if ($buffer eq "\}") {
        $block = 0;
        next;
      }

      my ($key, $value) = split(/ = /, $buffer, 2);

      if ($block eq "hub") { $FXcfg{'hub'}{$key} = $value; }
      if ($block eq "general") { $FXcfg{'general'}{$key} = $value; }
      if ($block eq "files") { $FXcfg{'files'}{$key} = $value; }
      if ($block eq "FXserv") { $FXserv{$key} = $value; }
      if ($block =~ /^(Data|File|Find|News|Mobi|Game|Page|Scan)Serv$/) { $FXbot{$block}{$key} = $value; }

      if ($block eq "MySQL") { $MySQL{$key} = $value; }

      if ($block eq "listen") {
        if ($key eq "port") { @range = &parse_range($value); }

        foreach (@range) {
          $listen{$_}{'port'} = $_;
          $listen{$_}{$key} = $value;
        }
      }
    }
  }

  $LangPack = $FXcfg{'general'}{'language'};
  $PidFile = $FXcfg{'files'}{'pid'};
  $LogFile = $FXcfg{'files'}{'log'};

  foreach (split(//, $FXcfg{'files'}{'log_event'})) {
    if ($FXflags{'event'}{$_}) { $LogEvent |= $FXflags{'event'}{$_}; }
  }

  $FXbot{'DataServ'}{'enabled'} = 1;
  $FXbot{'DataServ'}{'service'} = "DataServ";
  $FXbot{'FileServ'}{'service'} = "FileServ";
  $FXbot{'FindServ'}{'service'} = "FindServ";
  $FXbot{'NewsServ'}{'service'} = "NewsServ";
  $FXbot{'MobiServ'}{'service'} = "MobiServ";
  $FXbot{'PageServ'}{'service'} = "PageServ";
  $FXbot{'GameServ'}{'service'} = "GameServ";
  $FXbot{'ScanServ'}{'service'} = "ScanServ";

  foreach (keys(%FXbot)) {
    if ($FXbot{$_}{'enabled'}) {
      if (!$FXbot{$_}{'host'}) { $FXbot{$_}{'host'} = $FXserv{'name'}; }
      &enable_service($FXbot{$_}{'service'}, 1);
    }
  }

  if ($FXcfg{'files'}{'oper'}) { &load_oper(); }
  if ($FXcfg{'files'}{'kill'}) { &load_kill(); }
  if ($FXcfg{'files'}{'bot'}) { &load_bot(); }
  if ($FXcfg{'files'}{'ignore'}) { &load_ignore(); }
  if ($FXcfg{'files'}{'exempt'}) { &load_exempt(); }
  if ($FXbot{'DataServ'}{'seen_file'}) { &load_seen(); }

  if ($MySQL{'enabled'}) {
    require "src/mysql.pl";
    $MySQL{'last_sync'} = $ts;
    if (!$MySQL{'host'} || !&valid_port($MySQL{'port'}) || !$MySQL{'user'} || !$MySQL{'password'} || ($MySQL{'sync'} < 1)) { $error = 1; }
  }

  foreach my $port (keys(%listen)) {
    if (!&valid_port($port)) { next; }
    if ($listen{$port}{'type'} =~ /^(bot|user)$/) {
      $FXlisten{$port} = $listen{$port};
      $FXlisten{$port}{'listen'} = 0;
    }
  }

  if (!$FXcfg{'general'}{'language'} || !$FXcfg{'general'}{'reconnect'} || !$FXcfg{'general'}{'ping'} || !$FXcfg{'general'}{'modes'} || !$FXcfg{'general'}{'flood_count'} || !$FXcfg{'general'}{'flood_time'} || !$FXcfg{'general'}{'flood_ignore'} || !$FXcfg{'general'}{'communicate'} || !$FXcfg{'general'}{'clones_max'} || !$FXcfg{'general'}{'timeout'} || !$FXcfg{'general'}{'max_connections'} || !$FXcfg{'general'}{'autolink'} || !$FXcfg{'general'}{'non_wildcard'} || !$FXcfg{'general'}{'sync'}) { $error = 1; }

  require "lang/" . $LangPack;

  return($error);
}

sub load_buddies {
  if (!open(FILE, "<" . $FXbot{'PageServ'}{'buddies_file'})) { return(1); }

  my $block = 0;
  my $id = "";
  my %im = ();
  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer =~ tr/ //s; $buffer =~ s/\s+$//; $buffer =~ s/^\s+//;

    if (($buffer =~ /^#/) || ($buffer !~ /\S/)) { next; }

    if (!$block && ($buffer =~ /^(icq|yahoo|msn|aim|jabber) \{/)) {
      $block = $1;
      next;
    }

    if ($block) {
      if ($buffer eq "\}") {
        $block = 0;
        next;
      }

      my ($key, $value) = split(/ = /, $buffer, 2);
      if ($key eq "id") { $id = $value; }
      $im{$block}{lc($id)}{$key} = $value;
    }
  }

  foreach $block (keys(%im)) {
    foreach $id (keys(%{$im{$block}})) {
      if (($im{$block}{$id}{'id'} ne "") && ($im{$block}{$id}{'nick'} ne "")) {
        $FXim{$block}{'buddies'}{$id} = $im{$block}{$id};
        $FXim{$block}{'buddies'}{$id}{'ircnick'} = "";
        $FXim{$block}{'buddies'}{$id}{'online'} = 0;
        $FXim{$block}{'buddies'}{$id}{'status'} = "";
        $FXim{$block}{'buddies'}{$id}{'info'} = $id;
        $FXim{$block}{'buddies'}{$id}{'user'} = (split(/\@/, lc($id), 0))[0];
        $FXim{$block}{'buddies'}{$id}{'buddy'} = 1;
      }
    }
  }

  return(0);
}

sub load_games {
  if (!open(FILE, "<" . $FXbot{'GameServ'}{'games_file'})) { return(1); }

  my $block = 0;
  my $server = "";
  my %games = ();
  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer =~ tr/ //s; $buffer =~ s/\s+$//; $buffer =~ s/^\s+//;

    if (($buffer =~ /^#/) || ($buffer !~ /\S/)) { next; }

    if (!$block && ($buffer eq "game \{")) {
      $block = 1;
      next;
    }

    if ($block) {
      if ($buffer eq "\}") {
        $block = 0;
        next;
      }

      my ($key, $value) = split(/ = /, $buffer, 2);
      if ($key eq "server") { $server = $value; }
      $games{$server}{$key} = $value;
    }
  }

  foreach (keys(%games)) {
    if (($games{$_}{'server'} ne "") && ($games{$_}{'type'} =~ /^(valve|unreal|quake3|bf1942|duty|rtcw|moh|army)$/)) {
      my $server = $games{$_}{'server'};
      $FXgames{lc($server)} = $games{$_};
      $FXgames{lc($server)}{'host'} = (split(/:/, $server, 0))[0];
      $FXgames{lc($server)}{'port'} = (split(/:/, $server, 0))[1];
    }
  }

  return(0);
}

sub load_seen {
  if (!open(FILE, "<" . $FXbot{'DataServ'}{'seen_file'})) { return(1); }

  my $block = 0;
  my %seen = ();
  my $nick = ();
  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer =~ tr/ //s; $buffer =~ s/\s+$//; $buffer =~ s/^\s+//;

    if (($buffer =~ /^#/) || ($buffer !~ /\S/)) { next; }

    if (!$block && ($buffer eq "seen \{")) {
      $block = 1;
      next;
    }

    if ($block) {
      if ($buffer eq "\}") {
        $block = 0;
        next;
      }

      my ($key, $value) = split(/ = /, $buffer, 2);
      if ($key eq "nick") { $nick = $value; }
      $seen{lc($nick)}{$key} = $value;
    }
  }

  foreach (keys(%seen)) {
    if (($seen{$_}{'nick'} ne "") && ($seen{$_}{'user'} ne "") && ($seen{$_}{'host'} ne "") && ($seen{$_}{'time'} > 0) && ($seen{$_}{'action'} =~ /^(JOIN|PART|QUIT|KICK|NICK)$/) && ($seen{$_}{'xtra'} ne "")) {
      my $nick = $seen{$_}{'nick'};
      $FXirc{'seen'}{lc($nick)} = $seen{$_};
    }
  }

  return(0);
}

sub load_oper {
  if (!open(FILE, "<" . $FXcfg{'files'}{'oper'})) { return(1); }

  my $block = 0;
  my %oper = ();
  my $name = ();
  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer =~ tr/ //s; $buffer =~ s/\s+$//; $buffer =~ s/^\s+//;

    if (($buffer =~ /^#/) || ($buffer !~ /\S/)) { next; }

    if (!$block && ($buffer eq "operator \{")) {
      $block = 1;
      next;
    }

    if ($block) {
      if ($buffer eq "\}") {
        $block = 0;
        next;
      }

      my ($key, $value) = split(/ = /, $buffer, 2);
      if ($key eq "name") { $name = $value; }
      $oper{lc($name)}{$key} = $value;
    }
  }

  foreach my $key (keys(%oper)) {
    if (($oper{$key}{'name'} ne "") && ($oper{$key}{'mask'} ne "") && ($oper{$key}{'password'} ne "") && ($oper{$key}{'flags'} ne "")) {
      my $name = $oper{$key}{'name'};
      my $mask = $oper{$key}{'mask'};
      my $umodes = "";
      my $flags = "";

      foreach my $flag (split(//, $oper{lc($name)}{'flags'})) {
        if ($FXflags{'oper'}{$flag}) { $flags .= $flag; }
        if ($flag eq "a") { $flags .= "dfo"; }
        if ($flag eq "o") { $flags .= "f"; }
      }

      $oper{lc($name)}{'flags'} = '';

      foreach my $flag (split(//, $flags)) {
        $oper{lc($name)}{'flags'} |= $FXflags{'oper'}{$flag};
      }

      foreach my $umode (split(//, $oper{lc($name)}{'umodes'})) {
        if ($FXflags{'event'}{$umode}) { $umodes .= $umode; }
      }

      $oper{lc($name)}{'umodes'} = '';

      foreach my $umode (split(//, $umodes)) {
        $oper{lc($name)}{'umodes'} |= $FXflags{'event'}{$umode};
      }

      $FXoper{lc($name)} = $oper{$key};
      $FXoper{lc($name)}{'user'} = (split(/\@/, $mask, 0))[0];
      $FXoper{lc($name)}{'host'} = (split(/\@/, $mask, 0))[1];
    }
  }

  return(0);
}

sub load_kill {
  if (!open(FILE, "<" . $FXcfg{'files'}{'kill'})) { return(1); }

  my $block = 0;
  my %kill = ();
  my $mask = ();
  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer =~ tr/ //s; $buffer =~ s/\s+$//; $buffer =~ s/^\s+//;

    if (($buffer =~ /^#/) || ($buffer !~ /\S/)) { next; }

    if (!$block && ($buffer eq "kill \{")) {
      $block = 1;
      next;
    }

    if ($block) {
      if ($buffer eq "\}") {
        $block = 0;
        next;
      }

      my ($key, $value) = split(/ = /, $buffer, 2);
      if ($key eq "mask") { $mask = $value; }
      $kill{lc($mask)}{$key} = $value;
    }
  }

  foreach (keys(%kill)) {
    if (($kill{$_}{'mask'} ne "") && ($kill{$_}{'reason'} ne "")) {
      my $mask = $kill{$_}{'mask'};
      $FXirc{'kill'}{lc($mask)} = $kill{$_};
    }
  }

  return(0);
}

sub load_ignore {
  if (!open(FILE, "<" . $FXcfg{'files'}{'ignore'})) { return(1); }

  my $block = 0;
  my $mask = "";
  my %ignore = ();
  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer =~ tr/ //s; $buffer =~ s/\s+$//; $buffer =~ s/^\s+//;

    if (($buffer =~ /^#/) || ($buffer !~ /\S/)) { next; }

    if (!$block && ($buffer eq "ignore \{")) {
      $block = 1;
      next;
    }

    if ($block) {
      if ($buffer eq "\}") {
        $block = 0;
        next;
      }

      my ($key, $value) = split(/ = /, $buffer, 2);
      if ($key eq "mask") { $mask = $value; }
      $ignore{lc($mask)}{$key} = $value;
    }
  }

  foreach (keys(%ignore)) {
    if (($ignore{$_}{'mask'} ne "") && ($ignore{$_}{'reason'} ne "")) {
      my $mask = $ignore{$_}{'mask'};
      $FXirc{'ignore'}{lc($mask)} = $ignore{$_};
      $FXirc{'ignore'}{lc($mask)}{'user'} = (split(/\@/, $mask, 0))[0];
      $FXirc{'ignore'}{lc($mask)}{'host'} = (split(/\@/, $mask, 0))[1];
    }
  }

  return(0);
}

sub load_exempt {
  if (!open(FILE, "<" . $FXcfg{'files'}{'exempt'})) { return(1); }

  my $block = 0;
  my $mask = "";
  my %exempt = ();
  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer =~ tr/ //s; $buffer =~ s/\s+$//; $buffer =~ s/^\s+//;

    if (($buffer =~ /^#/) || ($buffer !~ /\S/)) { next; }

    if (!$block && ($buffer eq "exempt \{")) {
      $block = 1;
      next;
    }

    if ($block) {
      if ($buffer eq "\}") {
        $block = 0;
        next;
      }

      my ($key, $value) = split(/ = /, $buffer, 2);
      if ($key eq "mask") { $mask = $value; }
      $exempt{lc($mask)}{$key} = $value;
    }
  }

  foreach (keys(%exempt)) {
    if (($exempt{$_}{'mask'} ne "") && ($exempt{$_}{'server'} ne "")) {
      my $mask = $exempt{$_}{'mask'};
      $FXirc{'exempt'}{lc($mask)} = $exempt{$_};
    }
  }

  return(0);
}

sub load_version {
  if (!open(FILE, "<" . $FXbot{'ScanServ'}{'scan_version'})) { return(1); }

  my $block = 0;
  my $reply = "";
  my %version = ();
  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer =~ tr/ //s; $buffer =~ s/\s+$//; $buffer =~ s/^\s+//;

    if (($buffer =~ /^#/) || ($buffer !~ /\S/)) { next; }

    if (!$block && ($buffer eq "version \{")) {
      $block = 1;
      next;
    }

    if ($block) {
      if ($buffer eq "\}") {
        $block = 0;
        next;
      }

      my ($key, $value) = split(/ = /, $buffer, 2);
      if ($key eq "reply") { $reply = $value; }
      $version{lc($reply)}{$key} = $value;
    }
  }

  foreach (keys(%version)) {
    if (($version{$_}{'reply'} ne "") && ($version{$_}{'reason'} ne "")) {
      my $reply = $version{$_}{'reply'};
      $FXirc{'version'}{lc($reply)} = $version{$_};
    }
  }

  return(0);
}

sub load_bot {
  if (!open(FILE, "<" . $FXcfg{'files'}{'bot'})) { return(1); }

  my $block = 0;
  my $nick = "";
  my %bot = ();
  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer =~ tr/ //s; $buffer =~ s/\s+$//; $buffer =~ s/^\s+//;

    if (($buffer =~ /^#/) || ($buffer !~ /\S/)) { next; }

    if (!$block && ($buffer eq "bot \{")) {
      $block = 1;
      next;
    }

    if ($block) {
      if ($buffer eq "\}") {
        $block = 0;
        next;
      }

      my ($key, $value) = split(/ = /, $buffer, 2);
      if ($key eq "nick") { $nick = $value; }
      $bot{lc($nick)}{$key} = $value;
    }
  }

  foreach (keys(%bot)) {
    if (($bot{$_}{'nick'} ne "") && ($bot{$_}{'host'} ne "") && &valid_port($bot{$_}{'port'}) && ($bot{$_}{'password'} ne "")) {
      my $nick = $bot{$_}{'nick'};
      $FXbnet{lc($nick)} = $bot{$_};
      $FXbnet{lc($nick)}{'sock'} = 0;
      $FXbnet{lc($nick)}{'prefix'} = "";
      $FXbnet{lc($nick)}{'attempt'} = 0;
    }
  }

  return(0);
}

sub load_monitor {
  my $service = shift;

  if (!open(FILE, "<" . $FXcfg{'files'}{'monitor'})) { return(1); }

  my $block = 0;
  my %monitor = ();
  my $idx = 0;
  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer =~ tr/ //s; $buffer =~ s/\s+$//; $buffer =~ s/^\s+//;

    if (($buffer =~ /^#/) || ($buffer !~ /\S/)) { next; }

    if (!$block && ($buffer eq "monitor \{")) {
      $block = 1;

      $monitor{$idx}{'channel'} = "";
      $monitor{$idx}{'service'} = "";
      $monitor{$idx}{'mode'} = "";
      $monitor{$idx}{'public'} = 0;
      $monitor{$idx}{'prefix'} = "";
      $monitor{$idx}{'log_event'} = '';
      $monitor{$idx}{'log_file'} = "";
      $monitor{$idx}{'partmsg'} = "";
      $monitor{$idx}{'joinmsg'} = "";

      next;
    }

    if ($block) {
      if ($buffer eq "\}") {
        ++$idx;
        $block = 0;
        next;
      }

      my ($key, $value) = split(/ = /, $buffer, 2);
      $monitor{$idx}{$key} = $value;
    }
  }

  foreach my $idx (keys(%monitor)) {
    if (($monitor{$idx}{'channel'} =~ /^#/) && ($monitor{$idx}{'service'} ne "")) {
      my $channel = $monitor{$idx}{'channel'};
      my $nick = $monitor{$idx}{'service'};
      my $event = '';

      foreach my $flag (split(//, $monitor{$idx}{'log_event'})) {
        if ($FXflags{'monitor'}{$flag}) { $event |= $FXflags{'monitor'}{$flag}; }
      }

      foreach my $bot (keys(%FXbot)) {
        if (!$FXbot{$bot}{'enabled'}) { next; }

        if ($service && ($FXbot{$bot}{'service'} ne $service)) { next; }

        if (lc($nick) eq lc($FXbot{$bot}{'nick'})) {
          $FXbot{$bot}{'channel'}{lc($channel)} = $monitor{$idx};
          $FXbot{$bot}{'channel'}{lc($channel)}{'log_event'} = $event;
          last;
        }
      }
    }
  }

  return(0);
}

sub save_conf {
  my $fd;

  if (!open($fd, ">" . $FXcfg{'files'}{'oper'})) { &putinfo("y", "Unable to open operator file: %s", $FXcfg{'files'}{'oper'}); }
  foreach my $oper (keys(%FXoper)) {
    my $umodes = "";
    my $flags = "";

    foreach my $umode (keys(%{$FXflags{'event'}})) {
      if ($FXoper{$oper}{'umodes'} & $FXflags{'event'}{$umode}) { $umodes .= $umode; }
    }

    foreach my $flag (keys(%{$FXflags{'oper'}})) {
      if ($FXoper{$oper}{'flags'} & $FXflags{'oper'}{$flag}) { $flags .= $flag; }
    }

    print $fd "operator {\n";
    print $fd "  name = $FXoper{$oper}{'name'}\n";
    print $fd "  mask = $FXoper{$oper}{'mask'}\n";
    print $fd "  password = $FXoper{$oper}{'password'}\n";
    print $fd "  flags = $flags\n";
    print $fd "  umodes = $umodes\n";
    print $fd "}\n\n";
  }

  close($fd);

  if (!open($fd, ">" . $FXcfg{'files'}{'monitor'})) { &putinfo("y", "Unable to open monitor file: %s", $FXcfg{'files'}{'monitor'}); }
  foreach my $service (keys(%FXbot)) {
    if (!$FXbot{$service}{'channel'}) { next; }

    foreach my $channel (keys(%{$FXbot{$service}{'channel'}})) {
      print $fd "monitor {\n";
      print $fd "  channel = $FXbot{$service}{'channel'}{$channel}{'channel'}\n";
      print $fd "  service = $FXbot{$service}{'nick'}\n";
      if ($FXbot{$service}{'channel'}{$channel}{'mode'}) { print $fd "  mode = $FXbot{$service}{'channel'}{$channel}{'mode'}\n"; }
      if ($FXbot{$service}{'channel'}{$channel}{'public'}) { print $fd "  public = $FXbot{$service}{'channel'}{$channel}{'public'}\n"; }
      if ($FXbot{$service}{'channel'}{$channel}{'prefix'}) { print $fd "  prefix = $FXbot{$service}{'channel'}{$channel}{'prefix'}\n"; }
      if ($FXbot{$service}{'channel'}{$channel}{'log_event'}) {
        my $event = "";

        foreach my $flag (keys(%{$FXflags{'monitor'}})) {
          if ($FXbot{$service}{'channel'}{$channel}{'log_event'} & $FXflags{'monitor'}{$flag}) { $event .= $flag; }
        }

        print $fd "  log_event = $event\n"; 
      }

      if ($FXbot{$service}{'channel'}{$channel}{'log_file'}) { print $fd "  log_file = $FXbot{$service}{'channel'}{$channel}{'log_file'}\n"; }
      if ($FXbot{$service}{'channel'}{$channel}{'joinmsg'}) { print $fd "  joinmsg = $FXbot{$service}{'channel'}{$channel}{'joinmsg'}\n"; }
      if ($FXbot{$service}{'channel'}{$channel}{'partmsg'}) { print $fd "  partmsg = $FXbot{$service}{'channel'}{$channel}{'partmsg'}\n"; }
      print $fd "}\n\n";
    }
  }

  close($fd);

  if ($FXbot{'PageServ'}{'enabled'}) {
    if (!open($fd, ">" . $FXbot{'PageServ'}{'buddies_file'})) { &putinfo("y", "Unable to open buddies file: %s", $FXbot{'PageServ'}{'buddies_file'}); }

    foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
      foreach (keys(%{$FXim{$im}{'buddies'}})) {
        if (!$FXim{$im}{'buddies'}{$_}{'buddy'}) { next; }
        print $fd "$im {\n";
        print $fd "  id = $FXim{$im}{'buddies'}{$_}{'id'}\n";
        print $fd "  nick = $FXim{$im}{'buddies'}{$_}{'nick'}\n";
        print $fd "  seen = $FXim{$im}{'buddies'}{$_}{'seen'}\n";
        print $fd "}\n\n";
      }
    }

    close($fd);
  }

  if ($FXbot{'GameServ'}{'enabled'}) {
    if (!open($fd, ">" . $FXbot{'GameServ'}{'games_file'})) { &putinfo("y", "Unable to open games file: %s", $FXbot{'GameServ'}{'games_file'}); }

    foreach (keys(%FXgames)) {
      print $fd "game {\n";
      print $fd "  server = $FXgames{$_}{'server'}\n";
      print $fd "  type = $FXgames{$_}{'type'}\n";
      print $fd "}\n\n";
    }

    close($fd);
  }

  if (!open($fd, ">" . $FXbot{'DataServ'}{'seen_file'})) { &putinfo("y", "Unable to open seen file: %s", $FXbot{'DataServ'}{'seen_file'}); }
  if (scalar(keys(%{$FXirc{'seen'}})) > $FXbot{'DataServ'}{'seen_maxrecs'}) {
    my @seen = sort { $FXirc{'seen'}{$b}{'time'} <=> $FXirc{'seen'}{$a}{'time'} } keys(%{$FXirc{'seen'}});
    my $idx = 0;

    foreach (@seen) {
      print $fd "seen {\n";
      print $fd "  nick = $FXirc{'seen'}{$_}{'nick'}\n";
      print $fd "  time = $FXirc{'seen'}{$_}{'time'}\n";
      print $fd "  user = $FXirc{'seen'}{$_}{'user'}\n";
      print $fd "  host = $FXirc{'seen'}{$_}{'host'}\n";
      print $fd "  action = $FXirc{'seen'}{$_}{'action'}\n";
      print $fd "  xtra = $FXirc{'seen'}{$_}{'xtra'}\n";
      print $fd "}\n\n";
      if (++$idx > $FXbot{'DataServ'}{'seen_maxrecs'}) { last; }
    }
  } else {
    foreach (keys(%{$FXirc{'seen'}})) {
      print $fd "seen {\n";
      print $fd "  nick = $FXirc{'seen'}{$_}{'nick'}\n";
      print $fd "  time = $FXirc{'seen'}{$_}{'time'}\n";
      print $fd "  user = $FXirc{'seen'}{$_}{'user'}\n";
      print $fd "  host = $FXirc{'seen'}{$_}{'host'}\n";
      print $fd "  action = $FXirc{'seen'}{$_}{'action'}\n";
      print $fd "  xtra = $FXirc{'seen'}{$_}{'xtra'}\n";
      print $fd "}\n\n";
    }
  }

  close($fd);

  if (!open($fd, ">" . $FXcfg{'files'}{'exempt'})) { &putinfo("y", "Unable to open exempt file: %s", $FXcfg{'files'}{'exempt'}); }
  foreach (keys(%{$FXirc{'exempt'}})) {
    print $fd "exempt {\n";
    print $fd "  mask = $FXirc{'exempt'}{$_}{'mask'}\n";
    print $fd "  server = $FXirc{'exempt'}{$_}{'server'}\n";
    print $fd "}\n\n";
  }

  close($fd);

  if (!open($fd, ">" . $FXcfg{'files'}{'ignore'})) { &putinfo("y", "Unable to open ignore file: %s", $FXcfg{'files'}{'ignore'}); }
  foreach (keys(%{$FXirc{'ignore'}})) {
    print $fd "ignore {\n";
    print $fd "  mask = $FXirc{'ignore'}{$_}{'mask'}\n";
    print $fd "  reason = $FXirc{'ignore'}{$_}{'reason'}\n";
    print $fd "}\n\n";
  }

  close($fd);

  if (!open($fd, ">" . $FXcfg{'files'}{'kill'})) { &putinfo("y", "Unable to open auto-kill file: %s", $FXcfg{'files'}{'kill'}); }
  foreach (keys(%{$FXirc{'kill'}})) {
    print $fd "kill {\n";
    print $fd "  mask = $FXirc{'kill'}{$_}{'mask'}\n";
    print $fd "  reason = $FXirc{'kill'}{$_}{'reason'}\n";
    print $fd "  author = $FXirc{'kill'}{$_}{'author'}\n";
    print $fd "  set = $FXirc{'kill'}{$_}{'set'}\n";
    print $fd "  expire = $FXirc{'kill'}{$_}{'expire'}\n";
    print $fd "}\n\n";
  }

  close($fd);

  if ($FXbot{'ScanServ'}{'enabled'} && $FXbot{'ScanServ'}{'scan_version'}) {
    if (!open($fd, ">" . $FXbot{'ScanServ'}{'scan_version'})) { &putinfo("y", "Unable to open version file: %s", $FXbot{'ScanServ'}{'scan_version'}); }

    foreach (keys(%{$FXirc{'version'}})) {
      print $fd "version {\n";
      print $fd "  reply = $FXirc{'version'}{$_}{'reply'}\n";
      print $fd "  reason = $FXirc{'version'}{$_}{'reason'}\n";
      print $fd "  action = ". uc($FXirc{'version'}{$_}{'action'}) . "\n";
      print $fd "}\n\n";
    }

    close($fd);
  }

  &putinfo("y", "Database has been saved");
  $FXserv{'last_sync'} = $ts;
  return(0);
}

1;