use strict;

our (%FXoper, %FXbnet, %FXcfg, %FXflags, %FXirc, %FXmsg, %FXbot, %FXsock, $LangPack, $ts);

$FXbot{'DataServ'}{'dcc'} = {
  'MOTD'      => \&dcc_motd,
  'QUIT'      => \&dcc_quit,
  'BYE'       => \&dcc_quit,
  'EXIT'      => \&dcc_quit,
  'UMODE'     => \&dcc_umode,
  'UMODES'    => \&dcc_umode,
  'BOOT'      => \&dcc_boot,
  'WHO'       => \&dcc_who,
  'LINK'      => \&dcc_link,
  'UNLINK'    => \&dcc_unlink,
  'ME'        => \&dcc_me,
  'HELP'      => \&ds_help,
  'MAP'       => \&ds_map,
  'SAVE'      => \&ds_save,
  'STATS'     => \&ds_stats,
  'DIE'       => \&ds_die,
  'RESTART'   => \&ds_restart,
  'TRACE'     => \&ds_trace,
  'KILL'      => \&ds_kill,
  'UNKILL'    => \&ds_unkill,
  'GLOBAL'    => \&ds_global,
  'STATUS'    => \&ds_status,
  'OMODE'     => \&ds_omode,
  'MONITOR'   => \&ds_monitor,
  'CLONES'    => \&ds_clones,
  'ENABLE'    => \&ds_enable,
  'DISABLE'   => \&ds_disable,
  'SEEN'      => \&ds_seen,
  'WHOWAS'    => \&ds_seen,
  'UNSEEN'    => \&ds_unseen,
  'SEENSTATS' => \&ds_seenstats,
  'EXEMPT'    => \&ds_exempt,
  'IGNORE'    => \&ds_ignore
};

sub dcc_parse {
  my ($socket, $buffer) = (shift, shift);

  $FXsock{'list'}{$socket}{'lastcmd'} = $ts;

  if ($buffer =~ /^\./) {
    my $cmd = (split(/ /, $buffer, 0))[0]; $cmd = substr($cmd, 1);
    my $arg = (split(/ /, $buffer, 2))[1];

    if ($FXbot{'DataServ'}{'dcc'}->{uc($cmd)}) {
      &{$FXbot{'DataServ'}{'dcc'}->{uc($cmd)}}($socket, $arg);
    } else {
      &putsock($socket, $FXmsg{'unkn_cmd'}, $cmd);      
    }

    return(0);
  } else {
    foreach (keys(%{$FXsock{'list'}})) {
      if ($FXsock{'list'}{$_}{'type'} eq "DCC") { &putsock($FXsock{'list'}{$_}{'sock'}, "<%s\@%s> %s", $FXsock{'list'}{$socket}{'nick'}, $FXbot{'DataServ'}{'nick'}, $buffer); }
    }

    &putbnet("<%s\@%s> %s", $FXsock{'list'}{$socket}{'nick'}, $FXbot{'DataServ'}{'nick'}, $buffer);
    return(0);
  }
}

sub dcc_me {
  my ($socket, $action) = (shift, shift);

  if (!$action) {
    &putsock($socket, $FXmsg{'syntax'}, "ME <action>");
    return(0);
  }

  foreach (keys(%{$FXsock{'list'}})) {
    if ($FXsock{'list'}{$_}{'type'} eq "DCC") { &putsock($FXsock{'list'}{$_}{'sock'}, "* %s\@%s %s", $FXsock{'list'}{$socket}{'nick'}, $FXbot{'DataServ'}{'nick'}, $action); }
  }

  &putbnet("* %s\@%s %s", $FXsock{'list'}{$socket}{'nick'}, $FXbot{'DataServ'}{'nick'}, $action);
  return(0);
}

sub dcc_umode {
  my ($socket, $mode) = (shift, shift);

  if (!&valid_oper($socket, "o")) {
    &putsock($socket, $FXmsg{'no_priv'});
    return(0);
  }

  my $what = 1;
  my $umodes = "";
  my $oper = $FXsock{'list'}{$socket}{'oper'};

  if ($mode) {
    foreach (split(//, $mode)) {
      if ($_ eq "+") {
        $what = 1;
      } elsif ($_ eq "-") {
        $what = 0;
      } elsif ($FXflags{'event'}{$_}) {
        if ($what) {
          $FXoper{lc($oper)}{'umodes'} |= $FXflags{'event'}{$_};
        } else {
          $FXoper{lc($oper)}{'umodes'} &= ~$FXflags{'event'}{$_};
        }
      }
    }
  }

  foreach (keys(%{$FXflags{'event'}})) {
    if ($FXoper{lc($oper)}{'umodes'} & $FXflags{'event'}{$_}) { $umodes .= $_; }
  }

  if (!$mode) {
    &putsock($socket, "Your usermodes are currently [+%s]", $umodes);
  } else {
    &putsock($socket, "Your usermodes are now [+%s]", $umodes);
  }

  &servicelog($socket, undef, "UMODE %s", $umodes);
  return(0);
}

sub dcc_who {
  my $socket = shift;
  my $connex = 0;
  my $idx = 0;

  &putsock($socket, "Current users: (\@ = Admin, + = Oper)");

  foreach (keys(%{$FXsock{'list'}})) {
    if ($FXsock{'list'}{$_}{'type'} eq "DCC") {
      my $prefix = " ";
      my $uhost = $FXsock{'list'}{$_}{'user'} . "\@" . $FXsock{'list'}{$_}{'host'};

      if (&valid_oper($socket, "a")) {
        $prefix = "\@";
      } elsif (&valid_oper($socket, "o")) {
        $prefix = "+";
      }

      &putsock($socket, "%s%-16s %-30s idle: %s", $prefix, $FXsock{'list'}{$_}{'nick'}, "(" . $uhost . ")", &format_time($FXsock{'list'}{$_}{'lastcmd'}));
    }
  }

  foreach (keys(%FXbnet)) {
    ++$idx;

    if ($FXbnet{$_}{'sock'}) {
      $connex = 1;
      last;
    }
  }

  if ($connex) {
    &putsock($socket, "Bot connection%s:", $idx > 1 ? "s" : "");

    foreach (keys(%FXbnet)) {
      if ($FXbnet{$_}{'sock'}) { &putsock($socket, "  %s %-15s [%s:%d]", $FXbnet{$_}{'prefix'}, $FXbnet{$_}{'nick'}, $FXbnet{$_}{'host'}, $FXbnet{$_}{'port'}); }
    }
  }

  &servicelog($socket, undef, "WHO");
  return(0);
}

sub dcc_quit {
  my ($socket, $reason) = (shift, shift);

  &putsock($socket, "Closing connection %s", $reason ? "[" . $reason . "]" : "");
  &putinfo(0, "%s (%s\@%s) has left the partyline %s", $FXsock{'list'}{$socket}{'nick'}, $FXsock{'list'}{$socket}{'user'}, $FXsock{'list'}{$socket}{'host'}, $reason ? "[" . $reason . "]" : "");
  &putbnet("(%s) %s (%s\@%s) has left the partyline %s", $FXbot{'DataServ'}{'nick'}, $FXsock{'list'}{$socket}{'nick'}, $FXsock{'list'}{$socket}{'user'}, $FXsock{'list'}{$socket}{'host'}, $reason ? "[" . $reason . "]" : "");
  &servicelog($socket, undef, "QUIT %s", $reason);
  &del_socket($socket);
  return(0);
}

sub dcc_boot {
  my ($socket, $arg) = (shift, shift);
  my $target = (split(/ /, $arg, 0))[0];
  my $reason = (split(/ /, $arg, 2))[1];

  if (!&valid_oper($socket, "a")) {
    &putsock($socket, $FXmsg{'no_priv'});
    return(0);
  }

  if (!$target) {
    &putsock($socket, $FXmsg{'syntax'}, "BOOT <nick> [reason]");
    return(0);
  }

  foreach (keys(%{$FXsock{'list'}})) {
    if (($FXsock{'list'}{$_}{'type'} eq "DCC") && (lc($FXsock{'list'}{$_}{'nick'}) eq lc($target))) {
      &servicelog($socket, undef, "BOOT %s [%s]", $FXsock{'list'}{$_}{'nick'}, $reason);
      &putsock($FXsock{'list'}{$_}{'sock'}, $FXmsg{'boot'}, $FXsock{'list'}{$socket}{'nick'}, $reason);
      &putbnet("(%s) %s has been booted by %s %s", $FXbot{'DataServ'}{'nick'}, $FXsock{'list'}{$_}{'nick'}, $FXsock{'list'}{$socket}{'nick'}, $reason ? "[" . $reason . "]" : "");
      &putsock($socket, $FXmsg{'booted'}, $FXsock{'list'}{$_}{'nick'}, $reason);
      &del_socket($FXsock{'list'}{$_}{'sock'});
      return(0);
    }
  }

  &putsock($socket, $FXmsg{'no_user'}, $target);
  return(0);
}

sub dcc_motd {
  my $socket = shift;

  &send_motd($socket, $FXcfg{'files'}{'motd'});
  &servicelog($socket, undef, "MOTD");
  return(0);
}

sub dcc_link {
  my ($socket, $bot) = (shift, shift);

  if (!&valid_oper($socket, "o")) {
    &putsock($socket, $FXmsg{'no_priv'});
    return(0);
  }

  if (!$bot) {
    &putsock($socket, $FXmsg{'syntax'}, "LINK <botnick>");
    return(0);
  }

  $bot = (split(/ /, $bot, 0))[0];

  foreach (keys(%FXbnet)) {
    if (lc($FXbnet{$_}{'nick'}) eq lc($bot)) {
      if ($FXbnet{$_}{'sock'}) {
        &putsock($socket, $FXmsg{'bot_linked'}, $FXbnet{$_}{'nick'});
        return(0);
      } else {
        &servicelog($socket, undef, "LINK %s", $FXbnet{$_}{'nick'});
        &putsock($socket, $FXmsg{'bot_attempt'}, $FXbnet{$_}{'nick'}, $FXbnet{$_}{'host'}, $FXbnet{$_}{'port'});
        &connect_bot($bot);
        return(0);
      }
    }
  }

  &putsock($socket, $FXmsg{'no_bot'}, $bot);
  return(0);
}

sub dcc_unlink {
  my ($socket, $arg) = (shift, shift);

  if (!&valid_oper($socket, "o")) {
    &putsock($socket, $FXmsg{'no_priv'});
    return(0);
  }

  if (!$arg) {
    &putsock($socket, $FXmsg{'syntax'}, "UNLINK <botnick> [reason]");
    return(0);
  }

  my $bot = (split(/ /, $arg, 0))[0];
  my $reason = (split(/ /, $arg, 2))[1];

  foreach (keys(%FXbnet)) {
    if (lc($FXbnet{$_}{'nick'}) eq lc($bot)) {
      if ($FXbnet{$_}{'sock'}) {
        &servicelog($socket, undef, "UNLINK %s %s", $FXbnet{$_}{'nick'}, $reason);

        if (!$reason) {
          $reason = $FXsock{'list'}{$socket}{'oper'};
        } else {
          $reason = $FXsock{'list'}{$socket}{'oper'} . ": " . $reason;
        }

        &putsock($FXbnet{$_}{'sock'}, "(%s) Unlinked from %s (%s)", $FXbot{'DataServ'}{'nick'}, $FXbnet{$_}{'nick'}, $reason);
        &putinfo("b", "Unlinked from %s (%s)", $FXbnet{$_}{'nick'}, $reason);
        &del_socket($FXbnet{$_}{'sock'});
        return(0);
      } else {
        &putsock($socket, $FXmsg{'no_bot'}, $bot);
        return(0);
      }
    }
  }

  &putsock($socket, $FXmsg{'no_bot'}, $bot);
  return(0);
}

1;