use strict;

our (%FXbot, %FXserv, %FXoper, %FXirc, %FXmsg, %FXcfg, %FXsock, $LangPack);

$FXbot{'FindServ'}{'sub'} = {
  'HELP'      => \&fs_help,
  'A9'        => \&fs_a9,
  'ALTAVISTA' => \&fs_altavista,
  'FRESHMEAT' => \&fs_freshmeat,
  'GOOGLE'    => \&fs_google,
  'LOOKSMART' => \&fs_looksmart,
  'LYCOS'     => \&fs_lycos,
  'SLASHDOT'  => \&fs_slashdot,
  'YAHOO'     => \&fs_yahoo,
  'ED2K'      => \&fs_ed2k,
  'CDDB'      => \&fs_cddb,
  'SHOUTCAST' => \&fs_shoutcast,
  'WHOIS'     => \&fs_whois,
  'DNS'       => \&fs_nslookup,
  'NSLOOKUP'  => \&fs_nslookup
};

$FXbot{'FindServ'}{'public_sub'} = {
  'A9'        => \&fs_a9,
  'ALTAVISTA' => \&fs_altavista,
  'FRESHMEAT' => \&fs_freshmeat,
  'GOOGLE'    => \&fs_google,
  'LOOKSMART' => \&fs_looksmart,
  'LYCOS'     => \&fs_lycos,
  'SLASHDOT'  => \&fs_slashdot,
  'YAHOO'     => \&fs_yahoo,
  'WHOIS'     => \&fs_whois,
  #'ED2K'      => \&fs_ed2k,
  #'EDONKEY'   => \&fs_ed2k,
  'CDDB'      => \&fs_cddb,
  'SHOUTCAST' => \&fs_shoutcast,
  'DNS'       => \&fs_nslookup,
  'NSLOOKUP'  => \&fs_nslookup
};

$FXbot{'FindServ'}{'other_sub'} = {
  'process_fs' => \&process_fs,
  'fs_notice'  => \&fs_notice,
  'fs_ctcp'    => \&fs_ctcp
};

my $whois = {
  'COM'    => 'whois.crsnic.net',
  'NET'    => 'whois.crsnic.net',
  'EDU'    => 'whois.educause.net',
  'ORG'    => 'whois.publicinterestregistry.net',
  'PRO'    => 'whois.nic.pro',
  'ARPA'   => 'whois.arin.net',
  'RIPE'   => 'whois.ripe.net',
  'MIL'    => 'whois.nic.mil',
  'COOP'   => 'whois.nic.coop',
  'MUSEUM' => 'whois.museum',
  'BIZ'    => 'whois.neulevel.biz',
  'INFO'   => 'whois.afilias.net',
  'NAME'   => 'whois.nic.name',
  'GOV'    => 'whois.nic.gov',
  'AERO'   => 'whois.information.aero',
  'AC' => 'whois.nic.ac',
  'AD' => 'whois.ripe.net',
  'AE' => 'whois.uaenic.ae',
  'AG' => 'whois.nic.ag',
  'AL' => 'whois.ripe.net',
  'AM' => 'whois.amnic.net',
  'AS' => 'whois.nic.as',
  'AT' => 'whois.nic.at',
  'AU' => 'box2.aunic.net',
  'AZ' => 'whois.ripe.net',
  'BA' => 'whois.ripe.net',
  'BE' => 'whois.dns.be',
  'BG' => 'whois.ripe.net',
  'BR' => 'whois.nic.br',
  'BY' => 'whois.ripe.net',
  'CA' => 'eider.cira.ca',
  'CC' => 'whois.nic.cc',
  'CH' => 'domex.switch.ch',
  'CK' => 'whois.ck-nic.org.ck',
  'CL' => 'nic.cl',
  'CN' => 'log.cnnic.net.cn',
  'CX' => 'whois.nic.cx',
  'CY' => 'whois.ripe.net',
  'CZ' => 'dc1.eunet.cz',
  'DE' => 'whois.denic.de',
  'DK' => 'whois.dk-hostmaster.dk',
  'DO' => 'ns.nic.do',
  'DZ' => 'whois.ripe.net',
  'EE' => 'whois.ripe.net',
  'EG' => 'whois.ripe.net',
  'ES' => 'whois.ripe.net',
  'FI' => 'whois.ripe.net',
  'FO' => 'whois.ripe.net',
  'FR' => 'winter.nic.fr',
  'GA' => 'whois.ripe.net',
  'GB' => 'whois.ripe.net',
  'GE' => 'whois.ripe.net',
  'GL' => 'whois.ripe.net',
  'GM' => 'whois.ripe.net',
  'GR' => 'whois.ripe.net',
  'GS' => 'whois.adamsnames.tc',
  'HK' => 'whois.hkdnr.net.hk',
  'HR' => 'whois.ripe.net',
  'HU' => 'whois.nic.hu',
  'ID' => 'muara.idnic.net.id',
  'IE' => 'whois.domainregistry.ie',
  'IL' => 'whois.isoc.org.il',
  'IN' => 'whois.ncst.ernet.in',
  'IS' => 'horus.isnic.is',
  'IT' => 'whois.nic.it',
  'JO' => 'whois.ripe.net',
  'JP' => 'whois.nic.ad.jp',
  'KG' => 'whois.domain.kg',
  'KH' => 'whois.nic.net.kh',
  'KR' => 'whois.krnic.net',
  'LA' => 'whois.nic.la',
  'LI' => 'domex.switch.ch',
  'LK' => 'arisen.nic.lk',
  'LT' => 'ns.litnet.lt',
  'LU' => 'whois.dns.lu',
  'LV' => 'whois.ripe.net',
  'MA' => 'whois.ripe.net',
  'MC' => 'whois.ripe.net',
  'MD' => 'whois.ripe.net',
  'MM' => 'whois.nic.mm',
  'MS' => 'whois.adamsnames.tc',
  'MT' => 'whois.ripe.net',
  'MX' => 'whois.nic.mx',
  'NL' => 'gw.domain-registry.nl',
  'NO' => 'ask.norid.no',
  'NU' => 'whois.worldnames.net',
  'NZ' => 'akl-iis.domainz.net.nz',
  'PL' => 'nazgul.nask.waw.pl',
  'PT' => 'whois.ripe.net',
  'RO' => 'whois.rotld.ro',
  'RU' => 'whois.ripn.net',
  'SE' => 'ear.nic-se.se',
  'SG' => 'qs.nic.net.sg',
  'SH' => 'whois.nic.sh',
  'SI' => 'whois.arnes.si',
  'SK' => 'whois.ripe.net',
  'SM' => 'whois.ripe.net',
  'ST' => 'whois.nic.st',
  'SU' => 'whois.ripn.net',
  'TC' => 'whois.adamsnames.tc',
  'TF' => 'whois.adamsnames.tc',
  'TH' => 'whois.thnic.net',
  'TJ' => 'whois.nic.tj',
  'TN' => 'whois.ripe.net',
  'TO' => 'whois.tonic.to',
  'TR' => 'whois.ripe.net',
  'TW' => 'whois.twnic.net',
  'UA' => 'whois.net.ua',
  'UK' => 'whois.nic.uk',
  'US' => 'whois.nic.us',
  'VA' => 'whois.ripe.net',
  'VG' => 'whois.adamsnames.tc',
  'WS' => 'whois.worldsite.ws',
  'YU' => 'whois.ripe.net',
  'ZA' => 'apies.frd.ac.za'
};

sub fs_notice {
  my ($nick, $format, @arg) = (shift, shift, @_);
  my $buffer = sprintf($format, @arg);

  &putsock($FXsock{'irc'}, ":%s %s %s :%s", $FXbot{'FindServ'}{'nick'}, $FXcfg{'general'}{'communicate'}, $nick, $buffer);
  return(0);
}

sub fs_ctcp {
  my ($nick, $notice, $format, @arg) = (shift, shift, @_);
  my $buffer = sprintf($format, @arg);

  &putsock($FXsock{'irc'}, ":%s %s %s :\cA%s\cA", $FXbot{'FindServ'}{'nick'}, $notice ? "NOTICE" : "PRIVMSG", $nick, $buffer);
  return(0);
}

sub process_fs {
  my ($nick, $query) = (shift, shift);

  if (&check_flood($nick)) { return(0); }

  if ($query =~ /\cA(.*)\cA/) {
    my $ctcp = uc((split(/ /, $1, 0))[0]);

    if ($ctcp eq "VERSION") {
      &fs_ctcp($nick, 1, "VERSION %s", "FXserv IRC Services $FXserv{'version'}");
      &fs_ctcp($nick, 1, "VERSION %s", "Administrator: $FXserv{'admin'}");
      &putinfo("y", "%s: CTCP [%s] received from %s!%s\@%s", $FXbot{'FindServ'}{'nick'}, $ctcp, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    } elsif ($ctcp eq "PING") {
      &fs_ctcp($nick, 1, "PING %s", (split(/ /, $1, 0))[1]);
      &putinfo("y", "%s: CTCP [%s] received from %s!%s\@%s", $FXbot{'FindServ'}{'nick'}, $ctcp, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    } elsif ($ctcp eq "TIME") {
      &fs_ctcp($nick, 1, "TIME %s", scalar localtime());
      &putinfo("y", "%s: CTCP [%s] received from %s!%s\@%s", $FXbot{'FindServ'}{'nick'}, $ctcp, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    } else {
      &putinfo("y", "%s: CTCP [%s] received from %s!%s\@%s", $FXbot{'FindServ'}{'nick'}, $1, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    }

    return(0);
  }

  my $cmd = (split(/ /, $query, 0))[0];
  my $arg = (split(/ /, $query, 2))[1];

  if ($FXbot{'FindServ'}{'sub'}->{uc($cmd)}) {
    &{$FXbot{'FindServ'}{'sub'}->{uc($cmd)}}($nick, $arg);
  } else {
    &fs_notice($nick, $FXmsg{'unkn_cmd'}, $cmd);
  }

  return(0);
}

sub fs_help {
  my ($nick, $arg) = (shift, shift);

  if (!$arg) { $arg = "index"; }

  my $file = lc($arg);
  $file =~ s/ /\//g;
  $file = "help/" . $LangPack . "/findserv/" . $file;

  if (!open(FILE, "<" . $file)) {
    &fs_notice($nick, $FXmsg{'no_help'}, $arg);
    return(0);
  }

  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer = &substitute($buffer);

    if ($buffer =~ /^\%\+a/) {
      if (&valid_oper($nick, "a")) {
        $buffer =~ s/^\%\+a//;
        &fs_notice($nick, $buffer);
      }
    } elsif ($buffer =~ /^\%\+o/) {
      if (&valid_oper($nick, "o")) {
        $buffer =~ s/^\%\+o//;
        &fs_notice($nick, $buffer);
      }
    } else {
      &fs_notice($nick, $buffer);
    }
  }

  &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "HELP %s", $arg);
  return(0);
}

sub fs_a9 {
  my ($nick, $keyword) = (shift, shift);

  if (!$keyword) {
    &fs_notice($nick, $FXmsg{'syntax'}, "A9 <keywords>");
    return(0);
  }

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my $socket = &open_socket("tcp", "a9.com", 80, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      exit(0);
    }

    $socket->autoflush(1);

    my $query = $keyword; $query =~ tr/ /\%20/;
    my $desc = "";
    my $link = "";
    my $idx = 0;
    my $nodoc = 0;

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      &http_get($socket, "/" . $query, "a9.com", undef, undef);

      &fs_notice($nick, $FXmsg{'search_result'}, "A9", $keyword);
      while (my $buffer = <$socket>) {
        $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;
        $buffer =~ s/<b>//g; $buffer =~ s/<\/b>//g; $buffer =~ s/<wbr>//g;

        if (!$idx && ($buffer =~ /^<p>There are no search results for this query.<\/p>$/)) {
          &fs_notice($nick, $FXmsg{'no_doc'}, $keyword);
          $nodoc = 1;
          last;
        } else {
          if (!$desc) { ($desc) = $buffer =~ /^<a href="\S+" class="r-a" isData="true">(.*)<\/a>$/; $desc =~ s/&#39;/'/g; $desc =~ s/&amp;/&/g; $desc =~ s/&quot;/"/g; }
          if ($desc && !$link) { ($link) = $buffer =~ /^<span class="r-url"><a href="\S+" class="r-url" isData="true">(\S+)$/; }
          if ($desc && $link) {
            if (++$idx > $FXbot{'FindServ'}{'search_limit'}) { last; }
            &fs_notice($nick, "%d) %s", $idx, $desc);
            &fs_notice($nick, "   %s", $link);
            $desc = "";
            $link = "";
          }
        }
      }

      alarm(0);
    };

    close($socket);

    if (!$idx && !$nodoc) { &fs_notice($nick, $FXmsg{'no_doc'}, $keyword); }
    &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "A9 %s", $keyword);
    exit(0);
  }
}

sub fs_altavista {
  my ($nick, $keyword) = (shift, shift);

  if (!$keyword) {
    &fs_notice($nick, $FXmsg{'syntax'}, "ALTAVISTA <keywords>");
    return(0);
  }

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my $socket = &open_socket("tcp", "www.altavista.com", 80, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      exit(0);
    }

    my $query = $keyword; $query =~ tr/ /+/;
    my $desc = "";
    my $link = "";
    my $idx = 0;
    my $nodoc = 0;

    $socket->autoflush(1);

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      &http_get($socket, "/web/results?q=" . $query . "&kgs=0&kls=0", "www.altavista.com", undef, undef);

      my $lines = "";

      &fs_notice($nick, $FXmsg{'search_result'}, "AltaVista", $keyword);

      while (my $buffer = <$socket>) {
        $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;
        $buffer =~ s/<b>//g; $buffer =~ s/<\/b>//g;

        if (!$idx && ($buffer =~ /^<span class=m><span class=y>We found 0 results. Suggestions:<\/span><\/span><br>/)) {
          &fs_notice($nick, $FXmsg{'no_doc'}, $keyword);
          $nodoc = 1;
          last;
        } else {
          $lines .= $buffer;
          if ($buffer =~ /<\/html>/) { last; }
        }
      }

      foreach my $line (split(/<br class='lb'>/, $lines)) {
        if (!$desc) { ($desc) = $line =~ /^<a class='res' href='\S+\*\*\S+'>(.*)<\/a><br>/; $desc =~ s/&amp;/&/g; $desc =~ s/&quot;/"/g; $desc =~ s/&#39;/'/g; }
        if (!$link) { ($link) = $line =~ /^<a class='res' href='\S+\*\*(\S+)'>.*<\/a><br>/; $link =~ s/%([\dA-Fa-f]{2})/pack("C", hex($1))/eg; }
        if ($desc && $link) {
          if (++$idx > $FXbot{'FindServ'}{'search_limit'}) { last; }
          &fs_notice($nick, "%d) %s", $idx, $desc);
          &fs_notice($nick, "   %s", $link);
          $desc = "";
          $link = "";
        }
      }

      alarm(0);
    };

    close($socket);

    if (!$idx && !$nodoc) { &fs_notice($nick, $FXmsg{'no_doc'}, $keyword); }
    &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "ALTAVISTA %s", $keyword);
    exit(0);
  }
}

sub fs_freshmeat {
  my ($nick, $keyword) = (shift, shift);

  if (!$keyword) {
    &fs_notice($nick, $FXmsg{'syntax'}, "FRESHMEAT <keywords>");
    return(0);
  }

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my $socket = &open_socket("tcp", "freshmeat.net", 80, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      exit(0);
    }

    my $query = $keyword; $query =~ tr/ /+/;
    my $proj = "";
    my $desc = "";
    my $link = "";
    my $idx = 0;
    my $nodoc = 0;

    $socket->autoflush(1);

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      &http_get($socket, "/search/?q=" . $query . "&section=projects&Go.x=0&Go.y=0", "freshmeat.net", undef, undef);

      &fs_notice($nick, $FXmsg{'search_result'}, "freshmeat.net", $keyword);

      while (my $buffer = <$socket>) {
        $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;
        $buffer =~ s/<b>//g; $buffer =~ s/<\/b>//g; $buffer =~ s/<b style="background: #FFFF00">//g;

        if (!$idx && ($buffer =~ /^<ul>No matches.<\/ul>$/)) {
          &fs_notice($nick, $FXmsg{'no_doc'}, $keyword);
          $nodoc = 1;
          last;
        } else {
          if (!$proj) { ($proj) = $buffer =~ /^<a href="\/projects\/\S+">(.*)<\/a>$/; }
          if (!$desc) { ($desc) = $buffer =~ /^<br>(.*)<\/td>$/; }
          if (!$link) { ($link) = $buffer =~ /<a href="\/projects\/(\S+)">.*<\/a>$/; }
          if ($proj && $desc && $link) {
            if (++$idx > $FXbot{'FindServ'}{'search_limit'}) { last; }
            &fs_notice($nick, "%d) %s: %s", $idx, $proj, $desc);
            &fs_notice($nick, "   http://freshmeat.net/projects/%s", $link);
            $proj = "";
            $desc = "";
            $link = "";
          }
        }
      }

      alarm(0);
    };

    close($socket);

    if (!$idx && !$nodoc) { &fs_notice($nick, $FXmsg{'no_doc'}, $keyword); }
    &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "FRESHMEAT %s", $keyword);
    exit(0);
  }
}

sub fs_google {
  my ($nick, $keyword) = (shift, shift);

  if (!$keyword) {
    &fs_notice($nick, $FXmsg{'syntax'}, "GOOGLE [options] <keywords>");
    return(0);
  }

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my $socket = &open_socket("tcp", "www.google.com", 80, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      exit(0);
    }

    my $query = $keyword; $query =~ tr/ /+/;
    my $desc = "";
    my $link = "";
    my $idx = 0;
    my $nodoc = 0;

    $socket->autoflush(1);

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      &http_get($socket, "/search?hl=en&ie=ISO-8859-1&q=" . $query, "www.google.com", undef, undef);

      my $lines = "";

      &fs_notice($nick, $FXmsg{'search_result'}, "Google", $keyword);

      while (my $buffer = <$socket>) {
        $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;
        $buffer =~ s/<b>//g; $buffer =~ s/<\/b>//g;

        if (!$idx && ($buffer =~ /^<br><br>Your search - $keyword - did not match any documents./)) {
          &fs_notice($nick, $FXmsg{'no_doc'}, $keyword);
          $nodoc = 1;
          last;
        } else {
          $lines .= $buffer;
          if ($buffer =~ /<\/html>/) { last; }
        }
      }

      foreach my $line (split(/<p class=g>/, $lines)) {
        if (!$desc) { ($desc) = $line =~ /^<a href=\S+>(.*)<\/a>(<br>)?(<table |<font size=-1>)/; $desc =~ s/&amp;/&/g; $desc =~ s/&quot;/"/g; $desc =~ s/&#39;/'/g; utf8::decode($desc); }
        if (!$link) { ($link) = $line =~ /^<a href=(\S+)>.*<\/a>(<br>)?(<table |<font size=-1>)/; }
        if ($desc && $link) {
          if (++$idx > $FXbot{'FindServ'}{'search_limit'}) { last; }
          &fs_notice($nick, "%d) %s", $idx, $desc);
          &fs_notice($nick, "   %s", $link);
          $desc = "";
          $link = "";
        }
      }

      alarm(0);
    };

    close($socket);

    if (!$idx && !$nodoc) { &fs_notice($nick, $FXmsg{'no_doc'}, $keyword); }
    &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "GOOGLE %s", $keyword);
    exit(0);
  }
}

sub fs_looksmart {
  my ($nick, $keyword) = (shift, shift);

  if (!$keyword) {
    &fs_notice($nick, $FXmsg{'syntax'}, "LOOKSMART <keywords>");
    return(0);
  }

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my $socket = &open_socket("tcp", "search.looksmart.com", 80, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      return(0);
    }

    my $query = $keyword; $query =~ tr/ /+/;
    my $desc = "";
    my $link = "";
    my $idx = 0;
    my $nodoc = 0;

    $socket->autoflush(1);

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      &http_get($socket, "/p/search?tb=dir&qt=" . $query, "search.looksmart.com", undef, undef);

      &fs_notice($nick, $FXmsg{'search_result'}, "LookSmart", $keyword);
      while (my $buffer = <$socket>) {
        $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;
        $buffer =~ s/<strong>//g; $buffer =~ s/<\/strong>//g;

        if (!$idx && ($buffer =~ /No results found for your query from the Directory or the Web/)) {
          &fs_notice($nick, $FXmsg{'no_doc'}, $keyword);
          $nodoc = 1;
          last;
        } else {
          if (!$desc) { ($desc) = $buffer =~ /^<li ><a href="\S+">(.*)<\/a><br \/>$/; }
          if (!$link) { ($link) = $buffer =~ /^<span class="displayUrl">(\S+)<\/span><br \/>$/; }

          if (!$desc) { ($desc) = $buffer =~ /^<li><a href="\S+">(.*)<\/a><br \/>$/; }
          if (!$link) { ($link) = $buffer =~ /^<li><a href="(\S+)">.*<\/a><br \/>$/; }
          if ($desc && $link) {
            if (++$idx > $FXbot{'FindServ'}{'search_limit'}) { last; }
            &fs_notice($nick, "%d) %s", $idx, $desc);
            &fs_notice($nick, "   %s", $link);
            $desc = "";
            $link = "";
          }
        }
      }

      alarm(0);
    };

    close($socket);

    if (!$idx && !$nodoc) { &fs_notice($nick, $FXmsg{'no_doc'}, $keyword); }
    &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "LOOKSMART %s", $keyword);
    exit(0);
  }
}

sub fs_lycos {
  my ($nick, $keyword) = (shift, shift);

  if (!$keyword) {
    &fs_notice($nick, $FXmsg{'syntax'}, "LYCOS <keywords>");
    return(0);
  }

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my $socket = &open_socket("tcp", "search.lycos.com", 80, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      exit(0);
    }

    my $query = $keyword; $query =~ tr/ /+/;
    my $desc = "";
    my $link = "";
    my $idx = 0;
    my $nodoc = 0;

    $socket->autoflush(1);

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      &http_get($socket, "/default.asp?lpv=1&loc=searchhp&tab=web&query=" . $query . "&x=0&y=0", "search.lycos.com", undef, undef);

      &fs_notice($nick, $FXmsg{'search_result'}, "Lycos", $keyword);
      while (my $buffer = <$socket>) {
        $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;
        $buffer =~ s/<b>//g; $buffer =~ s/<\/b>//g;

        if (!$idx && ($buffer =~ /^<tr><td><a name="dir"><font face=verdana size=-1>There are no WEB results for this search term<\/font><\/a><\/td><\/tr>$/)) {
          &fs_notice($nick, $FXmsg{'no_doc'}, $keyword);
          $nodoc = 1;
          last;
        } else {
          if (!$desc) { ($desc) = $buffer =~ /onclick="return kr2\(this,'.*?','\d+',''\)">(.*)<\/a><br>/; }
          if (!$link) { ($link) = $buffer =~ /<a class="sm" href="(\S+)" onclick="return kr2\(this,'.*?','\d+',''\)">/; }
          if (!$link) { ($link) = $buffer =~ /<a class="sm" onmouseover="return sb\('(\S+)'\);" onfocus/; }
          if ($desc && $link) {
            if (++$idx > $FXbot{'FindServ'}{'search_limit'}) { last; }
            &fs_notice($nick, "%d) %s", $idx, $desc);
            &fs_notice($nick, "   %s", $link);
            $desc = "";
            $link = "";
          }
        }
      }

      alarm(0);
    };

    close($socket);

    if (!$idx && !$nodoc) { &fs_notice($nick, $FXmsg{'no_doc'}, $keyword); }
    &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "LYCOS %s", $keyword);
    exit(0);
  }
}

sub fs_slashdot {
  my ($nick, $keyword) = (shift, shift);

  if (!$keyword) {
    &fs_notice($nick, $FXmsg{'syntax'}, "SLASHDOT <keywords>");
    return(0);
  }

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my $socket = &open_socket("tcp", "slashdot.org", 80, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      exit(0);
    }

    my $query = $keyword; $query =~ tr/ /+/;
    my $arti = "";
    my $date = "";
    my $link = "";
    my $idx = 0;
    my $nodoc = 0;

    $socket->autoflush(1);

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      &http_get($socket, "/search.pl?query=" . $query, "slashdot.org", undef, undef);

      &fs_notice($nick, $FXmsg{'search_result'}, "Slashdot", $keyword);
      while (my $buffer = <$socket>) {
        $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;

        if (!$idx && ($buffer =~ /^<\/FORM>No stories were found that match your query.<\/TR>$/)) {
          &fs_notice($nick, $FXmsg{'no_doc'}, $keyword);
          $nodoc = 1;
          last;
        } else {
          if (!$arti) { ($arti) = $buffer =~ /<A HREF="\/\/slashdot\.org\/article\.pl\?sid=\S+">(.*)<\/A>$/; }
          if (!$date) { ($date) = $buffer =~ /<FONT SIZE="-1">On (.*)<\/FONT><BR>/; }
          if (!$link) { ($link) = $buffer =~ /<A HREF="\/\/slashdot\.org\/article\.pl\?sid=(\S+)">.*<\/A>$/; }
          if ($arti && $date && $link) {
            if (++$idx > $FXbot{'FindServ'}{'search_limit'}) { last; }
            &fs_notice($nick, "%d) %s (%s)", $idx, $arti, $date);
            &fs_notice($nick, "   http://slashdot.org/article.pl?sid=%s", $link);
            $arti = "";
            $date = "";
            $link = "";
          }
        }
      }

      alarm(0);
    };

    close($socket);

    if (!$idx && !$nodoc) { &fs_notice($nick, $FXmsg{'no_doc'}, $keyword); }
    &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "SLASHDOT %s", $keyword);
    exit(0);
  }
}

sub fs_yahoo {
  my ($nick, $keyword) = (shift, shift);

  if (!$keyword) {
    &fs_notice($nick, $FXmsg{'syntax'}, "YAHOO <keywords>");
    return(0);
  }

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my $socket = &open_socket("tcp", "search.yahoo.com", 80, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      return(0);
    }

    my $query = $keyword; $query =~ tr/ /+/;
    my $desc = "";
    my $link = "";
    my $idx = 0;
    my $nodoc = 0;

    $socket->autoflush(1);

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      &http_get($socket, "/search?fr=fp-pull-web-t&p=" . $query, "search.yahoo.com", undef, undef);

      &fs_notice($nick, $FXmsg{'search_result'}, "Yahoo!", $keyword);
      while (my $buffer = <$socket>) {
        $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;
        $buffer =~ s/<b>//g; $buffer =~ s/<\/b>//g;

        if (!$idx && ($buffer =~ /^We didn't find any&nbsp;Web pages containing/)) {
          &fs_notice($nick, $FXmsg{'no_doc'}, $keyword);
          $nodoc = 1;
          last;
        } else {
          if (!$desc) { ($desc) = $buffer =~ /^<li><a class=yschlp href="\S+">(.*)<\/a>$/; }
          if (!$link) { ($link) = $buffer =~ /^<li><a class=yschlp href="http:\/\/rds.yahoo.com\/\S+\/*-(\S+)">/; }
          if ($desc && $link) {
            if (++$idx > $FXbot{'FindServ'}{'search_limit'}) { last; }
            &fs_notice($nick, "%d) %s", $idx, $desc);
            &fs_notice($nick, "   %s", $link);
            $desc = "";
            $link = "";
          }
        }
      }

      alarm(0);
    };

    close($socket);

    if (!$idx && !$nodoc) { &fs_notice($nick, $FXmsg{'no_doc'}, $keyword); }
    &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "YAHOO %s", $keyword);
    exit(0);
  }
}

sub fs_whois {
  my ($nick, $domain) = (shift, shift);
  my $lastdot = rindex($domain, ".");
  my $suffix = uc(substr($domain, ++$lastdot));

  if (!$domain) {
    &fs_notice($nick, $FXmsg{'syntax'}, "WHOIS <domain>");
    return(0);
  }

  my $nomatch = 0;
  my $skip = 1;
  my $server = $whois->{uc($suffix)};

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my $socket = &open_socket("tcp", $server ? $server : "whois.ripe.net", 43, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      exit(0);
    }

    $socket->autoflush(1);

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      &putsock($socket, "%s\r", $domain);

      while (my $buffer = <$socket>) {
        $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;
        if ($buffer =~ /^No match for/) {
          $nomatch = 1;
          last;
        } elsif ($buffer =~ /^Domain Name: (\S+)$/) {
          if (uc($1) eq uc($domain)) { $skip = 0; }
        } elsif (!$skip && ($buffer =~ /^Whois Server: (\S+)$/)) {
          $server = $1;
          last;
        }
      }

      alarm(0);
    };

    close($socket);

    if ($nomatch) {
      &fs_notice($nick, $FXmsg{'no_match'}, $domain);
      exit(0);
    } elsif (!$server) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      exit(0);
    }

    $socket = &open_socket("tcp", $server, 43, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      exit(0);
    }

    $socket->autoflush(1);

    &fs_notice($nick, "-- WHOIS result for domain [%s] --", $domain);

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      &putsock($socket, "%s\r", $domain);

      while (<$socket>) { &fs_notice($nick, $_); }

      alarm(0);
    };

    close($socket);

    &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "WHOIS %s", $domain);
    exit(0);
  }
}

sub fs_nslookup {
  my ($nick, $query) = (shift, shift);

  if (!$query) {
    &fs_notice($nick, $FXmsg{'syntax'}, "NSLOOKUP <domain|ip>");
    return(0);
  }

  my @ip = ();
  my $addr = "";
  my $result = "";
 
  if ($query =~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/) {
    $addr = pack("C4", split(/\./, $query));
    $result = gethostbyaddr($addr, &AF_INET);
  } else {
    @ip = unpack("C4", (gethostbyname($query))[4]);
    $result = join("\.", @ip);
  }

  if ($result) {
    &fs_notice($nick, $FXmsg{'dns_resolv'}, $query, $result);
  } else {
    &fs_notice($nick, $FXmsg{'dns_unable'}, $query);
  }

  &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "NSLOOKUP %s", $query);
  return(0);
}

sub fs_ed2k {
  my ($nick, $keyword) = (shift, shift);

  if (!$keyword) {
    &fs_notice($nick, $FXmsg{'syntax'}, "ED2K <keywords>");
    return(0);
  }

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my ($server, $port) = split(/:/, $FXbot{'FindServ'}{'search_ed2k'}, 2);
    my $socket = &open_socket("udp", $server, $port, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      return(0);
    }

    my $query = $keyword; $query =~ tr/ /+/;
    my $desc = "";
    my $link = "";
    my $idx = 0;
    my $nodoc = 0;

    $socket->autoflush(1);

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      #x

      alarm(0);
    };

    close($socket);

    if (!$idx && !$nodoc) { &fs_notice($nick, $FXmsg{'no_doc'}, $keyword); }
    &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "ED2K %s", $keyword);
    exit(0);
  }
}

sub fs_cddb {
  my ($nick, $keyword) = (shift, shift);

  if (!$keyword) {
    &fs_notice($nick, $FXmsg{'syntax'}, "CDDB <keywords>");
    return(0);
  }

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my $socket = &open_socket("tcp", "www.freedb.org", 80, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      return(0);
    }

    my $query = $keyword; $query =~ tr/ /+/;
    my $desc = "";
    my $link = "";
    my $idx = 0;
    my $nodoc = 0;

    $socket->autoflush(1);

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      &http_get($socket, "/freedb_search.php?words=" . $query . "&allfields=NO&fields=artist&fields=title&allcats=YES&grouping=none&x=0&y=0", "www.freedb.org", undef, undef);

      &fs_notice($nick, $FXmsg{'search_result'}, "CDDB", $keyword);
      while (my $buffer = <$socket>) {
        $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;
        $buffer =~ s/<b>//g; $buffer =~ s/<\/b>//g;

        if (!$idx && ($buffer =~ /^<\/html>$/)) {
          &fs_notice($nick, $FXmsg{'no_doc'}, $keyword);
          $nodoc = 1;
          last;
        } else {
          if (!$desc) { ($desc) = $buffer =~ /^<tr><td><a href="\S+">(.*)<\/a><br><br><\/tr>$/; }
          if (!$link) { ($link) = $buffer =~ /^<tr><td><a href="(\S+)">.*<\/a><br><br><\/tr>$/; }
          if ($desc && $link) {
            if (++$idx > $FXbot{'FindServ'}{'search_limit'}) { last; }
            &fs_notice($nick, "%d) %s", $idx, $desc);
            &fs_notice($nick, "   %s", $link);
            $desc = "";
            $link = "";
          }
        }
      }

      alarm(0);
    };

    close($socket);

    if (!$idx && !$nodoc) { &fs_notice($nick, $FXmsg{'no_doc'}, $keyword); }
    &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "CDDB %s", $keyword);
    exit(0);
  }
}

sub fs_shoutcast {
  my ($nick, $keyword) = (shift, shift);

  if (!$keyword) {
    &fs_notice($nick, $FXmsg{'syntax'}, "SHOUTCAST <keywords>");
    return(0);
  }

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my $socket = &open_socket("tcp", "www.shoutcast.com", 80, $FXbot{'FindServ'}{'search_timeout'});

    if (!$socket) {
      &fs_notice($nick, $FXmsg{'serv_down'});
      return(0);
    }

    my $query = $keyword; $query =~ tr/ /+/;
    my $desc = "";
    my $link = "";
    my $play = "";
    my $idx = 0;
    my $nodoc = 0;

    $socket->autoflush(1);

    eval {
      local $SIG{'ALRM'} = sub { die(); };
      alarm($FXbot{'FindServ'}{'search_timeout'});

      &http_get($socket, "/directory/?s=" . $query . "&x=0&y=0&numresult=25", "www.shoutcast.com", undef, undef);

      &fs_notice($nick, $FXmsg{'search_result'}, "SHOUTcast", $keyword);
      while (my $buffer = <$socket>) {
        $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;
        $buffer =~ s/<b>//g; $buffer =~ s/<\/b>//g;

        if (!$idx && ($buffer =~ /Unfortunately, there weren't any SHOUTcast streams found containing the term/)) {
          &fs_notice($nick, $FXmsg{'no_doc'}, $keyword);
          $nodoc = 1;
          last;
        } else {
          if (!$desc) { ($desc) = $buffer =~ /<a id="listlinks" target="_scurl" href="\S+">(.*)<\/a><br>$/; }
          if (!$link) { ($link) = $buffer =~ /^<td nowrap align="center" bgcolor="#001E5A"><a href="(\S+)"><img/; }
          if (!$play) { ($play) = $buffer =~ /^<font size="1"><font color="#FF0000">Now Playing:<\/font> (.*)<\/font><\/font><\/td>$/; }
          if ($desc && $link && $play) {
            if (++$idx > $FXbot{'FindServ'}{'search_limit'}) { last; }
            &fs_notice($nick, "%d) %s", $idx, $desc);
            &fs_notice($nick, "   http://www.shoutcast.com%s", $link);
            &fs_notice($nick, "   Now playing: %s", $play);
            $desc = "";
            $link = "";
            $play = "";
          }
        }
      }

      alarm(0);
    };

    close($socket);

    if (!$idx && !$nodoc) { &fs_notice($nick, $FXmsg{'no_doc'}, $keyword); }
    &servicelog($nick, $FXbot{'FindServ'}{'nick'}, "SHOUTCAST %s", $keyword);
    exit(0);
  }
}

1;