use strict;

our (%FXcfg, %FXflags, %FXim, %FXirc, %FXserv, %FXbot, %FXmsg, %FXsock, %FXstats, $bind, $ts);
our %FXstatus;

$bind = {
  'PING'    => \&irc_ping,
  'NETINFO' => \&irc_netinfo,
  'SERVER'  => \&irc_server,
  'SQUIT'   => \&irc_squit,
  'ERROR'   => \&irc_error,
  'PONG'    => \&irc_pong,
  'PRIVMSG' => \&irc_privmsg,
  'NOTICE'  => \&irc_notice,
  'NICK'    => \&irc_nick,
  'MODE'    => \&irc_mode,
  'QUIT'    => \&irc_quit,
  'KICK'    => \&irc_kick,
  'TOPIC'   => \&irc_topic,
  '332'     => \&irc_topic,
  'KILL'    => \&irc_kill,
  'SJOIN'   => \&irc_sjoin,
  'PART'    => \&irc_part,
  'WHOIS'   => \&irc_whois,
  '257'     => \&irc_25X,
  '258'     => \&irc_25X,
  '259'     => \&irc_25X,
  '351'     => \&irc_351,
  'ADMIN'   => \&irc_admin,
  'VERSION' => \&irc_version
};

sub connect_irc {
  $FXserv{'attempt'} = $ts;
  $FXserv{'connected'} = 0;
  $FXserv{'ping'} = 0;
  $FXserv{'pong'} = 0;
  $FXserv{'hub'} = "";
  $FXsock{'irc'} = "";

  my $socket = &open_socket("tcp", $FXcfg{'hub'}{'host'}, $FXcfg{'hub'}{'port'}, 3);

  if (!$socket) {
    &putinfo("y", "Unable to connect to IRC server %s:%d", $FXcfg{'hub'}{'host'}, $FXcfg{'hub'}{'port'});
    return(1);
  }

  &add_socket($socket, "IRC");

  &putinfo("y", "Connected to IRC server %s:%d", $FXcfg{'hub'}{'host'}, $FXcfg{'hub'}{'port'});

  if ($FXirc{'server'}{lc($FXserv{'name'})}) {
    delete($FXirc{'server'}{lc($FXirc{'server'}{lc($FXserv{'name'})}{'hub'})});
    delete($FXirc{'server'}{lc($FXserv{'name'})});
  }

  &add_server($FXserv{'name'}, $FXserv{'info'}, $ts, 1, undef, $FXserv{'name'});
  $FXirc{'server'}{lc($FXserv{'name'})}{'version'} = "FXserv IRC Services $FXserv{'version'}";
  push(@{$FXirc{'server'}{lc($FXserv{'name'})}{'admin'}}, $FXserv{'admin'});

  if ($FXcfg{'hub'}{'type'} eq "unreal") { &putsock($FXsock{'irc'}, "PROTOCTL NOQUIT NICKv2 SJOIN SJ3"); }

  if ($FXcfg{'hub'}{'type'} =~ /^(hybrid|hybrid7|bahamut|ultimate)$/) {
    &putsock($FXsock{'irc'}, "PASS %s :TS", $FXcfg{'hub'}{'password'});
  } elsif ($FXcfg{'hub'}{'type'} eq "unreal") {
    &putsock($FXsock{'irc'}, "PASS :%s", $FXcfg{'hub'}{'password'});
  }

  if ($FXcfg{'hub'}{'type'} =~ /^(hybrid|hybrid7)$/) {
    &putsock($FXsock{'irc'}, "CAPAB :EX DE");
  } elsif ($FXcfg{'hub'}{'type'} eq "bahamut") {
    &putsock($FXsock{'irc'}, "CAPAB TS3 NOQUIT SSJOIN NICKIP");
  } elsif ($FXcfg{'hub'}{'type'} eq "ultimate") {
    &putsock($FXsock{'irc'}, "CAPAB TS5 SSJ5 NICKIP");
  }

  if ($FXcfg{'hub'}{'type'} =~ /^(hybrid|hybrid7|bahamut|ultimate)$/) {
    &putsock($FXsock{'irc'}, "SERVER %s 1 :%s", $FXserv{'name'}, $FXserv{'info'});
  } elsif ($FXcfg{'hub'}{'type'} eq "unreal") {
    &putsock($FXsock{'irc'}, "SERVER %s %d :%s", $FXserv{'name'}, $FXserv{'numeric'}, $FXserv{'info'});
  }

  if ($FXcfg{'hub'}{'type'} eq "hybrid") {
    &putsock($FXsock{'irc'}, "SVINFO 3 1 0 :%d", $ts);
  } elsif ($FXcfg{'hub'}{'type'} =~ /^(hybrid7|ultimate|bahamut)$/) {
    &putsock($FXsock{'irc'}, "SVINFO 5 3 0 :%d", $ts);
  }

  if ($FXcfg{'hub'}{'type'} eq "unreal") { &putsock($FXsock{'irc'}, ":%s EOS", $FXserv{'name'}); }

  return(0);
}

sub connected_irc {
  $FXserv{'connected'} = $ts;
  $FXserv{'ping'} = $ts;
  $FXserv{'netmerge'} = 0;

  foreach (keys(%FXbot)) {
    if (!$FXbot{$_}{'enabled'}) { next; }
    &introduce_service($FXbot{$_}{'service'});
    if ($FXbot{$_}{'channel'}) { &check_channel($FXbot{$_}{'service'}); }
  }

  if ($FXcfg{'hub'}{'type'} eq "hybrid") {
    foreach (keys(%{$FXirc{'channel'}})) { &putsock($FXsock{'irc'}, ":%s TOPIC %s", $FXserv{'name'}, $FXirc{'channel'}{$_}{'channel'}); }
  }

  foreach (keys(%{$FXirc{'server'}})) {
    if ($FXirc{'server'}{$_}{'name'} eq $FXserv{'name'}) { next; }

    &putsock($FXsock{'irc'}, ":%s VERSION %s", $FXbot{'DataServ'}{'nick'}, $FXirc{'server'}{$_}{'name'});
    &putsock($FXsock{'irc'}, ":%s ADMIN %s ", $FXbot{'DataServ'}{'nick'}, $FXirc{'server'}{$_}{'name'});
  }

  if ($FXbot{'PageServ'}{'enabled'}) {
    my $im_introduce = {
      'msn'    => \&msn_introduce,
      'yahoo'  => \&yahoo_introduce,
      'icq'    => \&icq_introduce,
      'aim'    => \&aim_introduce,
      'jabber' => \&jabber_introduce
    };

    foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
      if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }

      foreach (keys(%{$FXim{$im}{'buddies'}})) {
        if ($FXim{$im}{'buddies'}{$_}{'buddy'} && $FXim{$im}{'buddies'}{$_}{'online'} && !$FXim{$im}{'buddies'}{$_}{'ircnick'}) { &{$im_introduce->{$im}}($FXim{$im}{'buddies'}{$_}{'id'}); }
      }
    }
  }

  return(0);
}

sub irc_netinfo {
  &putsock($FXsock{'irc'}, ":%s PING :%s", $FXserv{'name'}, $FXserv{'hub'});

  &connected_irc();
  return(0);
}

sub irc_ping {
  my $buffer = shift;
  my $target = (split(/:/, $buffer, 0))[1]; $target = (split(/ /, $target, 0))[0];

  &putsock($FXsock{'irc'}, ":%s PONG %s :%s", $FXserv{'name'}, $FXserv{'name'}, $target);

  if (!$FXserv{'connected'} && ($target eq $FXserv{'hub'})) { &connected_irc(); }

  return(0);
}

sub irc_pong {
  my $buffer = shift;
  my $server = (split(/:/, $buffer, 0))[1]; $server = (split(/ /, $server, 0))[0];

  if ($FXirc{'server'}{lc($server)}{'pong'}) {
    $FXirc{'server'}{lc($server)}{'lag'} = $ts - $FXirc{'server'}{lc($server)}{'ping'};
    $FXirc{'server'}{lc($server)}{'pong'} = 0;
  }

  return(0);
}

sub irc_server {
  my $buffer = shift;
  my $server = "";
  my $info = "";
  my $hop = "";
  my $hub = "";

  if (substr($buffer, 0, 1) eq ":") {
    $server = (split(/ /, $buffer, 0))[2];
    $info = (split(/:/, $buffer, 3))[2];
    $hub = (split(/:/, $buffer, 0))[1]; $hub = (split(/ /, $hub, 0))[0];
    $hop = (split(/ /, $buffer, 0))[3];

    &add_server($server, $info, $ts, $hop, undef, $hub);
    $FXirc{'server'}{lc($hub)}{'leaf'}{lc($server)} = $FXirc{'server'}{lc($server)}{'name'};

    if ($FXserv{'connected'}) {
      &putinfo("l", "Server %s has connected to %s", $server, $hub);
      $FXserv{'netmerge'} = $ts;

      &putsock($FXsock{'irc'}, ":%s VERSION %s", $FXbot{'DataServ'}{'nick'}, $server);
      &putsock($FXsock{'irc'}, ":%s ADMIN %s ", $FXbot{'DataServ'}{'nick'}, $server);
    }

  } else {
    $server = (split(/ /, $buffer, 0))[1];
    $info = (split(/:/, $buffer, 2))[1];
    $hop = (split(/ /, $buffer, 0))[2];

    &add_server($server, $info, $ts, $hop, undef, $server);
    $FXirc{'server'}{lc($FXserv{'name'})}{'hub'} = $server;
    $FXirc{'server'}{lc($server)}{'leaf'}{lc($FXserv{'name'})} = $FXserv{'name'};
    $FXserv{'hub'} = $server;
  }

  return(0);
}

sub irc_squit {
  my $buffer = shift;

  my $server = (split(/ /, $buffer, 0))[1];
  &del_server($server);
  return(0);
}

sub irc_error {
  &del_socket($FXsock{'irc'});
  return(0);
}

sub irc_nick {
  my $buffer = shift;

  if (substr($buffer, 0, 1) eq ":") {
    my $oldnick = (split(/:/, $buffer, 0))[1]; $oldnick = (split(/ /, $oldnick, 0))[0];
    my $newnick = (split(/ /, $buffer, 0))[2];

    &add_seen($oldnick, "NICK", $newnick);
    &putinfo("n", "Nick change: %s -> %s", $oldnick, $newnick);
    &chanlog("n", undef, $oldnick, $newnick, undef);
    &rename_client($oldnick, $newnick);
    return(0);

  } else {
    my $nick = (split(/ /, $buffer, 0))[1];
    my $time = (split(/ /, $buffer, 0))[3];
    my $info = (split(/:/, $buffer, 2))[1];
    my $numeric = (split(/ /, $buffer, 0))[2];
    my $what = 1;
    my $umode = '';
    my $user = "";
    my $host = "";
    my $server = "";
    my $mode = "";

    if ($FXcfg{'hub'}{'type'} =~ /(hybrid|bahamut|ultimate)/) {
      $user = (split(/ /, $buffer, 0))[5];
      $host = (split(/ /, $buffer, 0))[6];
      $server = (split(/ /, $buffer, 0))[7];
      $mode = (split(/ /, $buffer, 0))[4];
    } elsif ($FXcfg{'hub'}{'type'} eq "unreal") {
      $user = (split(/ /, $buffer, 0))[4];
      $host = (split(/ /, $buffer, 0))[5];
      $server = (split(/ /, $buffer, 0))[6];
      $mode = (split(/ /, $buffer, 0))[8];
      if ($mode eq "*") { $mode = ""; }
    }

    foreach (split(//, $mode)) {
      if ($_ eq "+") {
        $what = 1;
      } elsif ($_ eq "-") {
        $what = 0;
      } elsif ($FXflags{'client'}{$_}) {
        if ($what) {
          $umode |= $FXflags{'client'}{$_};
        } else {
          $umode &= ~$FXflags{'client'}{$_};
        }
      }
    }

    &add_client($nick, $user, $host, $info, $numeric, $server, $time, $umode);

    if ($FXserv{'connected'} && !$FXserv{'netmerge'}) {
      &check_client($nick);
    } else {
      if ($FXbot{'ScanServ'}{'enabled'} && $FXbot{'ScanServ'}{'scan_netmerge'}) {
        if ($FXbot{'ScanServ'}{'scan_version'}) { &ss_ctcp($nick, 0, "VERSION"); }
        &ss_check($nick, "scan", undef);
      }
    }

    return(0);
  }
}

sub irc_privmsg {
  my $buffer = shift;

  my $nick = (split(/:/, $buffer, 0))[1]; $nick = (split(/ /, $nick, 0))[0];
  my $target = (split(/ /, $buffer, 0))[2];
  my $query = (split(/:/, $buffer, 3))[2];

  foreach (keys(%{$FXirc{'ignore'}})) {
    my $umaskrx = &plain2regexp($FXirc{'ignore'}{$_}{'user'});
    my $hmaskrx = &plain2regexp($FXirc{'ignore'}{$_}{'host'});

    if (($FXirc{'client'}{lc($nick)}{'user'} =~ /$umaskrx/i) && ($FXirc{'client'}{lc($nick)}{'host'} =~ /$hmaskrx/i)) { return(0); }
  }

  if ($target =~ /^#/) {
    &chanlog("x", $target, $nick, $query, undef);
    &process_channel($nick, $target, $query);
    return(0);
  }

  $target = (split(/\@/, $target, 0))[0];

  if (lc($target) eq lc($FXbot{'DataServ'}{'nick'})) {
    &process_ds($nick, $query);
  } elsif ((lc($target) eq lc($FXbot{'FindServ'}{'nick'}))) {
    &process_fs($nick, $query);
  } elsif ((lc($target) eq lc($FXbot{'NewsServ'}{'nick'}))) {
    &process_ns($nick, $query);
  } elsif ((lc($target) eq lc($FXbot{'MobiServ'}{'nick'}))) {
    &process_ms($nick, $query);
  } elsif ((lc($target) eq lc($FXbot{'GameServ'}{'nick'}))) {
    &process_gs($nick, $query);
  } elsif ((lc($target) eq lc($FXbot{'ScanServ'}{'nick'}))) {
    &process_ss($nick, $query);
  } elsif ((lc($target) eq lc($FXbot{'FileServ'}{'nick'}))) {
    &process_xs($nick, $query);
  } elsif ((lc($target) eq lc($FXbot{'PageServ'}{'nick'}))) {
    &process_ps($nick, $query);
  } else {
    if ($FXbot{'PageServ'}{'enabled'}) {
      my $im_privmsg = {
        'msn'    => \&msn_privmsg,
        'yahoo'  => \&yahoo_privmsg,
        'icq'    => \&icq_privmsg,
        'aim'    => \&aim_privmsg,
        'jabber' => \&jabber_privmsg
      };

      foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
        if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }

        foreach (keys(%{$FXim{$im}{'buddies'}})) {
          if (lc($target) eq lc($FXim{$im}{'buddies'}{$_}{'ircnick'})) {
            &{$im_privmsg->{$im}}($nick, $FXim{$im}{'buddies'}{$_}{'id'}, $query);
            last;
          }
        }
      }
    }
  }

  return(0);
}

sub irc_mode {
  my $buffer = shift;

  my $nick = (split(/:/, $buffer, 0))[1]; $nick = (split(/ /, $nick, 0))[0];
  my $target = (split(/ /, $buffer, 0))[2];
  my $args = (split(/ /, $buffer, 5))[4];
  my $mode = "";
  my $what = 1;

  if ($target =~ /^#/) {
    $mode = (split(/ /, $buffer, 0))[3];

    &chanlog("m", $target, $nick, $mode, $args);
    &channel_mode($nick, $target, $mode, $args);
    if ($FXserv{'connected'}) {
      if ($FXirc{'client'}{lc($nick)}) {
        &putinfo("m", "Mode: %s [%s%s] by %s!%s\@%s", $target, $mode, $args ? " " . $args : "", $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
      } else {
        &putinfo("m", "Mode: %s [%s%s] by %s", $target, $mode, $args ? " " . $args : "", $FXirc{'server'}{lc($nick)}{'name'});
      }
    }
  } else {
    $mode = (split(/:/, $buffer, 0))[2];

    foreach (split(//, $mode)) {
      if ($_ eq "+") {
        $what = 1;
      } elsif ($_ eq "-") {
        $what = 0;
      } elsif ($FXflags{'client'}{$_}) {
        my $server = $FXirc{'client'}{lc($target)}{'server'};

        if ($what) {
          if ($FXirc{'client'}{lc($target)}{'mode'} & $FXflags{'client'}{$_}) { next; }

          $FXirc{'client'}{lc($target)}{'mode'} |= $FXflags{'client'}{$_};

          if ($_ eq "o") {
            if ($FXserv{'connected'} && !$FXserv{'netmerge'}) { &putinfo("o", "New Operator: %s (%s\@%s) [%s]", $FXirc{'client'}{lc($target)}{'nick'}, $FXirc{'client'}{lc($target)}{'user'}, $FXirc{'client'}{lc($target)}{'host'},  $FXirc{'client'}{lc($target)}{'server'}); }

            if (++$FXstats{'opers'}{'current'} > $FXstats{'opers'}{'max'}) {
              if ($FXserv{'connected'} && !$FXserv{'netmerge'}) { &putinfo("x", "New max operator count: %d", $FXstats{'opers'}{'current'}); }
              $FXstats{'opers'}{'max'} = $FXstats{'opers'}{'current'};
              $FXstats{'opers'}{'max_ts'} = $ts;
            }

            if (++$FXirc{'server'}{lc($server)}{'opers'}{'current'} > $FXirc{'server'}{lc($server)}{'opers'}{'max'}) {
              $FXirc{'server'}{lc($server)}{'opers'}{'max'} = $FXirc{'server'}{lc($server)}{'opers'}{'current'};
              $FXirc{'server'}{lc($server)}{'opers'}{'max_ts'} = $ts;
            }
          }
        } else {
          if (!($FXirc{'client'}{lc($target)}{'mode'} & $FXflags{'client'}{$_})) { next; }

          $FXirc{'client'}{lc($target)}{'mode'} &= ~$FXflags{'client'}{$_};

          if ($_ eq "o") {
            --$FXstats{'opers'}{'current'};
            --$FXirc{'server'}{lc($server)}{'opers'}{'current'};
          }
        }
      }
    }
  }

  return(0);
}

sub irc_quit {
  my $buffer = shift;

  my $nick = (split(/:/, $buffer, 0))[1]; $nick = (split(/ /, $nick, 0))[0];
  my $reason = (split(/:/, $buffer, 3))[2];

  &add_seen($nick, "QUIT", $reason);
  &putinfo("E", "Client exit: %s!%s\@%s [%s]", $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $FXirc{'client'}{lc($nick)}{'server'});
  &chanlog("q", undef, $nick, $reason, undef);
  &del_client($nick);

  return(0);
}

sub irc_kick {
  my $buffer = shift;

  my $nick = (split(/:/, $buffer, 0))[1]; $nick = (split(/ /, $nick, 0))[0];
  my $channel = (split(/ /, $buffer, 0))[2];
  my $target = (split(/ /, $buffer, 0))[3];
  my $reason = (split(/:/, $buffer, 3))[2];

  &add_seen($target, "KICK", $channel);

  if ($FXirc{'client'}{lc($nick)}) {
    &putinfo("k", "Channel kick: %s [%s] by %s!%s\@%s (%s)", $channel, $target, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $reason);
  } else {
    &putinfo("k", "Channel kick: %s [%s] by %s (%s)", $channel, $target, $FXirc{'server'}{lc($nick)}{'name'}, $reason);
  }

  &chanlog("k", $channel, $target, $nick, $reason);
  &del_channel($channel, $target);

  foreach (keys(%FXbot)) {
    if (!$FXbot{$_}{'enabled'}) { next; }
    if ((lc($FXbot{$_}{'nick'}) eq lc($target)) && $FXbot{$_}{'channel'} && $FXbot{$_}{'channel'}{lc($channel)}) {
      &service_join($FXbot{$_}{'nick'}, $FXbot{$_}{'channel'}{lc($channel)}{'channel'});
      last;
    }
  }

  if ($FXbot{'PageServ'}{'enabled'}) {
    my $im_sjoin = {
      'msn'    => \&msn_sjoin,
      'yahoo'  => \&yahoo_sjoin,
      'icq'    => \&icq_sjoin,
      'aim'    => \&aim_sjoin,
      'jabber' => \&jabber_sjoin
    };

    my $im_remsession = {
      'msn'    => \&msn_remsession,
      'yahoo'  => \&yahoo_remsession,
      'icq'    => \&icq_remsession,
      'aim'    => \&aim_remsession,
      'jabber' => \&jabber_remsession
    };

    foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
      if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }

      foreach (keys(%{$FXim{$im}{'buddies'}})) {
        if (lc($FXim{$im}{'buddies'}{$_}{'ircnick'}) eq lc($target)) {
          if (lc($channel) eq lc($FXbot{'PageServ'}{$im . "_channel"})) { &{$im_sjoin->{$im}}($FXim{$im}{'buddies'}{$_}{'id'}, $FXbot{'PageServ'}{$im . "_channel"}, 0); }

          foreach my $session (keys(%{$FXim{$im}{'board'}})) {
            if (lc($channel) eq lc($FXim{$im}{'board'}{$session}{'channel'})) { &{$im_remsession->{$im}}($session, "*"); }
          }

          return(0);
        }
      }

      foreach my $session (keys(%{$FXim{$im}{'board'}})) {
        if (lc($channel) eq lc($FXim{$im}{'board'}{$session}{'channel'})) {
          foreach my $user (@{$FXim{$im}{'board'}{$session}{'nick'}}) {
            if (lc($nick) eq lc($user)) {
              &{$im_remsession->{$im}}($session, $nick);
              last;
            }
          }
        }
      }
    }
  }

  return(0);
}

sub irc_topic {
  my $buffer = shift;

  my $channel = "";
  my $topic = "";
  my $author = "";
  my $time = $ts;

  if (substr($buffer, 0, 1) eq ":") {
    $topic = (split(/:/, $buffer, 3))[2];

    if ($FXcfg{'hub'}{'type'} eq "bahamut") {
      $channel = (split(/ /, $buffer, 0))[2];
      $author = (split(/ /, $buffer, 0))[3];
      $ts = (split(/ /, $buffer, 0))[4];
    } else {
      my $nick = (split(/:/, $buffer, 0))[1]; $nick = (split(/ /, $nick, 0))[0];

      if ((split(/ /, $buffer, 0))[1] == 332) {
        $channel = (split(/ /, $buffer, 0))[3];
        $author = $FXirc{'server'}{lc($nick)}{'name'};
      } else {
        $channel = (split(/ /, $buffer, 0))[2];
        $author = $FXirc{'client'}{lc($nick)}{'nick'};
      }
    }

  } else {
    $channel = (split(/ /, $buffer, 0))[1];
    $author = (split(/ /, $buffer, 0))[2];
    $time = (split(/ /, $buffer, 0))[3];
    $topic = (split(/:/, $buffer, 0))[1];
  }

  $FXirc{'channel'}{lc($channel)}{'topic'}{'string'} = $topic;
  $FXirc{'channel'}{lc($channel)}{'topic'}{'author'} = $author;
  $FXirc{'channel'}{lc($channel)}{'topic'}{'set'} = $time;

  if ($FXserv{'connected'}) {
    &putinfo("t", "Channel topic: %s (%s) %s", $channel, $author, $topic);
    &chanlog("t", $channel, $author, $topic, undef);
  }

  return(0);
}

sub irc_kill {
  my $buffer = shift;

  my $nick = (split(/:/, $buffer, 0))[1]; $nick = (split(/ /, $nick, 0))[0];
  my $reason = (split(/:/, $buffer, 3))[2];
  my $target = (split(/ /, $buffer, 0))[2];

  &add_seen($target, "QUIT", $reason);
  &chanlog("q", undef, $target, $reason, undef);

  if ($FXirc{'client'}{lc($nick)}) {
    ++$FXstats{'kills'}{'oper'};
    &putinfo("O", "Operator kill: [%s] by %s!%s\@%s (%s)", $target, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $reason);
  } elsif ($FXirc{'server'}{lc($nick)}) {
    ++$FXstats{'kills'}{'server'};
    &putinfo("S", "Server kill: [%s] by %s (%s)", $target, $FXirc{'server'}{lc($nick)}{'name'}, $reason);
  }

  &del_client($target);

  foreach (keys(%FXbot)) {
    if (!$FXbot{$_}{'enabled'}) { next; }
    if (lc($FXbot{$_}{'nick'}) eq lc($target)) {
      &introduce_service($FXbot{$_}{'service'});
      if ($FXbot{$_}{'channel'}) { &check_channel($FXbot{$_}{'service'}); }
      last;
    }
  }

  if ($FXbot{'PageServ'}{'enabled'}) {
    my $im_introduce = {
      'msn'    => \&msn_introduce,
      'yahoo'  => \&yahoo_introduce,
      'icq'    => \&icq_introduce,
      'aim'    => \&aim_introduce,
      'jabber' => \&jabber_introduce
    };

    my $im_remsession = {
      'msn'    => \&msn_remsession,
      'yahoo'  => \&yahoo_remsession,
      'icq'    => \&icq_remsession,
      'aim'    => \&aim_remsession,
      'jabber' => \&jabber_remsession
    };

    foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
      if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }

      foreach (keys(%{$FXim{$im}{'buddies'}})) {
        if (lc($FXim{$im}{'buddies'}{$_}{'ircnick'}) eq lc($target)) {
          foreach my $session (keys(%{$FXim{$im}{'board'}})) {
            if ($FXim{$im}{'board'}{$session}{'id'} eq $FXim{$im}{'buddies'}{$_}{'id'}) { &{$im_remsession->{$im}}($session, "*"); }
          }

          $FXim{$im}{'buddies'}{$_}{'ircnick'} = "";
          &{$im_introduce->{$im}}($FXim{$im}{'buddies'}{$_}{'id'});
          return(0);
        }
      }
    }
  }

  return(0);
}

sub irc_sjoin {
  my $buffer = shift;

  my $time = 0;
  my $channel = "";
  my $list = "";
  my $proc = "";
  my $mode = "";
  my $args = "";

  if (substr($buffer, 0, 1) eq ":") {
    $time = (split(/ /, $buffer, 0))[2];
    $channel = (split(/ /, $buffer, 0))[3];

    if ($FXcfg{'hub'}{'type'} eq "bahamut") {
      my $nick = (split(/:/, $buffer, 0))[1]; $nick = (split(/ /, $nick, 0))[0];

      if ($FXirc{'client'}{lc($nick)}) {
        $list = $nick;
      } elsif ($FXirc{'server'}{lc($nick)}) {
        $list = (split(/:/, $buffer, 0))[2];
        $proc = (split(/:/, $buffer, 0))[1];
        $mode = (split(/ /, $proc, 0))[4];
        $args = (split(/ /, $proc, 0))[5];
      }
    } else {
      $list = (split(/:/, $buffer, 0))[2];
      $proc = (split(/:/, $buffer, 0))[1];
      $mode = (split(/ /, $proc, 0))[4];
      $args = (split(/ /, $proc, 0))[5];
    }
  } else {
    $time = (split(/ /, $buffer, 0))[1];
    $channel = (split(/ /, $buffer, 0))[2];
    $list = (split(/:/, $buffer, 0))[1];
    $proc = (split(/:/, $buffer, 0))[0];
    $mode = (split(/ /, $proc, 0))[3];
    $args = (split(/ /, $proc, 0))[4];
  }

  my $nick = (split(/ /, $list, 0))[0]; $nick =~ s/\@//; $nick =~ s/\%//; $nick =~ s/\+//; $nick =~ s/\~//; $nick =~ s/\*//; $nick =~ s/\&//; $nick =~ s/!//;

  if (!$FXirc{'channel'}{lc($channel)}) { &add_channel($channel, $time, undef); }

  if (!$FXserv{'connected'}) {
    &channel_mode($nick, $channel, $mode, $args);
  } else {
    if (!$FXirc{'channel'}{lc($channel)}) {
      &putinfo("j", "New channel: %s (created by %s!%s\@%s)", $channel, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    } else {
      &putinfo("j", "Channel join: %s (%s!%s\@%s)", $channel, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    }

    &chanlog("j", $channel, $nick, undef, undef);

    foreach (keys(%FXbot)) {
      if (!$FXbot{$_}{'enabled'}) { next; }
      if (lc($FXbot{$_}{'nick'}) eq lc($nick)) { next; }

      if ($FXbot{$_}{'channel'} && $FXbot{$_}{'channel'}{lc($channel)} && $FXbot{$_}{'channel'}{lc($channel)}{'joinmsg'}) {
        my $joinmsg = $FXbot{$_}{'channel'}{lc($channel)}{'joinmsg'};
        $joinmsg =~ s/%c/$channel/g; $joinmsg =~ s/%n/$nick/g;
        &putsock($FXsock{'irc'}, ":%s %s %s :%s", $FXbot{$_}{'nick'}, $FXcfg{'general'}{'communicate'}, $nick, $joinmsg);
      }
    }

    if ($FXbot{'PageServ'}{'enabled'}) {
      my $im_text = {
        'msn'    => \&msn_text,
        'yahoo'  => \&yahoo_text,
        'icq'    => \&icq_text,
        'aim'    => \&aim_text,
        'jabber' => \&jabber_text
      };

      foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
        if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }

        foreach my $session (keys(%{$FXim{$im}{'board'}})) {
          if (lc($channel) eq lc($FXim{$im}{'board'}{$session}{'channel'})) {
            &{$im_text->{$im}}($FXim{$im}{'board'}{$session}{'id'}, $FXmsg{'buddy_join'}, $nick);
            push(@{$FXim{$im}{'board'}{$session}{'nick'}}, $nick);
            $FXim{$im}{'board'}{$session}{'last'} = $ts;
            last;
          }
        }
      }
    }

  }

  foreach my $user (split(/ /, $list)) {
    $user =~ s/\~//; $user =~ s/\&//; $user =~ s/\*//; $user =~ s/\!//;
    my $nick = $user; $nick =~ s/\@//; $nick =~ s/\%//; $nick =~ s/\+//;

    $FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'nick'} = $FXirc{'client'}{lc($nick)}{'nick'};
    $FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} = '';

    if (++$FXirc{'channel'}{lc($channel)}{'current'} > $FXirc{'channel'}{lc($channel)}{'max'}) {
      $FXirc{'channel'}{lc($channel)}{'max'} = $FXirc{'channel'}{lc($channel)}{'current'};
      $FXirc{'channel'}{lc($channel)}{'max_ts'} = $ts;
    }

    if (substr($user, 0, 1) eq "\@") {
      $FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} |= $FXflags{'channel'}{'o'};
    } elsif ((substr($user, 0, 1) eq "\%") || (substr($user, 0, 2) eq "\%")) {
      $FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} |= $FXflags{'channel'}{'h'};
    } elsif ((substr($user, 0, 1) eq "+") || (substr($user, 0, 2) eq "+") || (substr($user, 0, 3) eq "+")) {
      $FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} |= $FXflags{'channel'}{'v'};
    }

    &add_seen($nick, "JOIN", $FXirc{'channel'}{lc($channel)}{'channel'})
  }

  return(0);
}

sub irc_part {
  my $buffer = shift;

  my $nick = (split(/:/, $buffer, 0))[1]; $nick = (split(/ /, $nick, 0))[0];
  my $channel = (split(/ /, $buffer, 0))[2];

  &add_seen($nick, "PART", $FXirc{'channel'}{lc($channel)}{'channel'});
  &chanlog("p", $channel, $nick, undef, undef);

  foreach (keys(%FXbot)) {
    if (!$FXbot{$_}{'enabled'}) { next; }
    if (lc($FXbot{$_}{'nick'}) eq lc($nick)) { next; }

    if ($FXbot{$_}{'channel'} && $FXbot{$_}{'channel'}{lc($channel)} && $FXbot{$_}{'channel'}{lc($channel)}{'partmsg'}) {
      my $partmsg = $FXbot{$_}{'channel'}{lc($channel)}{'partmsg'};
      $partmsg =~ s/%c/$channel/g; $partmsg =~ s/%n/$nick/g;
      &putsock($FXsock{'irc'}, ":%s %s %s :%s", $FXbot{$_}{'nick'}, $FXcfg{'general'}{'communicate'}, $nick, $partmsg);
    }
  }

  if ($FXbot{'PageServ'}{'enabled'}) {
    my $im_remsession = {
      'msn'    => \&msn_remsession,
      'yahoo'  => \&yahoo_remsession,
      'icq'    => \&icq_remsession,
      'aim'    => \&aim_remsession,
      'jabber' => \&jabber_remsession
    };

    foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
      if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }

      foreach my $session (keys(%{$FXim{$im}{'board'}})) {
        if (lc($channel) eq lc($FXim{$im}{'board'}{$session}{'channel'})) {
          foreach my $user (@{$FXim{$im}{'board'}{$session}{'nick'}}) {
            if (lc($nick) eq lc($user)) {
              &{$im_remsession->{$im}}($session, $nick);
              last;
            }
          }
        }
      }
    }
  }

  &putinfo("p", "Channel part: %s (%s!%s\@%s)", $channel, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
  &del_channel($channel, $nick);

  return(0);
}

sub irc_whois {
  my $buffer = shift;

  my $nick = (split(/:/, $buffer, 0))[1]; $nick = (split(/ /, $nick))[0];
  my $target = (split(/ /, $buffer, 0))[2];

  &putsock($FXsock{'irc'}, ":%s 311 %s %s %s %s * :%s", $FXserv{'name'}, $nick, $FXirc{'client'}{lc($target)}{'nick'}, $FXirc{'client'}{lc($target)}{'user'}, $FXirc{'client'}{lc($target)}{'host'}, $FXirc{'client'}{lc($target)}{'info'});
  &putsock($FXsock{'irc'}, ":%s 312 %s %s :%s", $FXserv{'name'}, $nick, $FXirc{'client'}{lc($target)}{'nick'}, $FXserv{'name'}, $FXserv{'info'});
  if ($FXirc{'client'}{lc($target)}{'mode'} & $FXflags{'client'}{'o'}) { &putsock($FXsock{'irc'}, ":%s 313 %s %s :is a Network Service Daemon", $FXserv{'name'}, $nick, $FXirc{'client'}{lc($target)}{'nick'}); }
  &putsock($FXsock{'irc'}, ":%s 317 %s %s %d %d :seconds idle, signon time", $FXserv{'name'}, $nick, $FXirc{'client'}{lc($target)}{'nick'}, 0, $FXirc{'client'}{lc($target)}{'time'});
  &putsock($FXsock{'irc'}, ":%s 318 %s %s :End of /WHOIS list", $FXserv{'name'}, $nick, $FXirc{'client'}{lc($target)}{'nick'});

  &putinfo("y", "Remote WHOIS [%s] requested by %s!%s\@%s", $FXirc{'client'}{lc($target)}{'nick'}, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
  return(0);
}

sub irc_notice {
  my $buffer = shift;

  my $nick = (split(/:/, $buffer, 0))[1]; $nick = (split(/ /, $nick, 0))[0];
  my $target = (split(/ /, $buffer, 0))[2];
  my $query = (split(/:/, $buffer, 3))[2];

  if ($target =~ /^#/) {
    &chanlog("y", $target, $nick, $query, undef);
    return(0);
  }

  $target = (split(/\@/, $target, 0))[0];

  if ($FXbot{'ScanServ'}{'enabled'} && ($query =~ /^\cAVERSION (.*)\cA$/i) && (lc($target) eq lc($FXbot{'ScanServ'}{'nick'}))) { &ss_reply($nick, $1); }

  return(0);
}

sub irc_version {
  my $buffer = shift;

  my $nick = (split(/:/, $buffer, 0))[1]; $nick = (split(/ /, $nick))[0];

  &putsock($FXsock{'irc'}, ":%s 351 %s %s", $FXserv{'name'}, $nick, "FXserv IRC Services $FXserv{'version'}");

  if ($FXirc{'client'}{lc($nick)}) {
    &putinfo("y", "Remote VERSION requested by %s!%s\@%s", $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
  } else {
    &putinfo("y", "Remote VERSION requested by %s", $nick);
  }

  return(0);
}

sub irc_admin {
  my $buffer = shift;

  my $nick = (split(/:/, $buffer, 0))[1]; $nick = (split(/ /, $nick))[0];

  &putsock($FXsock{'irc'}, ":%s 256 %s :Administrative info about %s", $FXserv{'name'}, $nick, $FXserv{'name'});
  &putsock($FXsock{'irc'}, ":%s 257 %s :FXserv IRC Services %s", $FXserv{'name'}, $nick, $FXserv{'version'});
  &putsock($FXsock{'irc'}, ":%s 259 %s :%s", $FXserv{'name'}, $nick, $FXserv{'admin'});

  if ($FXirc{'client'}{lc($nick)}) {
    &putinfo("y", "Remote ADMIN requested by %s!%s\@%s", $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
  } else {
    &putinfo("y", "Remote ADMIN requested by %s", $nick);
  }

  return(0);
}

sub irc_351 {
  my $buffer = shift;

  my $server = (split(/:/, $buffer, 0))[1]; $server = (split(/ /, $server, 0))[0];
  my $version = (split(/ /, $buffer, 4))[3];

  if ($FXirc{'server'}{lc($server)}) { $FXirc{'server'}{lc($server)}{'version'} = $version; }

  return(0);
}

sub irc_25X {
  my $buffer = shift;

  my $server = (split(/:/, $buffer, 0))[1]; $server = (split(/ /, $server, 0))[0];
  my $admin = (split(/:/, $buffer, 3))[2];

  if ($FXirc{'server'}{lc($server)}) { push(@{$FXirc{'server'}{lc($server)}{'admin'}}, $admin); }

  return(0);
}

1;