use strict;
use POSIX qw(strftime);

our (%FXirc, %FXflags, %FXbot, %FXsock, $LogEvent, $LogFile);

sub servicelog {
  my ($nick, $service, $format, @arg) = (shift, shift, shift, @_);
  my $buffer = sprintf($format, @arg);

  if ($FXsock{'list'}{$nick}) { &putinfo("s", "#%s# %s", $FXsock{'list'}{$nick}{'nick'}, $buffer); }
  if ($FXirc{'client'}{lc($nick)}) { &putinfo("s", "%s: %s!%s\@%s %s", $FXbot{$service}{'nick'}, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $buffer); }

  return(0);
}

sub putlog {
  my ($flag, $format, @arg) = (shift, shift, @_);
  my $buffer = sprintf($format, @arg);

  if ($FXflags{'event'}{$flag} && !($LogEvent & $FXflags{'event'}{$flag})) { return(0); }

  if (!open(FILE, ">>" . $LogFile)) { return(0); }

  print FILE sprintf("[%s] %s\r\n", strftime("%H:%M:%S", localtime), $buffer);
  close(FILE);
  return(0);
}

sub chanlog {
  my ($event, $channel, $nick, $a, $b) = (shift, shift, shift, shift, shift);
  my $strftime = strftime("%H:%M:%S", localtime);

  if (!$channel && (($event eq "n") || ($event eq "q"))) {
    foreach my $service (keys(%FXbot)) {
      if (!$FXbot{$service}{'enabled'}) { next; }

      foreach my $target (keys(%{$FXbot{$service}{'channel'}})) {
        $target = $FXbot{$service}{'channel'}{lc($target)}{'channel'};

        if (!($FXbot{$service}{'channel'}{lc($target)}{'log_event'} & $FXflags{'monitor'}{$event})) { next; }
        if ($FXirc{'channel'}{lc($target)} && !$FXirc{'channel'}{lc($target)}{'names'}{lc($nick)}) { next; }
        if ($FXirc{'channel'}{lc($target)} && !$FXirc{'channel'}{lc($target)}{'names'}{lc($FXbot{$service}{'nick'})}) { next; }

        if (!open(FILE, ">>" . $FXbot{$service}{'channel'}{lc($target)}{'log_file'})) { next; }

        if ($event eq "n") {
          print FILE sprintf("[%s] * %s is now known as %s\r\n", $strftime, $nick, $a);
        } elsif ($event eq "q") {
          if (lc($nick) eq lc($FXbot{$service}{'nick'})) {
            print FILE sprintf("Session Close: %s\r\n", scalar(localtime()));
          } else {
            my $mode = "";

            if ($FXirc{'channel'}{lc($target)}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'o'}) {
              $mode = "\@";
            } elsif ($FXirc{'channel'}{lc($target)}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'h'}) {
              $mode = "\%";
            } elsif ($FXirc{'channel'}{lc($target)}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'v'}) {
              $mode = "+";
            }

            print FILE sprintf("[%s] * %s%s (%s\@%s) Quit (%s)\r\n", $strftime, $mode, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $a);
          }
        }

        close(FILE);
      }
    }

    return(0);
  }

  foreach my $service (keys(%FXbot)) {
    if (!$FXbot{$service}{'channel'}{lc($channel)}) { next; }
    if (!($FXbot{$service}{'channel'}{lc($channel)}{'log_event'} & $FXflags{'monitor'}{$event})) { next; }
    if ($FXirc{'channel'}{lc($channel)} && !$FXirc{'channel'}{lc($channel)}{'names'}{lc($FXbot{$service}{'nick'})}) { next; }

    if (!open(FILE, ">>" . $FXbot{$service}{'channel'}{lc($channel)}{'log_file'})) { next; }

    if ($event eq "j") {
      if (lc($nick) eq lc($FXbot{$service}{'nick'})) {
        print FILE sprintf("\r\nSession Start: %s\r\n", scalar(localtime()));
        print FILE sprintf("Session Ident: %s\r\n", $FXirc{'channel'}{lc($channel)}{'channel'});
        print FILE sprintf("[%s] * Now talking in %s\r\n", $strftime, $FXirc{'channel'}{lc($channel)}{'channel'});

        if ($FXirc{'channel'}{lc($channel)}{'topic'}{'string'}) {
          print FILE sprintf("[%s] * Topic is '%s'\r\n", $strftime, $FXirc{'channel'}{lc($channel)}{'topic'}{'string'});
          print FILE sprintf("[%s] * Set by %s on %s\r\n", $strftime, $FXirc{'channel'}{lc($channel)}{'topic'}{'author'}, scalar(localtime($FXirc{'channel'}{lc($channel)}{'topic'}{'set'})));
        }
      } else {
        print FILE sprintf("[%s] * %s (%s\@%s) has joined %s\r\n", $strftime, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $FXirc{'channel'}{lc($channel)}{'channel'});
      }
    } elsif ($event eq "k") {
      if (lc($nick) eq lc($FXbot{$service}{'nick'})) {
        print FILE sprintf("Session Close: %s\r\n", scalar(localtime()));
      } else {
        print FILE sprintf("[%s] * %s was kicked by %s (%s)\r\n", $strftime, $nick, $a, $b);
      }
    } elsif ($event eq "m") {
      print FILE sprintf("[%s] * %s sets mode: %s %s\r\n", $strftime, $nick, $a, $b);
    } elsif ($event eq "p") {
      if (lc($nick) eq lc($FXbot{$service}{'nick'})) {
        print FILE sprintf("Session Close: %s\r\n", scalar(localtime()));
      } else {
        print FILE sprintf("[%s] * %s (%s\@%s) has left %s\r\n", $strftime, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $FXirc{'channel'}{lc($channel)}{'channel'});
      }
    } elsif ($event eq "t") {
      print FILE sprintf("[%s] * %s changes topic to '%s'\r\n", $strftime, $nick, $a);
    } elsif (($event eq "x") || ($event eq "y")) {
      my $mode = "";

      if ($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'o'}) {
        $mode = "\@";
      } elsif ($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'h'}) {
        $mode = "\%";
      } elsif ($FXirc{'channel'}{lc($channel)}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'v'}) {
        $mode = "+";
      }

      if ($event eq "x") {
        if ($a =~ /\cA(.*)\cA/) {
          my $ctcp = (split(/ /, $1, 0))[0];
          my $query = (split(/ /, $1, 2))[1];

          if (uc($ctcp) eq "ACTION") {
            print FILE sprintf("[%s] * %s%s %s\r\n", $strftime, $mode, $nick, $query);
          } else {
            print FILE sprintf("[%s] -> [%s%s] %s\r\n", $strftime, $mode, $nick, $query);
          }
        } else {
          print FILE sprintf("[%s] <%s%s> %s\r\n", $strftime, $mode, $nick, $a);
        }
      }

      if ($event eq "y") { print FILE sprintf("[%s] -%s%s- %s\r\n", $strftime, $mode, $nick, $a); }
    }

    close(FILE);
    return(0);
  }

  return(0);
}

1;