use strict;
use DBI;

our (%MySQL, %FXflags, %FXbot, %FXirc, %FXstats, $ts);

sub save_mysql {
  my $sth;
  my $query;

  $MySQL{'last_sync'} = $ts;

  my $pid = undef;

  if ($pid = fork()) {
  } elsif (defined($pid)) {
    my $dbs = sprintf("DBI:mysql:%s:%s:%d", $MySQL{'database'}, $MySQL{'host'}, $MySQL{'port'}); 
    my $dbh = DBI->connect($dbs, $MySQL{'user'}, $MySQL{'password'});

    if (!$dbh) {
      &putinfo("y", "Can't connect to MySQL database %s", $dbs);
      exit(0);
    }

    $query = sprintf("INSERT INTO \`stats\` \(time, servers, maxservers, maxserverstime, users, maxusers, maxuserstime, opers, maxopers, maxoperstime, channels, maxchannels, maxchannelstime, operkills, serverkills\) VALUES \(\'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\'\)", $ts, $FXstats{'servers'}{'current'}, $FXstats{'servers'}{'max'}, $FXstats{'servers'}{'max_ts'}, $FXstats{'clients'}{'current'}, $FXstats{'clients'}{'max'}, $FXstats{'clients'}{'max_ts'}, $FXstats{'opers'}{'current'}, $FXstats{'opers'}{'max'}, $FXstats{'opers'}{'max_ts'}, $FXstats{'channels'}{'current'}, $FXstats{'channels'}{'max'}, $FXstats{'channels'}{'max_ts'}, $FXstats{'kills'}{'oper'}, $FXstats{'kills'}{'server'});
    $sth = $dbh->prepare($query);
    $sth->execute;
    $sth->finish;

    $query = "DELETE FROM \`server\`";
    $sth = $dbh->prepare($query);
    $sth->execute;
    $sth->finish;

    foreach (keys(%{$FXirc{'server'}})) {
      my $admin = "";
      foreach my $line (@{$FXirc{'server'}{$_}{'admin'}}) { $admin .= quotemeta($line) . "\n"; }

      $query = sprintf("INSERT INTO \`server\` \(server, descr, hopcount, hub, uptime, users, maxusers, maxuserstime, opers, maxopers, maxoperstime, version, admin\) VALUES \(\'%s\', \'%s\', \'%d\', \'%s\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%d\', \'%s\', \'%s\'\)", quotemeta($FXirc{'server'}{$_}{'name'}), quotemeta($FXirc{'server'}{$_}{'info'}), $FXirc{'server'}{$_}{'hopcount'}, $FXirc{'server'}{$_}{'hub'}, $ts - $FXirc{'server'}{$_}{'time'}, $FXirc{'server'}{$_}{'users'}{'current'}, $FXirc{'server'}{$_}{'users'}{'max'}, $FXirc{'server'}{$_}{'users'}{'max_ts'}, $FXirc{'server'}{$_}{'opers'}{'current'}, $FXirc{'server'}{$_}{'opers'}{'max'}, $FXirc{'server'}{$_}{'opers'}{'max_ts'}, $FXirc{'server'}{$_}{'version'}, $admin);
      $sth = $dbh->prepare($query);
      $sth->execute;
      $sth->finish;
    }

    if ($FXbot{'ScanServ'}{'enabled'} && $FXbot{'ScanServ'}{'scan_version'}) {
      $query = "DELETE FROM \`version\`";
      $sth = $dbh->prepare($query);
      $sth->execute;
      $sth->finish;

      foreach (keys(%{$FXstats{'version'}})) {
        $query = sprintf("INSERT INTO \`version\` \(reply, users, maxusers, maxuserstime\) VALUES \(\'%s\', \'%d\', \'%d\', \'%d\'\)", quotemeta($FXstats{'version'}{$_}{'reply'}), $FXstats{'version'}{$_}{'current'}, $FXstats{'version'}{$_}{'max'}, $FXstats{'version'}{$_}{'max_ts'});
        $sth = $dbh->prepare($query);
        $sth->execute;
        $sth->finish;
      }
    }

    $query = "DELETE FROM \`tld\`";
    $sth = $dbh->prepare($query);
    $sth->execute;
    $sth->finish;

    foreach (keys(%{$FXstats{'tld'}})) {
      $query = sprintf("INSERT INTO \`tld\` \(tld, time, users, maxusers, maxuserstime\) VALUES \(\'%s\', \'%d\', \'%d\', \'%d\', \'%d\'\)", $_, $ts, $FXstats{'tld'}{$_}{'current'}, $FXstats{'tld'}{$_}{'max'}, $FXstats{'tld'}{$_}{'max_ts'});
      $sth = $dbh->prepare($query);
      $sth->execute;
      $sth->finish;
    }

    $query = "DELETE FROM \`domain\`";
    $sth = $dbh->prepare($query);
    $sth->execute;
    $sth->finish;

    foreach (keys(%{$FXstats{'domain'}})) {
      $query = sprintf("INSERT INTO \`domain\` \(domain, time, users, maxusers, maxuserstime\) VALUES \(\'%s\', \'%d\', \'%d\', \'%d\', \'%d\'\)", $_, $ts, $FXstats{'domain'}{$_}{'current'}, $FXstats{'domain'}{$_}{'max'}, $FXstats{'domain'}{$_}{'max_ts'});
      $sth = $dbh->prepare($query);
      $sth->execute;
      $sth->finish;
    }

    $query = "DELETE FROM \`client\`";
    $sth = $dbh->prepare($query);
    $sth->execute;
    $sth->finish;

    foreach (keys(%{$FXirc{'client'}})) {
      my $mode = "";
      my $list = "";

      foreach my $flag (keys(%{$FXflags{'client'}})) {
        if ($FXirc{'client'}{$_}{'mode'} & $FXflags{'client'}{$flag}) { $mode .= $flag; }
      }

      foreach my $channel (keys(%{$FXirc{'channel'}})) {
        my $power = "";

        if ($FXirc{'channel'}{$channel}{'names'}{lc($_)}) {
          if ($FXirc{'channel'}{$channel}{'names'}{lc($_)}{'mode'} & $FXflags{'channel'}{'o'}) { $power = "\@"; }
          if ($FXirc{'channel'}{$channel}{'names'}{lc($_)}{'mode'} & $FXflags{'channel'}{'h'}) { $power = "\%"; }
          if ($FXirc{'channel'}{$channel}{'names'}{lc($_)}{'mode'} & $FXflags{'channel'}{'v'}) { $power = "+"; }

          $list .= $power . $FXirc{'channel'}{$channel}{'channel'} . " ";
        }
      }

      $list =~ s/\s+$//;

      $query = sprintf("INSERT INTO \`client\` \(nick, user, host, info, server, time, mode, channel\) VALUES \(\'%s\', \'%s\', \'%s\', \'%s\', \'%s\', \'%d\', \'%s\', \'%s\'\)", $FXirc{'client'}{$_}{'nick'}, $FXirc{'client'}{$_}{'user'}, $FXirc{'client'}{$_}{'host'}, quotemeta($FXirc{'client'}{$_}{'info'}), $FXirc{'client'}{$_}{'server'}, $FXirc{'client'}{$_}{'time'}, $mode, quotemeta($list));
      $sth = $dbh->prepare($query);
      $sth->execute;
      $sth->finish;
    }

    $query = "DELETE FROM \`channel\`";
    $sth = $dbh->prepare($query);
    $sth->execute;
    $sth->finish;

    foreach my $channel (keys(%{$FXirc{'channel'}})) {
      my $modes = "";
      my $userlist = "";
      my $banlist = "";
      my $exclist = "";
      my $geclist = "";
      my $invlist = "";

      my @op = ();
      my @half = ();
      my @voice = ();
      my @user = ();

      foreach my $nick (keys(%{$FXirc{'channel'}{$channel}{'names'}})) {
        if ($FXirc{'channel'}{$channel}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'o'}) {
          push(@op, $FXirc{'channel'}{$channel}{'names'}{lc($nick)}{'nick'});
        } elsif ($FXirc{'channel'}{$channel}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'h'}) {
          push(@half, $FXirc{'channel'}{$channel}{'names'}{lc($nick)}{'nick'});
        } elsif ($FXirc{'channel'}{$channel}{'names'}{lc($nick)}{'mode'} & $FXflags{'channel'}{'v'}) {
          push(@voice, $FXirc{'channel'}{$channel}{'names'}{lc($nick)}{'nick'});
        } else {
          push(@user, $FXirc{'channel'}{$channel}{'names'}{lc($nick)}{'nick'});
        }
      }

      @op = sort(@op);
      @half = sort(@half);
      @voice = sort(@voice);
      @user = sort(@user);

      foreach my $client (@op) { $userlist .= "\@" . $client . " "; }
      foreach my $client (@half) { $userlist .= "\%" . $client . " "; }
      foreach my $client (@voice) { $userlist .= "+" . $client . " "; }
      foreach my $client (@user) { $userlist .= $client . " "; }

      $userlist =~ tr/ //s; $userlist =~ s/\s+$//;

      if ($FXirc{'channel'}{$channel}{'banlist'}) {
        foreach my $ban (keys(%{$FXirc{'channel'}{$channel}{'banlist'}})) { $banlist .= $FXirc{'channel'}{$channel}{'banlist'}{$ban}{'mask'} . " "; }
      }

      if ($FXirc{'channel'}{$channel}{'exclist'}) {
        foreach my $exc (keys(%{$FXirc{'channel'}{$channel}{'exclist'}})) { $exclist .= $FXirc{'channel'}{$channel}{'exclist'}{$exc}{'mask'} . " "; }
      }

      if ($FXirc{'channel'}{$channel}{'geclist'}) {
        foreach my $gec (keys(%{$FXirc{'channel'}{$channel}{'geclist'}})) { $geclist .= $FXirc{'channel'}{$channel}{'geclist'}{$gec}{'mask'} . " "; }
      }

      if ($FXirc{'channel'}{$channel}{'invlist'}) {
        foreach my $inv (keys(%{$FXirc{'channel'}{$channel}{'invlist'}})) { $invlist .= $FXirc{'channel'}{$channel}{'invlist'}{$inv}{'mask'} . " "; }
      }

      $banlist =~ s/\s+$//;
      $exclist =~ s/\s+$//;
      $geclist =~ s/\s+$//;
      $invlist =~ s/\s+$//;

      foreach my $mode (keys(%{$FXflags{'channel'}})) {
        if ($FXirc{'channel'}{$channel}{'mode'} & $FXflags{'channel'}{$mode}) { $modes .= $mode; }
      }

      $query = sprintf("INSERT INTO \`channel\` \(channel, time, mode, topic, author, timeset, users, maxusers, maxuserstime, userlist, banlist, exclist, geclist, invlist\) VALUES \(\'%s\', \'%d\', \'%s\', \'%s\', \'%s\', \'%d\', \'%d\', \'%d\', \'%d\', \'%s\', \'%s\', \'%s\', \'%s\', \'%s\'\)", quotemeta($FXirc{'channel'}{$channel}{'channel'}), $FXirc{'channel'}{$channel}{'time'}, $modes, quotemeta($FXirc{'channel'}{$channel}{'topic'}{'string'}), quotemeta($FXirc{'channel'}{$channel}{'topic'}{'author'}), $FXirc{'channel'}{$channel}{'topic'}{'set'}, $FXirc{'channel'}{$channel}{'current'}, $FXirc{'channel'}{$channel}{'max'}, $FXirc{'channel'}{$channel}{'max_ts'}, $userlist, quotemeta($banlist), quotemeta($exclist), quotemeta($geclist), quotemeta($invlist));
      $sth = $dbh->prepare($query);
      $sth->execute;
      $sth->finish;
    }

    $dbh->disconnect;
    &putinfo("y", "MySQL stats have been saved");
    exit(0);
  }
}

1;