use strict;

our (%FXbot, %FXserv, %FXoper, %FXirc, %FXmsg, %FXcfg, %FXsock, %FXim, $LangPack);

$FXbot{'PageServ'}{'sub'} = {
  'HELP'   => \&ps_help,
  #'YAHOO'  => \&ps_yahoo,
  #'YMSG'   => \&ps_yahoo,
  'MSN'    => \&ps_msn,
  #'AIM'    => \&ps_aim,
  #'AOL'    => \&ps_aim,
  #'ICQ'    => \&ps_icq,
  'JABBER' => \&ps_jabber,
  'LIST'   => \&ps_list,
  'WHO'    => \&ps_who,
  'STATUS' => \&ps_status
};

$FXbot{'PageServ'}{'msn_sub'} = {
  'msn_connect'     => \&msn_connect,
  'msnx_connect'    => \&msnx_connect,
  'msn_board'       => \&msn_board,
  'msn_id'          => \&msn_id,
  'msn_parse'       => \&msn_parse,
  'msn_sjoin'       => \&msn_sjoin,
  'msn_introduce'   => \&msn_introduce,
  'msn_disconnect'  => \&msn_disconnect,
  'msn_addbuddy'    => \&msn_addbuddy,
  'msn_rembuddy'    => \&msn_rembuddy,
  'msn_renamebuddy' => \&msn_renamebuddy,
  'msn_text'        => \&msn_text,
  'msn_privmsg'     => \&msn_privmsg,
  'msn_remsession'  => \&msn_remsession
};

$FXbot{'PageServ'}{'jabber_sub'} = {
  'jabber_connect'     => \&jabber_connect,
  'jabber_output'      => \&jabber_output,
  'jabber_id'          => \&jabber_id,
  'jabber_parse'       => \&jabber_parse,
  'jabber_sjoin'       => \&jabber_sjoin,
  'jabber_introduce'   => \&jabber_introduce,
  'jabber_disconnect'  => \&jabber_disconnect,
  'jabber_addbuddy'    => \&jabber_addbuddy,
  'jabber_rembuddy'    => \&jabber_rembuddy,
  'jabber_renamebuddy' => \&jabber_renamebuddy,
  'jabber_text'        => \&jabber_text,
  'jabber_privmsg'     => \&jabber_privmsg,
  'jabber_remsession'  => \&jabber_remsession
};

$FXbot{'PageServ'}{'yahoo_sub'} = {
  'yahoo_connect'     => \&yahoo_connect,
  'yahoo_output'      => \&yahoo_output,
  'yahoo_id'          => \&yahoo_id,
  'yahoo_read'        => \&yahoo_read,
  'yahoo_parse'       => \&yahoo_parse,
  'yahoo_sjoin'       => \&yahoo_sjoin,
  'yahoo_introduce'   => \&yahoo_introduce,
  'yahoo_disconnect'  => \&yahoo_disconnect,
  'yahoo_addbuddy'    => \&yahoo_addbuddy,
  'yahoo_rembuddy'    => \&yahoo_rembuddy,
  'yahoo_renamebuddy' => \&yahoo_renamebuddy,
  'yahoo_text'        => \&yahoo_text,
  'yahoo_privmsg'     => \&yahoo_privmsg,
  'yahoo_remsession'  => \&yahoo_remsession
};

$FXbot{'PageServ'}{'public_sub'} = {
};

$FXbot{'PageServ'}{'other_sub'} = {
  'process_ps' => \&process_ps,
  'ps_notice'  => \&ps_notice,
  'ps_ctcp'    => \&ps_ctcp,
  'buddy_ctcp' => \&buddy_ctcp
};

my %im_name = (
  "msn"    => "MSN Messenger",
  "jabber" => "Jabber",
  "yahoo"  => "Yahoo! Messenger",
  "ICQ"    => "ICQ",
  "AIM"    => "AOL Instant Messanger"
);

sub connect_im {
  my $im_connect = {
    'msn'    => \&msn_connect,
    'yahoo'  => \&yahoo_connect,
    'icq'    => \&icq_connect,
    'aim'    => \&aim_connect,
    'jabber' => \&jabber_connect
  };

  foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
    if ($FXbot{'PageServ'}{$im . '_id'}) {
      $FXsock{$im} = "";
      &{$im_connect->{$im}}($FXbot{'PageServ'}{$im . '_server'}, $FXbot{'PageServ'}{$im . '_port'}, 0);
    }
  }

  return(0);
}

sub ps_notice {
  my ($nick, $format, @arg) = (shift, shift, @_);
  my $buffer = sprintf($format, @arg);

  &putsock($FXsock{'irc'}, ":%s %s %s :%s", $FXbot{'PageServ'}{'nick'}, $FXcfg{'general'}{'communicate'}, $nick, $buffer);
  return(0);
}

sub ps_ctcp {
  my ($nick, $notice, $format, @arg) = (shift, shift, @_);
  my $buffer = sprintf($format, @arg);

  &putsock($FXsock{'irc'}, ":%s %s %s :\cA%s\cA", $FXbot{'PageServ'}{'nick'}, $notice ? "NOTICE" : "PRIVMSG", $nick, $buffer);
  return(0);
}

sub buddy_ctcp {
  my ($nick, $buddy, $format, @arg) = (shift, shift, @_);
  my $buffer = sprintf($format, @arg);

  &putsock($FXsock{'irc'}, ":%s NOTICE %s :\cA%s\cA", $buddy, $nick, $buffer);
  return(0);
}

sub process_ps {
  my ($nick, $query) = (shift, shift);

  if (&check_flood($nick)) { return(0); }

  if ($query =~ /\cA(.*)\cA/) {
    my $ctcp = uc((split(/ /, $1, 0))[0]);

    if ($ctcp eq "VERSION") {
      &ps_ctcp($nick, 1, "VERSION %s", "FXserv IRC Services $FXserv{'version'}");
      &ps_ctcp($nick, 1, "VERSION %s", "Administrator: $FXserv{'admin'}");
      &putinfo("y", "%s: CTCP [%s] received from %s!%s\@%s", $FXbot{'PageServ'}{'nick'}, $ctcp, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    } elsif ($ctcp eq "PING") {
      &ps_ctcp($nick, 1, "PING %s", (split(/ /, $1, 0))[1]);
      &putinfo("y", "%s: CTCP [%s] received from %s!%s\@%s", $FXbot{'PageServ'}{'nick'}, $ctcp, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    } elsif ($ctcp eq "TIME") {
      &ps_ctcp($nick, 1, "TIME %s", scalar localtime());
      &putinfo("y", "%s: CTCP [%s] received from %s!%s\@%s", $FXbot{'PageServ'}{'nick'}, $ctcp, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    } else {
      &putinfo("y", "%s: CTCP [%s] received from %s!%s\@%s", $FXbot{'PageServ'}{'nick'}, $1, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    }

    return(0);
  }

  my $cmd = (split(/ /, $query, 0))[0];
  my $arg = (split(/ /, $query, 2))[1];

  if ($FXbot{'PageServ'}{'sub'}->{uc($cmd)}) {
    &{$FXbot{'PageServ'}{'sub'}->{uc($cmd)}}($nick, $arg);
  } else {
    &ps_notice($nick, $FXmsg{'unkn_cmd'}, $cmd);
  }

  return(0);
}

sub ps_help {
  my ($nick, $arg) = (shift, shift);

  if (!$arg) { $arg = "index"; }

  my $file = lc($arg);
  $file =~ s/ /\//g;
  $file = "help/" . $LangPack . "/pageserv/" . $file;

  if (!open(FILE, "<" . $file)) {
    &ps_notice($nick, $FXmsg{'no_help'}, $arg);
    return(0);
  }

  my @lines = <FILE>;
  close(FILE);

  foreach my $buffer (@lines) {
    chomp($buffer);
    $buffer = &substitute($buffer);

    if ($buffer =~ /^\%\+a/) {
      if (&valid_oper($nick, "a")) {
        $buffer =~ s/^\%\+a//;
        &ps_notice($nick, $buffer);
      }
    } elsif ($buffer =~ /^\%\+o/) {
      if (&valid_oper($nick, "o")) {
        $buffer =~ s/^\%\+o//;
        &ps_notice($nick, $buffer);
      }
    } else {
      &ps_notice($nick, $buffer);
    }
  }

  &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "HELP %s", $arg);
  return(0);
}

sub ps_status {
  my $nick = shift;

  &ps_notice($nick, "-- Connection status --");

  foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
    if ($FXbot{'PageServ'}{$im . '_id'}) {
      my $status = $FXsock{$im} ? "ONLINE" : "OFFLINE";
      &ps_notice($nick, "%s: %s (%s)", $im_name{$im}, $status, &format_time($FXim{$im}{'attempt'}));
    }
  }

  &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "STATUS");
  return(0);
}

sub ps_who {
  my $nick = shift;
  my $idx = 0;

  if (!&valid_oper($nick, "o")) {
    &ps_notice($nick, $FXmsg{'no_priv'});
    return(0);
  }

  &ps_notice($nick, "-- Chatting users --");
  &ps_notice($nick, "[User ID                  ] [Channel             ] [List                          ]");

  foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
    if (!$FXbot{'PageServ'}{$im . '_id'}) { next; }

    foreach my $session (keys(%{$FXim{$im}{'board'}})) {
      $idx++;
      my $list = "";

      foreach my $user (@{$FXim{$im}{'board'}{$session}{'nick'}}) { $list .=  $user . " "; }
      $list =~ s/\s+$//;

      &ps_notice($nick, "[%-25s] [%-20s] [%-30s]", $FXim{$im}{'board'}{$session}{'buddy'}, $FXim{$im}{'board'}{$session}{'channel'}, $list);
    }

  }

  &ps_notice($nick, "-- End of list [%d session%s] --", $idx, $idx > 1 ? "s" : "");

  &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "WHO");
  return(0);
}

sub ps_list {
  my ($nick, $filter) = (shift, shift);
  my $online = 0;
  my $idx = 0;
  my $verbose = 1;

  if (!&valid_oper($nick, "o")) { $verbose = 0; }

  my %medium = (
    "msn"    => " MSN  ",
    "yahoo"  => "  Y!  ",
    "jabber" => "Jabber",
    "icq"    => " ICQ  ",
    "aim"    => " AIM  "
  );


  &ps_notice($nick, "-- Listing contacts --");

  if ($verbose) {
    &ps_notice($nick, "[Medium] [User ID                  ] [Nickname       ] [Status] [Last seen      ]");
  } else {
    &ps_notice($nick, "[Medium] [Nickname       ] [Status] [Last seen      ]");
  }

  foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
    if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }
    if ($filter && ($filter ne $im)) { next; }

    foreach (keys(%{$FXim{$im}{'buddies'}})) {
      if (!$FXim{$im}{'buddies'}{$_}{'buddy'}) { next; }

      my $status = "";
      my $seen = "never";

      if ($FXim{$im}{'buddies'}{$_}{'seen'}) { $seen = &format_time($FXim{$im}{'buddies'}{$_}{'seen'}); }

      if ($FXim{$im}{'buddies'}{$_}{'online'}) {
        ++$online;
        $status = "ONLINE";
        $seen = "";
      }

      if ($verbose) {
        &ps_notice($nick, "[%-6s] [%-25s] [%-15s] [%-6s] [%-15s]", $medium{$im}, $FXim{$im}{'buddies'}{$_}{'id'}, $FXim{$im}{'buddies'}{$_}{'nick'}, $status, $seen);
      } else {
        &ps_notice($nick, "[%-6s] [%-15s] [%-6s] [%-15s]", $medium{$im}, $FXim{$im}{'buddies'}{$_}{'nick'}, $status, $seen);
      }

      ++$idx;
    }
  }

  &ps_notice($nick, "-- End of list [%d contact%s found, %d online] --", $idx, $idx > 1 ? "s" : "", $online);
  &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "LIST %s", $filter ? uc($filter) : "*");
  return(0);
}

sub ps_msn {
  my ($nick, $arg) = (shift, shift);

  if (!$arg) {
    &ps_notice($nick, $FXmsg{'syntax'}, "MSN <ADD|DEL|NICK|LIST> [id] [nick]");
    return(0);
  }

  my $idx = 0;
  my $online = 0;
  my $what = (split(/ /, $arg, 0))[0];
  my $id = (split(/ /, $arg, 0))[1];
  my $new = (split(/ /, $arg, 0))[2];

  if (!(($new =~ /^[a-zA-Z\[\]\{\}`^\\|]/) && ($new =~ /^[a-zA-Z0-9\[\]\{\}`^\\\-|]+$/))) { $new = ""; }

  if (uc($what) eq "NICK") {
    if (!&valid_oper($nick, "o")) {
      &ps_notice($nick, $FXmsg{'no_priv'});
      return(0);
    }

    if (!$id || !$new) {
      &ps_notice($nick, $FXmsg{'syntax'}, "MSN NICK <id> <nick>");
      return(0);
    }

    foreach (keys(%{$FXim{'msn'}{'buddies'}})) {
      if (!$FXim{'msn'}{'buddies'}{$_}{'buddy'}) { next; }

      if (lc($FXim{'msn'}{'buddies'}{$_}{'id'}) eq lc($id)) {
        $FXim{'msn'}{'buddies'}{$_}{'nick'} = $new;
        &ps_notice($nick, $FXmsg{'contact_nick'}, $id, $new);
        &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "MSN NICK %s %s", $id, $new);
        &msn_renamebuddy($id, $new);
        return(0);
      }
    }

    &ps_notice($nick, $FXmsg{'contact_unkn'}, $id);
    return(0);

  } elsif (uc($what) eq "ADD") {
    if (!$id) {
      &ps_notice($nick, $FXmsg{'syntax'}, "MSN ADD <id> [nick]");
      return(0);
    }

    if (!$FXsock{'msn'}) {
      &ps_notice($nick, $FXmsg{'im_offline'}, "MSN");
      return(0);
    }

    if (lc($id) eq lc($FXbot{'PageServ'}{'msn_id'})) {
      &ps_notice($nick, $FXmsg{'im_myself'});
      return(0);
    }

    foreach (keys(%{$FXim{'msn'}{'buddies'}})) {
      if ((lc($FXim{'msn'}{'buddies'}{$_}{'id'}) eq lc($id)) && $FXim{'msn'}{'buddies'}{$_}{'buddy'}) {
        &ps_notice($nick, $FXmsg{'contact_in'}, $id);
        return(0);
      }
    }

    if (!$new) {
      $new = (split(/\@/, $id, 0))[0];
      $new =~ s/\./_/g;
    }

    &msn_addbuddy($id, $new);
    &ps_notice($nick, $FXmsg{'contact_add'}, $id, $new);
    &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "MSN ADD %s [%s]", $id, $new);
    return(0);

  } elsif (uc($what) eq "DEL") {
    if (!$id) {
      &ps_notice($nick, $FXmsg{'syntax'}, "MSN DEL <id>");
      return(0);
    }

    if (!&valid_oper($nick, "o")) {
      &ps_notice($nick, $FXmsg{'no_priv'});
      return(0);
    }

    if (!$FXsock{'msn'}) {
      &ps_notice($nick, $FXmsg{'im_offline'}, "MSN");
      return(0);
    }

    my $found = 0;

    foreach (keys(%{$FXim{'msn'}{'buddies'}})) {
      if ((lc($FXim{'msn'}{'buddies'}{$_}{'id'}) eq lc($id)) && $FXim{'msn'}{'buddies'}{$_}{'buddy'}) {
        $found = 1;
        last;
      }
    }

    if ($found) {
      &msn_rembuddy($id);
      &ps_notice($nick, $FXmsg{'contact_del'}, $id);
      &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "MSN DEL %s", $id);
      return(0);
    } else {
      &ps_notice($nick, $FXmsg{'contact_unkn'}, $id);
      return(0);
    }

  } elsif (uc($what) eq "LIST") {
    &ps_list($nick, "msn");
    return(0);

  } else {
    &ps_notice($nick, $FXmsg{'syntax'}, "MSN <ADD|DEL|NICK|LIST> [id] [nick]");
    return(0);
  }
}

sub ps_jabber {
  my ($nick, $arg) = (shift, shift);

  if (!$arg) {
    &ps_notice($nick, $FXmsg{'syntax'}, "JABBER <ADD|DEL|NICK|LIST> [id] [nick]");
    return(0);
  }

  my $idx = 0;
  my $online = 0;
  my $what = (split(/ /, $arg, 0))[0];
  my $id = (split(/ /, $arg, 0))[1];
  my $new = (split(/ /, $arg, 0))[2];

  if (!(($new =~ /^[a-zA-Z\[\]\{\}`^\\|]/) && ($new =~ /^[a-zA-Z0-9\[\]\{\}`^\\\-|]+$/))) { $new = ""; }

  if (uc($what) eq "NICK") {
    if (!&valid_oper($nick, "o")) {
      &ps_notice($nick, $FXmsg{'no_priv'});
      return(0);
    }

    if (!$id || !$new) {
      &ps_notice($nick, $FXmsg{'syntax'}, "JABBER NICK <id> <nick>");
      return(0);
    }

    foreach (keys(%{$FXim{'jabber'}{'buddies'}})) {
      if (!$FXim{'jabber'}{'buddies'}{$_}{'buddy'}) { next; }

      if (lc($FXim{'jabber'}{'buddies'}{$_}{'id'}) eq lc($id)) {
        $FXim{'jabber'}{'buddies'}{$_}{'nick'} = $new;
        &ps_notice($nick, $FXmsg{'contact_nick'}, $id, $new);
        &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "JABBER NICK %s %s", $id, $new);
        &jabber_renamebuddy($id, $new);
        return(0);
      }
    }

    &ps_notice($nick, $FXmsg{'contact_unkn'}, $id);
    return(0);

  } elsif (uc($what) eq "ADD") {
    if (!$id) {
      &ps_notice($nick, $FXmsg{'syntax'}, "JABBER ADD <id> [nick]");
      return(0);
    }

    if (!$FXsock{'jabber'}) {
      &ps_notice($nick, $FXmsg{'im_offline'}, "Jabber");
      return(0);
    }

    if (lc($id) eq lc($FXbot{'PageServ'}{'jabber_id'})) {
      &ps_notice($nick, $FXmsg{'im_myself'});
      return(0);
    }

    foreach (keys(%{$FXim{'jabber'}{'buddies'}})) {
      if ((lc($FXim{'jabber'}{'buddies'}{$_}{'id'}) eq lc($id)) && $FXim{'jabber'}{'buddies'}{$_}{'buddy'}) {
        &ps_notice($nick, $FXmsg{'contact_in'}, $id);
        return(0);
      }
    }

    if (!$new) {
      $new = (split(/\@/, $id, 0))[0];
      $new =~ s/\./_/g;
    }

    &jabber_addbuddy($id, $new);
    &ps_notice($nick, $FXmsg{'contact_add'}, $id, $new);
    &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "JABBER ADD %s [%s]", $id, $new);
    return(0);

  } elsif (uc($what) eq "DEL") {
    if (!$id) {
      &ps_notice($nick, $FXmsg{'syntax'}, "JABBER DEL <id>");
      return(0);
    }

    if (!&valid_oper($nick, "o")) {
      &ps_notice($nick, $FXmsg{'no_priv'});
      return(0);
    }

    if (!$FXsock{'jabber'}) {
      &ps_notice($nick, $FXmsg{'im_offline'}, "Jabber");
      return(0);
    }

    my $found = 0;

    foreach (keys(%{$FXim{'jabber'}{'buddies'}})) {
      if ((lc($FXim{'jabber'}{'buddies'}{$_}{'id'}) eq lc($id)) && $FXim{'jabber'}{'buddies'}{$_}{'buddy'}) {
        $found = 1;
        last;
      }
    }

    if ($found) {
      &jabber_rembuddy($id);
      &ps_notice($nick, $FXmsg{'contact_del'}, $id);
      &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "JABBER DEL %s", $id);
      return(0);
    } else {
      &ps_notice($nick, $FXmsg{'contact_unkn'}, $id);
      return(0);
    }

  } elsif (uc($what) eq "LIST") {
    &ps_list($nick, "jabber");
    return(0);

  } else {
    &ps_notice($nick, $FXmsg{'syntax'}, "JABBER <ADD|DEL|NICK|LIST> [id] [nick]");
    return(0);
  }
}

sub ps_yahoo {
  my ($nick, $arg) = (shift, shift);

  if (!$arg) {
    &ps_notice($nick, $FXmsg{'syntax'}, "YAHOO <ADD|DEL|NICK|LIST> [id] [nick]");
    return(0);
  }

  my $idx = 0;
  my $online = 0;
  my $what = (split(/ /, $arg, 0))[0];
  my $id = (split(/ /, $arg, 0))[1];
  my $new = (split(/ /, $arg, 0))[2];

  if (!(($new =~ /^[a-zA-Z\[\]\{\}`^\\|]/) && ($new =~ /^[a-zA-Z0-9\[\]\{\}`^\\\-|]+$/))) { $new = ""; }

  if (uc($what) eq "NICK") {
    if (!&valid_oper($nick, "o")) {
      &ps_notice($nick, $FXmsg{'no_priv'});
      return(0);
    }

    if (!$id || !$new) {
      &ps_notice($nick, $FXmsg{'syntax'}, "YAHOO NICK <id> <nick>");
      return(0);
    }

    foreach (keys(%{$FXim{'yahoo'}{'buddies'}})) {
      if (!$FXim{'yahoo'}{'buddies'}{$_}{'buddy'}) { next; }

      if (lc($FXim{'yahoo'}{'buddies'}{$_}{'id'}) eq lc($id)) {
        $FXim{'yahoo'}{'buddies'}{$_}{'nick'} = $new;
        &ps_notice($nick, $FXmsg{'contact_nick'}, $id, $new);
        &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "YAHOO NICK %s %s", $id, $new);
        &yahoo_renamebuddy($id, $new);
        return(0);
      }
    }

    &ps_notice($nick, $FXmsg{'contact_unkn'}, $id);
    return(0);

  } elsif (uc($what) eq "ADD") {
    if (!$id) {
      &ps_notice($nick, $FXmsg{'syntax'}, "YAHOO ADD <id> [nick]");
      return(0);
    }

    if (!$FXsock{'yahoo'}) {
      &ps_notice($nick, $FXmsg{'im_offline'}, "Yahoo!");
      return(0);
    }

    if (lc($id) eq lc($FXbot{'PageServ'}{'yahoo_id'})) {
      &ps_notice($nick, $FXmsg{'im_myself'});
      return(0);
    }

    foreach (keys(%{$FXim{'yahoo'}{'buddies'}})) {
      if ((lc($FXim{'yahoo'}{'buddies'}{$_}{'id'}) eq lc($id)) && $FXim{'yahoo'}{'buddies'}{$_}{'buddy'}) {
        &ps_notice($nick, $FXmsg{'contact_in'}, $id);
        return(0);
      }
    }

    if (!$new) {
      $new = (split(/\@/, $id, 0))[0];
      $new =~ s/\./_/g;
    }

    &yahoo_addbuddy($id, $new);
    &ps_notice($nick, $FXmsg{'contact_add'}, $id, $new);
    &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "YAHOO ADD %s [%s]", $id, $new);
    return(0);

  } elsif (uc($what) eq "DEL") {
    if (!$id) {
      &ps_notice($nick, $FXmsg{'syntax'}, "YAHOO DEL <id>");
      return(0);
    }

    if (!&valid_oper($nick, "o")) {
      &ps_notice($nick, $FXmsg{'no_priv'});
      return(0);
    }

    if (!$FXsock{'yahoo'}) {
      &ps_notice($nick, $FXmsg{'im_offline'}, "Yahoo!");
      return(0);
    }

    my $found = 0;

    foreach (keys(%{$FXim{'yahoo'}{'buddies'}})) {
      if ((lc($FXim{'yahoo'}{'buddies'}{$_}{'id'}) eq lc($id)) && $FXim{'yahoo'}{'buddies'}{$_}{'buddy'}) {
        $found = 1;
        last;
      }
    }

    if ($found) {
      &yahoo_rembuddy($id);
      &ps_notice($nick, $FXmsg{'contact_del'}, $id);
      &servicelog($nick, $FXbot{'PageServ'}{'nick'}, "YAHOO DEL %s", $id);
      return(0);
    } else {
      &ps_notice($nick, $FXmsg{'contact_unkn'}, $id);
      return(0);
    }

  } elsif (uc($what) eq "LIST") {
    &ps_list($nick, "yahoo");
    return(0);

  } else {
    &ps_notice($nick, $FXmsg{'syntax'}, "YAHOO <ADD|DEL|NICK|LIST> [id] [nick]");
    return(0);
  }
}

1;