use strict;

our (%FXserv, %FXirc, %FXstats, $ts);

sub add_server {
  my ($server, $info, $time, $hop, $numeric, $hub) = (shift, shift, shift, shift, shift, shift);

  $FXirc{'server'}{lc($server)}{'name'} = $server;
  $FXirc{'server'}{lc($server)}{'info'} = $info;
  $FXirc{'server'}{lc($server)}{'time'} = $time;
  $FXirc{'server'}{lc($server)}{'hopcount'} = $hop;
  $FXirc{'server'}{lc($server)}{'numeric'} = $numeric;
  $FXirc{'server'}{lc($server)}{'hub'} = $hub;
  $FXirc{'server'}{lc($server)}{'leaf'} = ();
  $FXirc{'server'}{lc($server)}{'lag'} = 0;
  $FXirc{'server'}{lc($server)}{'ping'} = $ts;
  $FXirc{'server'}{lc($server)}{'pong'} = 0;
  $FXirc{'server'}{lc($server)}{'users'}{'current'} = 0;
  $FXirc{'server'}{lc($server)}{'users'}{'max'} = 0;
  $FXirc{'server'}{lc($server)}{'users'}{'max_ts'} = 0;
  $FXirc{'server'}{lc($server)}{'opers'}{'current'} = 0;
  $FXirc{'server'}{lc($server)}{'opers'}{'max'} = 0;
  $FXirc{'server'}{lc($server)}{'opers'}{'max_ts'} = 0;
  $FXirc{'server'}{lc($server)}{'version'} = "";
  @{$FXirc{'server'}{lc($server)}{'admin'}} = ();

  if (++$FXstats{'servers'}{'current'} > $FXstats{'servers'}{'max'}) {
    $FXstats{'servers'}{'max'} = $FXstats{'servers'}{'current'};
    $FXstats{'servers'}{'max_ts'} = $ts;
    if ($FXserv{'connected'} && !$FXserv{'netmerge'}) { &putinfo("x", "New max server count: %d", $FXstats{'servers'}{'current'}); }
  }

  return(0);
}

sub del_server {
  my $server = shift;

  foreach (keys(%{$FXirc{'server'}})) {
    if ($FXirc{'server'}{$_}{'leaf'}{lc($server)}) { delete($FXirc{'server'}{$_}{'leaf'}{lc($server)}); }
  }

  &putinfo("l", "Netsplit: %s (hub: %s)", $server, $FXirc{'server'}{lc($server)}{'hub'});
  delete($FXirc{'server'}{lc($server)});

  --$FXstats{'servers'}{'current'};

  return(0);
}

1;