use strict;

our (%FXbnet, %FXcfg, %FXflags, %FXfserv, %FXrcon, %FXim, %FXirc, %FXmsg, %FXbot, %FXserv, %FXoper, %FXsock, %FXstats, $bit, $bind, $LogEvent, $ts);
$bit = '';

sub add_socket {
  my ($socket, $type) = (shift, shift);

  $socket->autoflush(1);

  $FXsock{'list'}{$socket}{'sock'} = $socket;
  $FXsock{'list'}{$socket}{'host'} = $socket->peerhost() ? $socket->peerhost() : $socket->sockhost();
  $FXsock{'list'}{$socket}{'port'} = $socket->peerport() ? $socket->peerport() : $socket->sockport();
  $FXsock{'list'}{$socket}{'type'} = $type;
  $FXsock{'list'}{$socket}{'fileno'} = $socket->fileno();
  $FXsock{'list'}{$socket}{'time'} = $ts;

  vec($bit, $FXsock{'list'}{$socket}{'fileno'}, 1) = 1;

  if ($type eq "IRC") { $FXsock{'irc'} = $socket; }

  if ($FXbot{'PageServ'}{'enabled'}) {
    foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
      if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }
      if ($type eq uc($im)) { $FXsock{$im} = $socket; }
    }
  }

  return(0);
}

sub open_socket {
  my ($proto, $host, $port, $timeout) = (shift, shift, shift, shift);

  my $socket = IO::Socket::INET->new(
    Proto => $proto,
    PeerAddr => $host,
    PeerPort => $port,
    LocalAddr => $FXserv{'vhost'},
    Timeout => $timeout
  );

  if (!$socket) { return(0); }
  return($socket);
}

sub init_listen {
  my ($port, $proto, $type) = (shift, shift, shift);

  foreach (keys(%{$FXsock{'list'}})) {
    if ((($FXsock{'list'}{$_}{'type'} eq "BOT-A") || ($FXsock{'list'}{$_}{'type'} eq "DCC-A") || ($FXsock{'list'}{$_}{'type'} eq "FSERV-A") || ($FXsock{'list'}{$_}{'type'} eq "FSERV-B") || ($FXsock{'list'}{$_}{'type'} eq "RCON-A")) && ($port == $FXsock{'list'}{$_}{'port'})) { return(0); }
  }

  my $listen = IO::Socket::INET->new(
    Proto => $proto,
    LocalPort => $port,
    LocalAddr => $FXserv{'vhost'},
    Listen => 1,
    Reuse => 1
  );

  if (!$listen) { return(0); }

  &add_socket($listen, $type);
  return($listen);
}

sub loop_socket {
  my $rin = $bit; $rin =~ /[^\0]/ || next;
  my $idx = select($rin, undef, undef, 1);
  my $buffer = "";

  $idx || next;
  $idx > 0 || die($!);

  my %list = %{$FXsock{'list'}};

  while ($idx && (my ($socket, $value) = each(%list))) {
    $socket = $value->{'sock'};

    if (vec($rin, $value->{'fileno'}, 1)) {
      if (($value->{'type'} eq "MSN-X") || ($value->{'type'} eq "YAHOO") || ($value->{'type'} eq "ICQ") || ($value->{'type'} eq "AIM") || ($value->{'type'} eq "JABBER") || ($value->{'type'} eq "RCON")) {
        recv($socket, $buffer, 16384, 0);
      } elsif (($value->{'type'} eq "FSERV-C") || ($value->{'type'} eq "FSERV-X") || ($value->{'type'} eq "FSERV-G")) {
        recv($socket, $buffer, $FXbot{'FileServ'}{'fserv_buffer'}, 0);
      } else {
        $buffer = <$socket>;
      }

      if (!$buffer) {
        if (($value->{'type'} eq "DCC-A") || ($value->{'type'} eq "FSERV-A") || ($value->{'type'} eq "FSERV-B") || ($value->{'type'} eq "BOT-A") || ($value->{'type'} eq "RCON-A")) {
          &process_socket($socket, undef);
        } else {
          &del_socket($socket);
        }
      } else {
        &process_socket($socket, $buffer);
      }
    }
  }
}

sub putsock {
  my ($socket, $format, @arg) = (shift, shift, @_);
  my $buffer = sprintf($format, @arg);

  if ($socket == $FXsock{'irc'}) {
    $FXserv{'out'} += length($buffer);
    if ($FXserv{'debug'}) { &putlog(0, "OUT: $buffer"); }
  }

  print $socket $buffer . "\n";

  return(0);
}

sub putinfo {
  my ($flag, $format, @arg) = (shift, shift, @_);
  my $buffer = sprintf($format, @arg);

  &putlog($flag, $buffer);

  foreach (keys(%{$FXsock{'list'}})) {
    if ($FXsock{'list'}{$_}{'type'} eq "DCC") {
      if (!$flag || ($FXoper{lc($FXsock{'list'}{$_}{'oper'})}{'umodes'} & $FXflags{'event'}{$flag})) { &putsock($FXsock{'list'}{$_}{'sock'}, "[%s] %s%s", strftime("%H:%M:%S", localtime), !$flag ? "" : "*** ", $buffer); }
    }
  }

  return(0);
}

sub process_socket {
  my ($socket, $buffer) = (shift, shift);

  if ($FXsock{'list'}{$socket}{'type'} eq "IRC") {
    chomp($buffer);
    $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;

    if ($FXserv{'debug'}) { &putlog(0, "IN: $buffer"); }

    my $cmd = (split(/ /, $buffer, 2))[0]; $cmd = uc($cmd);

    $FXserv{'pong'} = $ts;
    $FXserv{'in'} += length($buffer);

    if (substr($buffer, 0, 1) eq ":") {
      $cmd = (split(/ /, $buffer, 3))[1];
      $cmd = uc($cmd);
      if ($bind->{$cmd}) { &{$bind->{$cmd}}($buffer); }
    } else {
      if ($bind->{$cmd}) { &{$bind->{$cmd}}($buffer); }
    }

    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "DCC") {
    $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;
    &dcc_parse($socket, $buffer);
    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "DCC-A") {
    my $remote = $socket->accept();

    &add_socket($remote, "DCC-B");

    $FXsock{'list'}{$remote}{'user'} = "telnet";

    &putinfo("y", "Received connection from [%s:%d] on port %d", $FXsock{'list'}{$remote}{'host'}, $FXsock{'list'}{$remote}{'port'}, $remote->sockport());
    &putsock($remote, "Enter nickname:");
    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "DCC-B") {
    chomp($buffer);
    $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s; $buffer =~ s/[\200-\377]//g;

    $FXsock{'list'}{$socket}{'nick'} = $buffer;
    $FXsock{'list'}{$socket}{'type'} = "DCC-C";
    $FXsock{'list'}{$socket}{'time'} = $ts;

    &putsock($socket, "Enter password:");
    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "DCC-C") {
    chomp($buffer);
    $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;
    my $nick = $FXsock{'list'}{$socket}{'nick'};

    if (!$FXoper{lc($nick)}) {
      &putsock($socket, "Invalid User\r");
      &putinfo("y", "Unauthorized connection attempt from [%s\@%s:%d] on port %d", $nick, $FXsock{'list'}{$socket}{'host'}, $FXsock{'list'}{$socket}{'port'}, $socket->sockport());
      $FXsock{'list'}{$socket}{'type'} = "DCC-E";
      &del_socket($socket);
      return(0);
    }

    if ($FXoper{lc($nick)}{'name'} ne $nick) {
      &putsock($socket, "Invalid password\r");
      &putinfo("y", "Unauthorized connection attempt from [%s\@%s:%d] on port %d", $nick, $FXsock{'list'}{$socket}{'host'}, $FXsock{'list'}{$socket}{'port'}, $socket->sockport());
      $FXsock{'list'}{$socket}{'type'} = "DCC-E";
      &del_socket($socket);
      return(0);
    }

    if ($buffer ne $FXoper{lc($nick)}{'password'}) {
      &putsock($socket, "Invalid password\r");
      &putinfo("y", "Unauthorized connection attempt from [%s\@%s:%d] on port %d", $nick, $FXsock{'list'}->{$socket}->{'host'}, $FXsock{'list'}->{$socket}->{'port'}, $socket->sockport());
      $FXsock{'list'}->{$socket}->{'type'} = "DCC-E";
      &del_socket($socket);
      return(0);
    }

    my $idx = 0;

    if ($FXstats{'partyline'} + 1 > $FXcfg{'general'}{'max_connections'}) {
      &putsock($socket, $FXmsg{'dcc_max'});
      $FXsock{'list'}{$socket}{'type'} = "DCC-E";
      &del_socket($socket);
      return(0);
    }

    ++$FXstats{'partyline'};

    $FXsock{'list'}{$socket}{'type'} = "DCC";
    $FXsock{'list'}{$socket}{'oper'} = $nick;
    $FXsock{'list'}{$socket}{'lastcmd'} = $ts;
    &send_motd($socket, $FXcfg{'files'}{'motd'});

    my $prefix = "User";

    if (&valid_oper($socket, "a")) {
      $prefix = "Admin";
    } elsif (&valid_oper($socket, "o")) {
      $prefix = "Oper";
    }

    &putinfo(0, "%s %s (%s\@%s) has connected", $prefix, $FXsock{'list'}{$socket}{'nick'}, $FXsock{'list'}{$socket}{'user'}, $FXsock{'list'}{$socket}{'host'});
    &putbnet("(%s) %s %s (%s\@%s) has connected", $FXbot{'DataServ'}{'nick'}, $prefix, $FXsock{'list'}{$socket}{'nick'}, $FXsock{'list'}{$socket}{'user'}, $FXsock{'list'}{$socket}{'host'});
    return(0);
 
  } elsif ($FXsock{'list'}{$socket}{'type'} eq "BOT-A") {
    my $remote = $socket->accept();

    &add_socket($remote, "BOT-B");

    &putinfo("b", "Received bot connection from [%s:%d] on port %d", $FXsock{'list'}{$remote}{'host'}, $FXsock{'list'}{$remote}{'port'}, $remote->sockport());
    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "BOT-B") {
    chomp($buffer);
    $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;

    foreach (keys(%FXbnet)) {
      if (!$FXbnet{$_}{'sock'} && ((split(/ /, $buffer, 0))[0] eq $FXbot{'DataServ'}{'nick'}) && ((split(/ /, $buffer, 0))[1] eq $FXbnet{$_}{'nick'}) && ((split(/ /, $buffer, 0))[2] eq $FXbnet{$_}{'password'})) {
        $FXbnet{$_}{'sock'} = $socket;
        $FXbnet{$_}{'prefix'} = "<-";
        $FXsock{'list'}{$socket}{'type'} = "BOT";
        &putinfo("b", "Linked to %s [%s:%d]", $FXbnet{$_}{'nick'}, $FXbnet{$_}{'host'}, $FXsock{'list'}{$socket}{'port'});
        &putbnet("(%s) Linked to %s [%s:%d]", $FXbot{'DataServ'}{'nick'}, $FXbnet{$_}{'nick'}, $FXbnet{$_}{'host'}, $FXsock{'list'}{$socket}{'port'});
        return(0);
      }
    }

    $FXsock{'list'}{$socket}{'type'} = "BOT-C";
    &del_socket($socket);
    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "BOT") {
    chomp($buffer);
    $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;

    if (($buffer =~ /^<\S+> .*/) || ($buffer =~ /^\(\S+\) .*/)) {
      foreach (keys(%{$FXsock{'list'}})) {
        if ($FXsock{'list'}{$_}{'type'} eq "DCC") { &putsock($FXsock{'list'}{$_}{'sock'}, $buffer); }
      }

      foreach (keys(%FXbnet)) {
        if ($FXbnet{$_}{'sock'} ne $socket) { &putsock($FXbnet{$_}{'sock'}, $buffer); }
      }

      return(0);
    }

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "FSERV-A") {
    my $remote = $socket->accept();

    &add_socket($remote, "FSERV");

    my $nick = $FXsock{'list'}{$socket}{'nick'};

    $FXsock{'list'}{$remote}{'nick'} = $nick;
    $FXsock{'list'}{$remote}{'lastcmd'} = $ts;
    $FXsock{'list'}{$remote}{'floodcnt'} = 0;
    $FXsock{'list'}{$remote}{'warning'} = 0;
    $FXsock{'list'}{$remote}{'folder'} = "/";
    $FXsock{'list'}{$remote}{'fserv'} = $remote->peerhost();
    &del_socket($socket);

    my $ip = $FXsock{'list'}{$remote}{'fserv'};

    if (!$FXfserv{'list'}{$ip}) {
      $FXfserv{'list'}{$ip}{'time'} = $ts;
      $FXfserv{'list'}{$ip}{'ip'} = $ip;
      $FXfserv{'list'}{$ip}{'nick'} = $nick;
      $FXfserv{'list'}{$ip}{'xfer'} = 0;
      $FXfserv{'list'}{$ip}{'total'} = 0;
      $FXfserv{'list'}{$ip}{'traffic'} = 0;
      @{$FXfserv{'list'}{$ip}{'queue'}} = ();
      if ($FXbot{'FileServ'}{'fserv_cps'} > 0) { $FXfserv{'list'}{$ip}{'limitcps'} = 0; }
    }

    $FXfserv{'list'}{$ip}{'sock'} = $remote;

    foreach (keys(%{$FXfserv{'query'}})) {
      if (lc($FXfserv{'query'}{$_}{'nick'}) eq lc($nick)) {
        delete($FXfserv{'query'}{$_});
        last;
      }
    }

    &putinfo("s", "%s: %s (%s\@%s) has connected", $FXbot{'FileServ'}{'nick'}, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    &send_motd($remote, $FXbot{'FileServ'}{'fserv_welcome'});
    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "FSERV-B") {
    my $remote = $socket->accept();

    &add_socket($remote, "FSERV-C");

    $FXsock{'list'}{$remote}{'fserv'} = $FXsock{'list'}{$socket}{'fserv'};
    $FXsock{'list'}{$remote}{'start'} = $ts;
    $FXsock{'list'}{$remote}{'absolute'} = $FXsock{'list'}{$socket}{'absolute'};
    $FXsock{'list'}{$remote}{'seek'} = $FXsock{'list'}{$socket}{'seek'};
    &del_socket($socket);

    &fserv_send($remote, $FXsock{'list'}{$remote}{'seek'});
    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "FSERV-C") {
    my $size = unpack("N", $buffer);
    my $ip = $FXsock{'list'}{$socket}{'fserv'};

    if ($FXbot{'FileServ'}{'fserv_cps'} > 0) {
      if ($FXfserv{'list'}{$ip}{'limitcps'} >= $FXbot{'FileServ'}{'fserv_cps'}) {
        $FXfserv{'list'}{$ip}{'limitcps'} = 0;
        $FXsock{'list'}{$socket}{'type'} = "FSERV-X";
      } else {
        &fserv_send($socket, $FXsock{'list'}{$socket}{'seek'});
      }
    } else {
      &fserv_send($socket, $FXsock{'list'}{$socket}{'seek'});
    }

    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "FSERV-G") {
    my $handle = $FXsock{'list'}{$socket}{'filehd'};
    print $handle $buffer;

    $FXsock{'list'}{$socket}{'time'} = $ts;
    $FXsock{'list'}{$socket}{'read'} += length($buffer);

    print $socket pack("N", $FXsock{'list'}{$socket}{'read'});

    if ($FXsock{'list'}{$socket}{'read'} == $FXsock{'list'}{$socket}{'size'}) {
      close($handle);

      my $nick = $FXsock{'list'}{$socket}{'nick'};
      my $cps  = $FXsock{'list'}{$socket}{'size'};
      if ($ts - $FXsock{'list'}{$socket}{'start'} > 0) { $cps = $FXsock{'list'}{$socket}{'size'} / ($ts - $FXsock{'list'}{$socket}{'start'}); }

      &xs_notice($nick, "DCC Get of %s (%s) complete (%s, %s/sec)", $FXsock{'list'}{$socket}{'file'}, &format_size($FXsock{'list'}{$socket}{'size'}), &format_time($FXsock{'list'}{$socket}{'start'}), &format_size($cps));
      &putinfo("s", "%s: %s!%s\@%s DCC Send %s (%s) [complete]", $FXbot{'FileServ'}{'nick'}, $nick, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $FXsock{'list'}{$socket}{'file'}, &format_size($FXsock{'list'}{$socket}{'size'}));
      $FXsock{'list'}{$socket}{'type'} = "FSERV-Y";
      &del_socket($socket);
    }

    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "FSERV") {
    chomp($buffer);
    $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;

    &fserv_parse($socket, $buffer);
    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "RCON-A") {
    my $remote = $socket->accept();

    &add_socket($remote, "RCON");

    my $nick = $FXsock{'list'}{$socket}{'nick'};
    my $server = $FXsock{'list'}{$socket}{'server'};
    my $password = $FXsock{'list'}{$socket}{'password'};

    $FXsock{'list'}{$remote}{'nick'} = $nick;
    $FXsock{'list'}{$remote}{'lastcmd'} = $ts;
    $FXsock{'list'}{$remote}{'floodcnt'} = 0;
    $FXsock{'list'}{$remote}{'warning'} = 0;
    $FXsock{'list'}{$remote}{'ip'} = $remote->peerhost();
    &del_socket($socket);

    my $ip = $FXsock{'list'}{$remote}{'ip'};

    if (!$FXrcon{'list'}{$ip}) {
      $FXrcon{'list'}{$ip}{'time'} = $ts;
      $FXrcon{'list'}{$ip}{'ip'} = $ip;
      $FXrcon{'list'}{$ip}{'nick'} = $nick;
      $FXrcon{'list'}{$ip}{'server'} = $server;
      $FXrcon{'list'}{$ip}{'password'} = $password;
    }

    $FXrcon{'list'}{$ip}{'sock'} = $remote;

    foreach (keys(%{$FXrcon{'query'}})) {
      if (lc($FXrcon{'query'}{$_}{'nick'}) eq lc($nick)) {
        delete($FXrcon{'query'}{$_});
        last;
      }
    }

    &putinfo("s", "%s: %s (%s\@%s) has connected", $FXbot{'GameServ'}{'nick'}, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    &send_motd($remote, $FXbot{'GameServ'}{'rcon_welcome'});
    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "RCON") {
    chomp($buffer);
    $buffer =~ s/\s+$//; $buffer =~ s/^\s+//; $buffer =~ tr/ //s;

    &rcon_parse($socket, $buffer);
    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "MSN") {
    &msn_parse($buffer);
    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "MSN-X") {
    &msn_board($FXsock{'list'}{$socket}{'session'}, $FXsock{'list'}{$socket}{'sock'}, $buffer);
    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "YAHOO") {
    my @packet = ();

    foreach (split(//, $buffer)) { push(@packet, ord($_)); }

    $FXim{'yahoo'}{'flaprecv'}{'size'} = $FXim{'yahoo'}{'flapbytes'} = &bytes2int(@packet, 8, 2) + 20;
    $FXim{'yahoo'}{'flaprecv'}{'packlen'} = &bytes2int(@packet, 8, 2);
    $FXim{'yahoo'}{'flaprecv'}{'service'} = &bytes2str(@packet, 10, 2);
    $FXim{'yahoo'}{'flaprecv'}{'status'} = &bytes2int(@packet, 12, 4);
    $FXim{'yahoo'}{'sessid'} = &bytes2int(@packet, 16, 4);

    for (my $idx = 0; $idx < scalar @packet; $idx++) {
      if ($FXim{'yahoo'}{'flapbytes'} > 0) {
        push(@{$FXim{'yahoo'}{'flaprecv'}{'data'}}, $packet[$idx]);

        if (--$FXim{'yahoo'}{'flapbytes'} <= 0) {
          &yahoo_parse(%{$FXim{'yahoo'}{'flaprecv'}});
          $FXim{'yahoo'}{'flaprecv'} = undef;
          $FXim{'yahoo'}{'flapbytes'} = 0;
        }

        next;
      }
    }

    return(0);

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "JABBER") {
    if (substr($buffer, 0, 14) eq "<stream:stream") {
      $buffer = substr($buffer, 0, -1);
      $buffer .= "/>";
    }

    if (substr($buffer, -16) eq "</stream:stream>") { $buffer = substr($buffer, 0, -16); }

    $buffer = "<jabber>" . $buffer . "</jabber>";

    &jabber_parse($buffer);
    return(0);
  }
}

sub del_socket {
  my $socket = shift;

  if ($FXsock{'list'}{$socket}{'type'} eq "IRC") {
    &putinfo("y", "Disconnected from IRC server %s:%d", $FXcfg{'hub'}{'host'}, $FXcfg{'hub'}{'port'});
    $FXserv{'connected'} = 0;
    $FXserv{'attempt'} = $ts;
    $FXserv{'ping'} = 0;
    $FXserv{'pong'} = 0;
    $FXserv{'hub'} = "";
    $FXserv{'in'} = 0;
    $FXserv{'out'} = 0;

    $FXsock{'irc'} = "";

    &cleanup_vars();

    foreach (keys(%{$FXstats{'tld'}})) { $FXstats{'tld'}{$_}{'current'} = 0; }
    foreach (keys(%{$FXstats{'domain'}})) { $FXstats{'domain'}{$_}{'current'} = 0; }

    if ($FXbot{'PageServ'}{'enabled'}) {
      foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
        if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }

        foreach (keys(%{$FXim{$im}{'buddies'}})) {
          if ($FXim{$im}{'buddies'}{$_}{'ircnick'}) { $FXim{$im}{'buddies'}{$_}{'ircnick'} = ""; }
        }
      }
    }

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "BOT-B") {
    &putinfo("b", "Lost bot connection to [%s:%d] on port %d", $FXsock{'list'}{$socket}{'host'}, $FXsock{'list'}{$socket}{'port'}, $socket->sockport());

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "BOT-C") {
    &putinfo("b", "Unauthorized bot connection received from [%s:%d] on port %d", $FXsock{'list'}{$socket}{'host'}, $FXsock{'list'}{$socket}{'port'}, $socket->sockport());

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "BOT") {
    foreach (keys(%FXbnet)) {
      if ($FXsock{'list'}{$socket}{'sock'} eq $FXbnet{$_}{'sock'}) {
        &putinfo("b", "Bot %s [%s:%d] has disconnected", $FXbnet{$_}{'nick'}, $FXbnet{$_}{'host'}, $FXsock{'list'}{$socket}{'port'});
        &putbnet("(%s) Bot %s (%s:%d) has disconnected", $FXbot{'DataServ'}{'nick'}, $FXbnet{$_}{'nick'}, $FXbnet{$_}{'host'}, $FXsock{'list'}{$socket}{'port'});

        $FXbnet{$_}{'prefix'} = "";
        $FXbnet{$_}{'sock'} = "";
        $FXbnet{$_}{'attempt'} = $ts;
      }
    }

  } elsif (($FXsock{'list'}{$socket}{'type'} eq "DCC-B") || ($FXsock{'list'}{$socket}{'type'} eq "DCC-C")) {
    &putinfo("y", "Lost connection to [%s\@%s:%d]", $FXsock{'list'}{$socket}{'user'}, $FXsock{'list'}{$socket}{'host'}, $FXsock{'list'}{$socket}{'port'});

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "DCC-D") {
    &putinfo("y", "Lost DCC connection to %s [%s\@%s]", $FXsock{'list'}{$socket}{'nick'}, $FXsock{'list'}{$socket}{'user'}, $FXsock{'list'}{$socket}{'host'});

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "DCC") {
    --$FXstats{'partyline'};
    my $prefix = "User";

    if (&valid_oper($socket, "a")) {
      $prefix = "Admin";
    } elsif (&valid_oper($socket, "o")) {
      $prefix = "Oper";
    }

    &putinfo(0, "%s %s (%s\@%s) has disconnected", $prefix, $FXsock{'list'}{$socket}{'nick'}, $FXsock{'list'}{$socket}{'user'}, $FXsock{'list'}{$socket}{'host'});
    &putbnet("(%s) %s %s (%s\@%s) has disconnected", $FXbot{'DataServ'}{'nick'}, $prefix, $FXsock{'list'}{$socket}{'nick'}, $FXsock{'list'}{$socket}{'user'}, $FXsock{'list'}{$socket}{'host'});

  } elsif (($FXsock{'list'}{$socket}{'type'} eq "FSERV-C") || ($FXsock{'list'}{$socket}{'type'} eq "FSERV-X")) {
    my $ip = $FXsock{'list'}{$socket}{'fserv'};
    my ($vol, $dir, $file) = File::Spec->splitpath($FXsock{'list'}{$socket}{'absolute'});

    --$FXfserv{'list'}{$ip}{'xfer'};

    if ($FXfserv{'list'}{$ip}{'sock'}) {
      &putsock($FXfserv{'list'}{$ip}{'sock'}, "DCC Send of %s (%s) incomplete", $file, &format_size(-s $FXsock{'list'}{$socket}{'absolute'}));
    } else {
      &xs_notice($FXfserv{'list'}{$ip}{'nick'}, "DCC Send of %s (%s) incomplete", $file, &format_size(-s $FXsock{'list'}{$socket}{'absolute'}));
    }

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "FSERV-G") {
    my $nick = $FXsock{'list'}{$socket}{'nick'};

    if ($FXirc{'client'}{lc($nick)}{'nick'}) {
      &xs_notice($nick, "DCC Get of %s (%s) incomplete", $FXsock{'list'}{$socket}{'file'}, &format_size($FXsock{'list'}{$socket}{'size'}));
      &putinfo("s", "%s: %s!%s\@%s DCC Send %s (%s) [failed]", $FXbot{'FileServ'}{'nick'}, $nick, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $FXsock{'list'}{$socket}{'file'}, &format_size($FXsock{'list'}{$socket}{'size'}));
    } else {
      &putinfo("s", "%s: %s\@%s DCC Send %s (%s) [failed]", $FXbot{'FileServ'}{'nick'}, $nick, $FXsock{'list'}{$socket}{'fserv'}, $FXsock{'list'}{$socket}{'file'}, &format_size($FXsock{'list'}{$socket}{'size'}));
    }

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "FSERV") {
    my $ip = $FXsock{'list'}{$socket}{'fserv'};
    my $nick = $FXfserv{'list'}{$ip}{'nick'};

    if ($FXirc{'client'}{lc($nick)}{'nick'}) { &putinfo("s", "%s: %s (%s\@%s) has disconnected", $FXbot{'FileServ'}{'nick'}, $nick, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}); }

    $FXfserv{'list'}{$ip}{'sock'} = "";
    if (!$FXfserv{'list'}{$ip}{'xfer'}) { delete($FXfserv{'list'}{$ip}); }

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "RCON") {
    my $ip = $FXsock{'list'}{$socket}{'ip'};
    my $nick = $FXrcon{'list'}{$ip}{'nick'};

    if ($FXirc{'client'}{lc($nick)}{'nick'}) {
      &putinfo("s", "%s: %s (%s\@%s) has disconnected", $FXbot{'GameServ'}{'nick'}, $nick, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'});
    } else {
      &putinfo("s", "%s: %s (%s) has disconnected", $FXbot{'GameServ'}{'nick'}, $nick, $ip);
    }

    delete($FXrcon{'list'}{$ip});

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "MSN") {
    $FXsock{'msn'} = "";
    $FXim{'msn'}{'attempt'} = $ts;

    if ($FXim{'msn'}{'ns'}) {
      &putinfo("y", "Disconnected from MSN server %s:%d", $FXbot{'PageServ'}{'msn_server'}, $FXbot{'PageServ'}{'msn_port'});

      foreach my $session (keys(%{$FXim{'msn'}{'board'}})) { &msn_remsession($session, "*"); }

      foreach (keys(%{$FXim{'msn'}{'buddies'}})) {
        if (!$FXim{'msn'}{'buddies'}{$_}{'buddy'} || !$FXim{'msn'}{'buddies'}{$_}{'online'}) { next; }
        &msn_disconnect($FXim{'msn'}{'buddies'}{$_}{'id'}, "Disconnected");
      }

      $FXim{'msn'}{'ns'} = 0;
      $FXim{'msn'}{'board'} = ();
    }

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "YAHOO") {
    $FXsock{'yahoo'} = "";
    $FXim{'yahoo'}{'attempt'} = $ts;

    &putinfo("y", "Disconnected from Yahoo! server %s:%d", $FXbot{'PageServ'}{'yahoo_server'}, $FXbot{'PageServ'}{'yahoo_port'});

    foreach my $session (keys(%{$FXim{'yahoo'}{'board'}})) { &yahoo_remsession($session, "*"); }

    foreach (keys(%{$FXim{'yahoo'}{'buddies'}})) {
      if (!$FXim{'yahoo'}{'buddies'}{$_}{'buddy'} || !$FXim{'yahoo'}{'buddies'}{$_}{'online'}) { next; }
      &yahoo_disconnect($FXim{'yahoo'}{'buddies'}{$_}{'id'}, "Disconnected");
    }

    $FXim{'yahoo'}{'board'} = ();

  } elsif ($FXsock{'list'}{$socket}{'type'} eq "JABBER") {
    &jabber_output($FXsock{'jabber'}, "</stream:stream>");

    $FXsock{'jabber'} = "";
    $FXim{'jabber'}{'attempt'} = $ts;

    &putinfo("y", "Disconnected from Jabber server %s:%d", $FXbot{'PageServ'}{'jabber_server'}, $FXbot{'PageServ'}{'jabber_port'});

    foreach my $session (keys(%{$FXim{'jabber'}{'board'}})) { &jabber_remsession($session, "*"); }

    foreach (keys(%{$FXim{'jabber'}{'buddies'}})) {
      if (!$FXim{'jabber'}{'buddies'}{$_}{'buddy'} || !$FXim{'jabber'}{'buddies'}{$_}{'online'}) { next; }
      &jabber_disconnect($FXim{'jabber'}{'buddies'}{$_}{'id'}, "Disconnected");
    }

    $FXim{'jabber'}{'board'} = ();
  }

  vec($bit, $FXsock{'list'}{$socket}{'fileno'}, 1) = 0;
  $FXsock{'list'}{$socket}{'sock'}->close();
  delete($FXsock{'list'}{$socket});
  return(0);
}

1;