use strict;

our (%FXbnet, %FXstatus, %FXcfg, %FXfserv, %FXirc, %FXmsg, %MySQL, %FXim, %FXbot, %FXserv, %FXstats, %FXsock, %FXscan, $scan, $ts, $LogFile);
my $last = 0;

sub loop_timer {
  $ts = time();

  if ($FXbot{'ScanServ'}{'enabled'}) {
    if ($scan) {
      &scan_reaper();
    } else {
      if (scalar(keys(%FXstatus))) { %FXstatus = (); }
    }
  }

  if ($last == $ts) { return(0); }

  $last = $ts;

  &timer_check();
  if ($FXserv{'connected'}) { &timer_online(); }

  return(0);
}

sub timer_online {
  if ($ts - $FXserv{'pong'} > $FXcfg{'general'}{'ping'}) {
    &putinfo("y", "Ping timeout (%dsec) for IRC server %s:%d", $FXcfg{'general'}{'ping'}, $FXcfg{'hub'}{'host'}, $FXcfg{'hub'}{'port'});
    &disconnect("Ping timeout");
    return(0);
  }

  if ($FXserv{'netmerge'} && ($ts - $FXserv{'netmerge'} > 2)) { $FXserv{'netmerge'} = 0; }

  if ($ts - $FXserv{'ping'} > 60) {
    $FXserv{'ping'} = $ts;

    foreach (keys(%{$FXirc{'server'}})) {
      if ($FXirc{'server'}{$_}{'name'} eq $FXserv{'name'}) { next; }

      if (!$FXirc{'server'}{$_}{'pong'}) {
        $FXirc{'server'}{$_}{'ping'} = $ts;
        $FXirc{'server'}{$_}{'pong'} = 1;
        &putsock($FXsock{'irc'}, ":%s PING %s :%s", $FXserv{'name'}, $FXserv{'hub'}, $FXirc{'server'}{$_}{'name'});
      }
    }
  }

  foreach (keys(%{$FXirc{'client'}})) {
    if ($FXirc{'client'}{$_}{'ignored'} && ($ts - $FXirc{'client'}{$_}{'ignored'} > $FXcfg{'general'}{'flood_ignore'})) {
      $FXirc{'client'}{$_}{'lastcmd'} = 0;
      $FXirc{'client'}{$_}{'floodcnt'} = 0;
      $FXirc{'client'}{$_}{'ignored'} = 0;
      &putinfo("y", "Expired ignore: %s (%s\@%s)", $FXirc{'client'}{$_}{'nick'}, $FXirc{'client'}{$_}{'user'}, $FXirc{'client'}{$_}{'host'});
    }
  }

  if ($FXbot{'ScanServ'}{'enabled'}) {
    foreach my $id (keys(%{$FXscan{'scan'}})) {
      my $nick = $FXscan{'scan'}{$id}{'nick'};
      my $unsecure = 0;

      if (!$FXirc{'client'}{lc($nick)}) {
        &scan_del($nick, "scan");
        delete($FXscan{'scan'}{$id});
        next;
      }

      if ($FXscan{'scan'}{$id}{'unsecure'} || ($FXscan{'scan'}{$id}{'total'} == $FXscan{'scan'}{$id}{'completed'})) {
        if ($FXscan{'scan'}{$id}{'unsecure'}) {
          &putinfo("y", "Proxy/Wingate detected (%s:%d): %s (%s\@%s) [%s]", $FXscan{'scan'}{$id}{'proto'}, $FXscan{'scan'}{$id}{'port'}, $FXirc{'client'}{lc($nick)}{'nick'}, $FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $FXirc{'client'}{lc($nick)}{'server'});
          &kill_client($FXirc{'client'}{lc($nick)}{'nick'}, "Proxy/Wingate detected", undef, $FXbot{'ScanServ'}{'service'});
          &add_akill($FXirc{'client'}{lc($nick)}{'user'}, $FXirc{'client'}{lc($nick)}{'host'}, $FXbot{'ScanServ'}{'nick'}, $FXbot{'ScanServ'}{'scan_expire'}, "Proxy/Wingate detected");
          &chanlog("q", undef, $nick, "Proxy/Wingate detected", undef);
          &del_client($nick);
          ++$FXstats{'kills'}{'oper'};
        } else {
          &ss_notice($FXirc{'client'}{lc($nick)}{'nick'}, $FXmsg{'scan_clean'});
        }

        &scan_del($nick, "scan");
        delete($FXscan{'scan'}{$id});
        next;
      }

      foreach my $idx (keys(%{$FXscan{'scan'}{$id}{'list'}})) {
        foreach my $pid (keys(%FXstatus)) {
          if ($pid == $FXscan{'scan'}{$id}{'list'}{$idx}{'pid'}) {
            $FXscan{'scan'}{$id}{'list'}{$idx}{'pid'} = 0;
            ++$FXscan{'scan'}{$id}{'completed'};
            --$scan;

            if ($FXstatus{$pid}) {
              $FXscan{'scan'}{$id}{'unsecure'} = 1;
              $FXscan{'scan'}{$id}{'proto'} = $FXscan{'scan'}{$id}{'list'}{$idx}{'proto'};
              $FXscan{'scan'}{$id}{'port'} = $FXscan{'scan'}{$id}{'list'}{$idx}{'port'};
              &scan_del($nick, "scan");
              $unsecure = 1;
              last;
            }

            delete($FXstatus{$pid});
          }
        }

        if ($unsecure) { last; }

        if ($FXscan{'scan'}{$id}{'list'}{$idx}{'pid'} && ($ts - $FXscan{'scan'}{$id}{'list'}{$idx}{'start'} > $FXbot{'ScanServ'}{'scan_timeout'})) {
          my $pid = $FXscan{'scan'}{$id}{'list'}{$idx}{'pid'};
          if (!$FXstatus{$pid}) {
            #kill('SIGTERM', $pid);
            $FXscan{'scan'}{$id}{'list'}{$idx}{'pid'} = 0;
            ++$FXscan{'scan'}{$id}{'completed'};
            --$scan;
          }
        }

        if ($FXscan{'scan'}{$id}{'list'}{$idx}{'queued'} && ($scan < $FXbot{'ScanServ'}{'scan_max'})) {
          my $pid = &scan_add($nick, $FXscan{'scan'}{$id}{'list'}{$idx}{'proto'}, $FXscan{'scan'}{$id}{'list'}{$idx}{'port'});
          $FXscan{'scan'}{$id}{'list'}{$idx}{'pid'} = $pid;
          $FXscan{'scan'}{$id}{'list'}{$idx}{'queued'} = 0;
          $FXscan{'scan'}{$id}{'list'}{$idx}{'start'} = $ts;
        }
      }
    }

    foreach my $id (keys(%{$FXscan{'query'}})) {
      my $nick = $FXscan{'query'}{$id}{'nick'};
      my $unsecure = 0;

      if (!$FXirc{'client'}{lc($nick)}) {
        &scan_del($nick, "query");
        delete($FXscan{'query'}{$id});
        next;
      }

      if ($FXscan{'query'}{$id}{'unsecure'} || ($FXscan{'query'}{$id}{'total'} == $FXscan{'query'}{$id}{'completed'})) {
        my $target = $FXscan{'query'}{$id}{'host'};

        if ($FXscan{'query'}{$id}{'unsecure'}) {
          if ($FXirc{'client'}{lc($target)}) {
            &ss_notice($FXirc{'client'}{lc($nick)}{'nick'}, $FXmsg{'scan_unsecure'}, "$FXirc{'client'}{lc($target)}{'nick'} ($FXirc{'client'}{lc($target)}{'user'}\@$FXirc{'client'}{lc($target)}{'host'})", $FXscan{'query'}{$id}{'proto'}, $FXscan{'query'}{$id}{'port'});
          } else {
            &ss_notice($FXirc{'client'}{lc($nick)}{'nick'}, $FXmsg{'scan_unsecure'}, $target, $FXscan{'query'}{$id}{'proto'}, $FXscan{'query'}{$id}{'port'});
          }
        } else {
          if ($FXirc{'client'}{lc($target)}) {
            &ss_notice($FXirc{'client'}{lc($nick)}{'nick'}, $FXmsg{'scan_passed'}, "$FXirc{'client'}{lc($target)}{'nick'} ($FXirc{'client'}{lc($target)}{'user'}\@$FXirc{'client'}{lc($target)}{'host'})");
          } else {
            &ss_notice($FXirc{'client'}{lc($nick)}{'nick'}, $FXmsg{'scan_passed'}, $target);
          }
        }

        &scan_del($nick, "query");
        delete($FXscan{'query'}{$id});
        next;
      }

      foreach my $idx (keys(%{$FXscan{'query'}{$id}{'list'}})) {
        foreach my $pid (keys(%FXstatus)) {
          if ($pid == $FXscan{'query'}{$id}{'list'}{$idx}{'pid'}) {
            $FXscan{'query'}{$id}{'list'}{$idx}{'pid'} = 0;
            ++$FXscan{'query'}{$id}{'completed'};
            --$scan;

            if ($FXstatus{$pid}) {
              $FXscan{'query'}{$id}{'unsecure'} = 1;
              $FXscan{'query'}{$id}{'proto'} = $FXscan{'query'}{$id}{'list'}{$idx}{'proto'};
              $FXscan{'query'}{$id}{'port'} = $FXscan{'query'}{$id}{'list'}{$idx}{'port'};
              &scan_del($nick, "query");
              $unsecure = 1;
              last;
            }

            delete($FXstatus{$pid});
          }
        }

        if ($unsecure) { last; }

        if ($FXscan{'query'}{$id}{'list'}{$idx}{'pid'} && ($ts - $FXscan{'query'}{$id}{'list'}{$idx}{'start'} > $FXbot{'ScanServ'}{'scan_timeout'})) {
          my $pid = $FXscan{'query'}{$id}{'list'}{$idx}{'pid'};
          if (!$FXstatus{$pid}) {
            #kill('SIGTERM', $pid);
            $FXscan{'query'}{$id}{'list'}{$idx}{'pid'} = 0;
            ++$FXscan{'query'}{$id}{'completed'};
            --$scan;
          }
        }

        if ($FXscan{'query'}{$id}{'list'}{$idx}{'queued'} && ($scan < $FXbot{'ScanServ'}{'scan_max'})) {
          my $pid = &scan_add($nick, $FXscan{'query'}{$id}{'list'}{$idx}{'proto'}, $FXscan{'query'}{$id}{'list'}{$idx}{'port'});
          $FXscan{'query'}{$id}{'list'}{$idx}{'pid'} = $pid;
          $FXscan{'query'}{$id}{'list'}{$idx}{'queued'} = 0;
          $FXscan{'query'}{$id}{'list'}{$idx}{'start'} = $ts;
        }
      }
    }

  }

  return(0);
}

sub timer_check {
  if (!($ts % 86400)) {
    &putlog("y", "Rotating log file");
    my $suffix = &substitute($FXcfg{'files'}{'log_suffix'});
    rename($LogFile, $LogFile . $suffix);
  }

  if (!$FXsock{'irc'} && ($ts - $FXserv{'attempt'} > $FXcfg{'general'}{'reconnect'})) { &connect_irc(); }

  foreach (keys(%{$FXirc{'kill'}})) {
    if (($FXirc{'kill'}{$_}{'expire'} > 0) && ($FXirc{'kill'}{$_}{'set'} + $FXirc{'kill'}{$_}{'expire'} < $ts)) {
      &putinfo("y", "Expired auto-kill: %s (set by %s %s) [%s]", $FXirc{'kill'}{$_}{'mask'}, $FXirc{'kill'}{$_}{'author'}, &format_date($FXirc{'kill'}{$_}{'set'}), $FXirc{'kill'}{$_}{'reason'});

      if ($FXirc{'kill'}{$_}{'expire'}) {
        my ($user, $host) = split(/\@/, $FXirc{'kill'}{$_}{'mask'}, 2);
        &rem_akill($user, $host);
      }

      delete($FXirc{'kill'}{$_});
    }
  }

  foreach (keys(%{$FXsock{'list'}})) {
    if ($FXbot{'GameServ'}{'enabled'}) {
      if (($FXsock{'list'}{$_}{'type'} eq "RCON-A") && ($ts - $FXsock{'list'}{$_}{'time'} > $FXbot{'GameServ'}{'rcon_timeout'})) {
        $FXsock{'list'}{$_}{'type'} = "RCON-Z";
        &del_socket($FXsock{'list'}{$_}{'sock'});
        next;
      }
    }

    if ($FXbot{'FileServ'}{'enabled'}) {
      if (($FXsock{'list'}{$_}{'type'} eq "FSERV-A") && ($ts - $FXsock{'list'}{$_}{'time'} > $FXbot{'FileServ'}{'fserv_timeout'})) {
        $FXsock{'list'}{$_}{'type'} = "FSERV-Z";
        &del_socket($FXsock{'list'}{$_}{'sock'});
        next;

      } elsif (($FXsock{'list'}{$_}{'type'} eq "FSERV-G") && ($ts - $FXsock{'list'}{$_}{'time'} > $FXbot{'FileServ'}{'fserv_timeout'})) {
        $FXsock{'list'}{$_}{'type'} = "FSERV-Z";
        &del_socket($FXsock{'list'}{$_}{'sock'});
        next;

      } elsif ((($FXsock{'list'}{$_}{'type'} eq "FSERV-B") || ($FXsock{'list'}{$_}{'type'} eq "FSERV-C")) && ($ts - $FXsock{'list'}{$_}{'time'} > $FXbot{'FileServ'}{'fserv_timeout'})) {
        $FXsock{'list'}{$_}{'type'} = "FSERV-C";
        &del_socket($FXsock{'list'}{$_}{'sock'});
        next;

      } elsif ($FXsock{'list'}{$_}{'type'} eq "FSERV-X") {
        $FXsock{'list'}{$_}{'type'} = "FSERV-C";
        &fserv_send($FXsock{'list'}{$_}{'sock'}, $FXsock{'list'}{$_}{'seek'});
        next;

      } elsif (($FXsock{'list'}{$_}{'type'} eq "FSERV") && ($ts - $FXsock{'list'}{$_}{'lastcmd'} + $FXbot{'FileServ'}{'fserv_warn'} > $FXbot{'FileServ'}{'fserv_idle'})) {
        if (!$FXsock{'list'}{$_}{'warning'}) {
          $FXsock{'list'}{$_}{'warning'} = $ts;
          &putsock($FXsock{'list'}{$_}{'sock'}, $FXmsg{'fserv_warn'});
          next;
        } elsif ($ts - $FXsock{'list'}{$_}{'lastcmd'} > $FXbot{'FileServ'}{'fserv_idle'}) {
          &putsock($FXsock{'list'}{$_}{'sock'}, $FXmsg{'fserv_timeout'});
          &del_socket($FXsock{'list'}{$_}{'sock'});
          next;
        }
      }
    }

    if ($FXsock{'list'}{$_}{'type'} eq "BOT-B") {
      if ($ts - $FXsock{'list'}{$_}{'time'} > $FXcfg{'general'}{'timeout'}) { &del_socket($FXsock{'list'}{$_}{'sock'}); }
    } elsif (($FXsock{'list'}{$_}{'type'} eq "DCC-B") || ($FXsock{'list'}{$_}{'type'} eq "DCC-C") || ($FXsock{'list'}{$_}{'type'} eq "DCC-D")) {
      if ($ts - $FXsock{'list'}{$_}{'time'} > $FXcfg{'general'}{'timeout'}) { &del_socket($FXsock{'list'}{$_}{'sock'}); }
    }
  }

  if ($MySQL{'enabled'} && ($ts - $MySQL{'last_sync'} > $MySQL{'sync'})) { &save_mysql(); }

  if ($ts - $FXserv{'last_sync'} > $FXcfg{'general'}{'sync'}) { &save_conf(); }

  if ($FXbot{'PageServ'}{'enabled'}) {
    my $im_connect = {
      'msn'    => \&msn_connect,
      'yahoo'  => \&yahoo_connect,
      'icq'    => \&icq_connect,
      'aim'    => \&aim_connect,
      'jabber' => \&jabber_connect
    };

    my $im_remsession = {
      'msn'    => \&msn_remsession,
      'yahoo'  => \&yahoo_remsession,
      'icq'    => \&icq_remsession,
      'aim'    => \&aim_remsession,
      'jabber' => \&jabber_remsession
    };

    foreach my $im ("msn", "yahoo", "icq", "aim", "jabber") {
      if (!$FXbot{'PageServ'}{$im . "_id"}) { next; }

      if (!$FXsock{$im} && ($ts - $FXim{$im}{'attempt'} > $FXbot{'PageServ'}{'im_reconnect'})) { &{$im_connect->{$im}}($FXbot{'PageServ'}{$im . "_server"}, $FXbot{'PageServ'}{$im . "_port"}, 0); }
      if ($FXsock{$im} && ($ts - $FXim{$im}{'ping'} > 60)) {
        if ($im eq "msn") { &putsock($FXsock{$im}, "PNG"); }
        if ($im eq "jabber") { &putsock($FXsock{$im}, " "); }
      }

      if ($FXim{$im}{'board'}) {
        foreach my $session (keys(%{$FXim{$im}{'board'}})) {
          if ($ts - $FXim{$im}{'board'}{$session}{'last'} > 240) { &{$im_remsession->{$im}}($session, "*"); }
        }
      }
    }
  }

  if ($FXbot{'FileServ'}{'enabled'}) {
    foreach (keys(%{$FXfserv{'query'}})) {
      if ($ts - $FXfserv{'query'}{$_}{'time'} > $FXbot{'FileServ'}{'fserv_timeout'}) { delete($FXfserv{'query'}{$_}); }
    }

    foreach (keys(%{$FXfserv{'list'}})) {
      if (!$FXfserv{'list'}{$_}{'xfer'} && $FXfserv{'list'}{$_}{'queue'} && scalar(@{$FXfserv{'list'}{$_}{'queue'}})) { &xs_queued($FXfserv{'list'}{$_}{'ip'}); }
    }
  }

  foreach (keys(%FXbnet)) {
    if (!$FXbnet{$_}{'sock'} && ($ts - $FXbnet{$_}{'attempt'} > $FXcfg{'general'}{'reconnect'})) { &connect_bot($FXbnet{$_}{'nick'}); }
  }

  return(0);
}

1;